
(* This generated code requires the following version of MenhirLib: *)

let () =
  MenhirLib.StaticVersion.require_20231231

module MenhirBasics = struct
  
  exception Error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | WHILE
    | WHEN
    | UU_WRITE
    | UU_UNPREDICTABLE_UNLESS
    | UU_UNPREDICTABLE
    | UU_UNALLOCATED
    | UU_REGISTER
    | UU_READWRITE
    | UU_POSTDECODE
    | UU_OPERATOR_TWO
    | UU_OPERATOR_ONE
    | UU_OPCODE
    | UU_NOP
    | UU_NEWMAP
    | UU_NEWEVENT
    | UU_MAP
    | UU_INSTRUCTION_SET
    | UU_INSTRUCTION
    | UU_GUARD
    | UU_FUNCTION
    | UU_FIELD
    | UU_EXECUTE
    | UU_EXCEPTIONTAKEN
    | UU_EVENT
    | UU_ENCODING
    | UU_DECODE
    | UU_CONFIG
    | UU_CONDITIONAL
    | UU_BUILTIN
    | UU_ARRAY
    | UNTIL
    | UNPREDICTABLE
    | UNKNOWN
    | UNDEFINED
    | TYPEOF
    | TYPE
    | TRY
    | TO
    | THROW
    | THEN
    | STRING_LIT of (
# 82 "asllib/Parser0.mly"
       (string)
# 60 "asllib/Parser0.ml"
  )
    | STAR
    | SLASH
    | SEMICOLON
    | SEE
    | RPAREN
    | RETURN
    | REPEAT
    | REM
    | RECORD
    | REAL_LIT of (
# 86 "asllib/Parser0.mly"
       (Q.t)
# 74 "asllib/Parser0.ml"
  )
    | REAL
    | RBRACK
    | RBRACE_RBRACE
    | RBRACE
    | QUOT
    | QUALIFIER of (
# 88 "asllib/Parser0.mly"
       (string)
# 84 "asllib/Parser0.ml"
  )
    | PLUS_PLUS
    | PLUS_COLON
    | PLUS
    | OTHERWISE
    | OR
    | OF
    | NOT
    | MOD
    | MINUS
    | MASK_LIT of (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 98 "asllib/Parser0.ml"
  )
    | LT_LT
    | LT_EQ
    | LT
    | LPAREN
    | LIMIT
    | LET
    | LBRACK
    | LBRACE_LBRACE
    | LBRACE
    | IS
    | INT_LIT of (
# 85 "asllib/Parser0.mly"
       (Z.t)
# 113 "asllib/Parser0.ml"
  )
    | INTEGER
    | INDENT
    | IN
    | IMPLIES
    | IMPLEM_DEFINED
    | IFF
    | IF
    | IDENTIFIER of (
# 82 "asllib/Parser0.mly"
       (string)
# 125 "asllib/Parser0.ml"
  )
    | GT_GT
    | GT_EQ
    | GT
    | FOR
    | EQ_GT
    | EQ_EQ
    | EQ
    | EOR
    | EOL
    | EOF
    | ENUMERATION
    | ELSIF
    | ELSE
    | DOWNTO
    | DOT_DOT
    | DOT
    | DO
    | DIV
    | DEDENT
    | DEBUG
    | CONSTRAINED_UNPRED
    | CONSTANT
    | CONFIG
    | COMMA
    | COLON
    | CATCH
    | CASE
    | CARET
    | BOOL_LIT of (
# 87 "asllib/Parser0.mly"
       (bool)
# 158 "asllib/Parser0.ml"
  )
    | BOOLEAN
    | BITS_LIT of (
# 84 "asllib/Parser0.mly"
       (Bitvector.t)
# 164 "asllib/Parser0.ml"
  )
    | BITS
    | BIT
    | BAR_BAR
    | BANG_EQ
    | BANG
    | ASSERT
    | ARRAY
    | AND
    | AMP_AMP
    | AMP
  
end

include MenhirBasics

# 23 "asllib/Parser0.mly"
  

  module Prelude = struct
    open AST
    open ASTUtils

    let version = V0

    let build_expr_conds =
      let make_cond { desc = c, e_then; _ } e_else =
        E_Cond (c, e_then, e_else)
      in
      fun (elseifs, e) -> List.fold_right (map2_desc make_cond) elseifs e

    let build_stmt_conds (s_elsifs, s_else) =
      let s_else = match s_else with Some s -> s | None -> s_pass in
      let folder { desc = c, s_then; _ } s_else = S_Cond (c, s_then, s_else) in
      List.fold_right (map2_desc folder) s_elsifs s_else

    let t_bit =
      T_Bits (E_Literal (L_Int Z.one) |> add_dummy_annotation ~version, [])


    let make_ldi_vars (ty, xs) =
      let make_one x =
        S_Decl (LDK_Var, LDI_Var x, Some ty, None)
        |> add_dummy_annotation ~version
      in
      List.map make_one xs |> stmt_from_list |> desc

    let make_func name args return_type body =
      let subprogram_type =
        match return_type with | Some _ -> ST_Function | None -> ST_Procedure
      and parameters = []
      and recurse_limit = None
      in
      D_Func {
        name;
        args;
        return_type;
        body;
        parameters;
        subprogram_type;
        recurse_limit;
        builtin = false;
      }

    let make_concat es =
      match es with
      | [] -> E_Literal (L_BitVector Bitvector.empty)
      | [ bv ] -> bv |> desc
      | bv :: bvs -> List.fold_left (binop BV_CONCAT) bv bvs |> desc

  end

  open Prelude


# 240 "asllib/Parser0.ml"

module Tables = struct
  
  include MenhirBasics
  
  let token2terminal : token -> int =
    fun _tok ->
      match _tok with
      | AMP ->
          127
      | AMP_AMP ->
          126
      | AND ->
          125
      | ARRAY ->
          124
      | ASSERT ->
          123
      | BANG ->
          122
      | BANG_EQ ->
          121
      | BAR_BAR ->
          120
      | BIT ->
          119
      | BITS ->
          118
      | BITS_LIT _ ->
          117
      | BOOLEAN ->
          116
      | BOOL_LIT _ ->
          115
      | CARET ->
          114
      | CASE ->
          113
      | CATCH ->
          112
      | COLON ->
          111
      | COMMA ->
          110
      | CONFIG ->
          109
      | CONSTANT ->
          108
      | CONSTRAINED_UNPRED ->
          107
      | DEBUG ->
          106
      | DEDENT ->
          105
      | DIV ->
          104
      | DO ->
          103
      | DOT ->
          102
      | DOT_DOT ->
          101
      | DOWNTO ->
          100
      | ELSE ->
          99
      | ELSIF ->
          98
      | ENUMERATION ->
          97
      | EOF ->
          96
      | EOL ->
          95
      | EOR ->
          94
      | EQ ->
          93
      | EQ_EQ ->
          92
      | EQ_GT ->
          91
      | FOR ->
          90
      | GT ->
          89
      | GT_EQ ->
          88
      | GT_GT ->
          87
      | IDENTIFIER _ ->
          86
      | IF ->
          85
      | IFF ->
          84
      | IMPLEM_DEFINED ->
          83
      | IMPLIES ->
          82
      | IN ->
          81
      | INDENT ->
          80
      | INTEGER ->
          79
      | INT_LIT _ ->
          78
      | IS ->
          77
      | LBRACE ->
          76
      | LBRACE_LBRACE ->
          75
      | LBRACK ->
          74
      | LET ->
          73
      | LIMIT ->
          72
      | LPAREN ->
          71
      | LT ->
          70
      | LT_EQ ->
          69
      | LT_LT ->
          68
      | MASK_LIT _ ->
          67
      | MINUS ->
          66
      | MOD ->
          65
      | NOT ->
          64
      | OF ->
          63
      | OR ->
          62
      | OTHERWISE ->
          61
      | PLUS ->
          60
      | PLUS_COLON ->
          59
      | PLUS_PLUS ->
          58
      | QUALIFIER _ ->
          57
      | QUOT ->
          56
      | RBRACE ->
          55
      | RBRACE_RBRACE ->
          54
      | RBRACK ->
          53
      | REAL ->
          52
      | REAL_LIT _ ->
          51
      | RECORD ->
          50
      | REM ->
          49
      | REPEAT ->
          48
      | RETURN ->
          47
      | RPAREN ->
          46
      | SEE ->
          45
      | SEMICOLON ->
          44
      | SLASH ->
          43
      | STAR ->
          42
      | STRING_LIT _ ->
          41
      | THEN ->
          40
      | THROW ->
          39
      | TO ->
          38
      | TRY ->
          37
      | TYPE ->
          36
      | TYPEOF ->
          35
      | UNDEFINED ->
          34
      | UNKNOWN ->
          33
      | UNPREDICTABLE ->
          32
      | UNTIL ->
          31
      | UU_ARRAY ->
          30
      | UU_BUILTIN ->
          29
      | UU_CONDITIONAL ->
          28
      | UU_CONFIG ->
          27
      | UU_DECODE ->
          26
      | UU_ENCODING ->
          25
      | UU_EVENT ->
          24
      | UU_EXCEPTIONTAKEN ->
          23
      | UU_EXECUTE ->
          22
      | UU_FIELD ->
          21
      | UU_FUNCTION ->
          20
      | UU_GUARD ->
          19
      | UU_INSTRUCTION ->
          18
      | UU_INSTRUCTION_SET ->
          17
      | UU_MAP ->
          16
      | UU_NEWEVENT ->
          15
      | UU_NEWMAP ->
          14
      | UU_NOP ->
          13
      | UU_OPCODE ->
          12
      | UU_OPERATOR_ONE ->
          11
      | UU_OPERATOR_TWO ->
          10
      | UU_POSTDECODE ->
          9
      | UU_READWRITE ->
          8
      | UU_REGISTER ->
          7
      | UU_UNALLOCATED ->
          6
      | UU_UNPREDICTABLE ->
          5
      | UU_UNPREDICTABLE_UNLESS ->
          4
      | UU_WRITE ->
          3
      | WHEN ->
          2
      | WHILE ->
          1
  
  and error_terminal =
    0
  
  and token2value : token -> Obj.t =
    fun _tok ->
      match _tok with
      | AMP ->
          Obj.repr ()
      | AMP_AMP ->
          Obj.repr ()
      | AND ->
          Obj.repr ()
      | ARRAY ->
          Obj.repr ()
      | ASSERT ->
          Obj.repr ()
      | BANG ->
          Obj.repr ()
      | BANG_EQ ->
          Obj.repr ()
      | BAR_BAR ->
          Obj.repr ()
      | BIT ->
          Obj.repr ()
      | BITS ->
          Obj.repr ()
      | BITS_LIT _v ->
          Obj.repr _v
      | BOOLEAN ->
          Obj.repr ()
      | BOOL_LIT _v ->
          Obj.repr _v
      | CARET ->
          Obj.repr ()
      | CASE ->
          Obj.repr ()
      | CATCH ->
          Obj.repr ()
      | COLON ->
          Obj.repr ()
      | COMMA ->
          Obj.repr ()
      | CONFIG ->
          Obj.repr ()
      | CONSTANT ->
          Obj.repr ()
      | CONSTRAINED_UNPRED ->
          Obj.repr ()
      | DEBUG ->
          Obj.repr ()
      | DEDENT ->
          Obj.repr ()
      | DIV ->
          Obj.repr ()
      | DO ->
          Obj.repr ()
      | DOT ->
          Obj.repr ()
      | DOT_DOT ->
          Obj.repr ()
      | DOWNTO ->
          Obj.repr ()
      | ELSE ->
          Obj.repr ()
      | ELSIF ->
          Obj.repr ()
      | ENUMERATION ->
          Obj.repr ()
      | EOF ->
          Obj.repr ()
      | EOL ->
          Obj.repr ()
      | EOR ->
          Obj.repr ()
      | EQ ->
          Obj.repr ()
      | EQ_EQ ->
          Obj.repr ()
      | EQ_GT ->
          Obj.repr ()
      | FOR ->
          Obj.repr ()
      | GT ->
          Obj.repr ()
      | GT_EQ ->
          Obj.repr ()
      | GT_GT ->
          Obj.repr ()
      | IDENTIFIER _v ->
          Obj.repr _v
      | IF ->
          Obj.repr ()
      | IFF ->
          Obj.repr ()
      | IMPLEM_DEFINED ->
          Obj.repr ()
      | IMPLIES ->
          Obj.repr ()
      | IN ->
          Obj.repr ()
      | INDENT ->
          Obj.repr ()
      | INTEGER ->
          Obj.repr ()
      | INT_LIT _v ->
          Obj.repr _v
      | IS ->
          Obj.repr ()
      | LBRACE ->
          Obj.repr ()
      | LBRACE_LBRACE ->
          Obj.repr ()
      | LBRACK ->
          Obj.repr ()
      | LET ->
          Obj.repr ()
      | LIMIT ->
          Obj.repr ()
      | LPAREN ->
          Obj.repr ()
      | LT ->
          Obj.repr ()
      | LT_EQ ->
          Obj.repr ()
      | LT_LT ->
          Obj.repr ()
      | MASK_LIT _v ->
          Obj.repr _v
      | MINUS ->
          Obj.repr ()
      | MOD ->
          Obj.repr ()
      | NOT ->
          Obj.repr ()
      | OF ->
          Obj.repr ()
      | OR ->
          Obj.repr ()
      | OTHERWISE ->
          Obj.repr ()
      | PLUS ->
          Obj.repr ()
      | PLUS_COLON ->
          Obj.repr ()
      | PLUS_PLUS ->
          Obj.repr ()
      | QUALIFIER _v ->
          Obj.repr _v
      | QUOT ->
          Obj.repr ()
      | RBRACE ->
          Obj.repr ()
      | RBRACE_RBRACE ->
          Obj.repr ()
      | RBRACK ->
          Obj.repr ()
      | REAL ->
          Obj.repr ()
      | REAL_LIT _v ->
          Obj.repr _v
      | RECORD ->
          Obj.repr ()
      | REM ->
          Obj.repr ()
      | REPEAT ->
          Obj.repr ()
      | RETURN ->
          Obj.repr ()
      | RPAREN ->
          Obj.repr ()
      | SEE ->
          Obj.repr ()
      | SEMICOLON ->
          Obj.repr ()
      | SLASH ->
          Obj.repr ()
      | STAR ->
          Obj.repr ()
      | STRING_LIT _v ->
          Obj.repr _v
      | THEN ->
          Obj.repr ()
      | THROW ->
          Obj.repr ()
      | TO ->
          Obj.repr ()
      | TRY ->
          Obj.repr ()
      | TYPE ->
          Obj.repr ()
      | TYPEOF ->
          Obj.repr ()
      | UNDEFINED ->
          Obj.repr ()
      | UNKNOWN ->
          Obj.repr ()
      | UNPREDICTABLE ->
          Obj.repr ()
      | UNTIL ->
          Obj.repr ()
      | UU_ARRAY ->
          Obj.repr ()
      | UU_BUILTIN ->
          Obj.repr ()
      | UU_CONDITIONAL ->
          Obj.repr ()
      | UU_CONFIG ->
          Obj.repr ()
      | UU_DECODE ->
          Obj.repr ()
      | UU_ENCODING ->
          Obj.repr ()
      | UU_EVENT ->
          Obj.repr ()
      | UU_EXCEPTIONTAKEN ->
          Obj.repr ()
      | UU_EXECUTE ->
          Obj.repr ()
      | UU_FIELD ->
          Obj.repr ()
      | UU_FUNCTION ->
          Obj.repr ()
      | UU_GUARD ->
          Obj.repr ()
      | UU_INSTRUCTION ->
          Obj.repr ()
      | UU_INSTRUCTION_SET ->
          Obj.repr ()
      | UU_MAP ->
          Obj.repr ()
      | UU_NEWEVENT ->
          Obj.repr ()
      | UU_NEWMAP ->
          Obj.repr ()
      | UU_NOP ->
          Obj.repr ()
      | UU_OPCODE ->
          Obj.repr ()
      | UU_OPERATOR_ONE ->
          Obj.repr ()
      | UU_OPERATOR_TWO ->
          Obj.repr ()
      | UU_POSTDECODE ->
          Obj.repr ()
      | UU_READWRITE ->
          Obj.repr ()
      | UU_REGISTER ->
          Obj.repr ()
      | UU_UNALLOCATED ->
          Obj.repr ()
      | UU_UNPREDICTABLE ->
          Obj.repr ()
      | UU_UNPREDICTABLE_UNLESS ->
          Obj.repr ()
      | UU_WRITE ->
          Obj.repr ()
      | WHEN ->
          Obj.repr ()
      | WHILE ->
          Obj.repr ()
  
  and default_reduction =
    (16, "\000\000\000\000\000u\000\001\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\016\000\006\000\000\000C\000\000\000Q\000\000\000\000\000\000\000F\000\000\000\012\000\000\000\000\000\000\000\000\000=\000\005\000\000\000B\000\000\000O\000\000\000\000\000E\000\000\000\014\000\004\000\000\000D\000\000\000S\000\007\000\000\000\000\000\000\000G\000\000\000Y\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0009\000\000\000\000\002\133\000\000\000:\0008\000\000\000\000\000\000\002\245\000\000\003\n\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\127\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000A\000\000\000\000\000\000\000\000\002}\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002|\002~\000\000\000\000\000?\002\181\000\000\000\000\002\189\000\000\002\190\000\000\000\000\002\129\000\000\000\000\000\000\002\199\000\000\002\200\000\000\000\000\000\000\002\201\000\000\002\202\002\179\000\000\002\238\000\000\002\252\000;\000\000\000\000\000\000\002\241\000\000\002\185\000\000\002\186\000\000\000\000\000\000\002\191\000\000\002\192\000\000\000\000\000\000\002\193\000\000\002\194\000\000\003\002\000\000\000\000\000\000\000\000\002\176\000\000\000\000\002\225\000\000\002\232\000\000\002\233\002\178\000\000\002\237\000\000\002\250\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\015\000\000\000\000\000\000\000\000\002\240\000\000\002\187\000\000\002\188\000\000\000\000\000\000\002\195\000\000\002\196\000\000\000\000\000\000\002\197\000\000\002\198\000\000\003\000\002\177\000\000\002\239\000\000\002\254\002\180\000\000\000\000\000\000\000\000\002\243\000\000\000\000\002\242\000\000\003\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\003\019\000\000\000\000\003\022\000\000\003\018\003\021\003\020\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\230\000\000\002\231\000\000\000\000\002\228\000\000\002\229\002\227\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\234\000\000\000\000\000\000\000\000\000\000\002\235\000\000\000\000\002\236\000\000\000\000\002\173\000\000\000\000\000\000\000\000\000\000\002\171\000\000\000\000\000\000\002\172\000\000\000\000\000\000\002p\001K\000\000\003\025\003\023\000\000\000\000\000\000\000\000\000\000\000\000\000\000\003\028\000\000\000\000\000\000\000\018\000\000\000\019\000\000\000\000\000\000\000\020\000\000\000\021\000\000\000W\000\000\000\000\000\000\003\027\000\000\000\000\000\000\000\022\000\000\000\023\000\000\000\000\000\000\000\024\000\000\000\025\000\000\000U\000\000\000\000\000\000\000\000\000\000\003\029\000\000\000\000\000\000\000\000\002\175\000\000\003\030\000\000\002\247\000\000\003\014\000\000\000\000\000\000\000\000\002\246\000\000\003\012\000\000\000\000\000\000\000\000\000\000\000\000\002\248\000\000\003\016\000\000\000\000\000\000\002\244\000\000\003\b\000\000\003\006\000\000\000\000\000\000\000<\003\026\000\000\000L\000\000\000c\000\000\000\000\000\000\000\000\000K\000\000\000a\000\000\000\000\000\000\000\000\000\000\000\000\000M\000\000\000e\000\000\000\000\000\000\000H\000\000\000\000\000\000\000I\000\000\000]\000\000\000[\000\000\000\015\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000>\000\000\000\003\000\000\000\000\0006\000\000\000\000\000\r\000\000\000\017\000\000\000\000\000\000\000\026\000\000\000\027\000\000\000\000\000\000\000\028\000\000\000\029\000\000\000\000\000J\000\000\000_\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000g\000\000\000j\000\000\000\000\000h\000\000\000i\000\000\000s\000\000\000\000\000m\000\000\000n\000\000\000k\000\000\000l\000\000\000\000\000q\000\000\000r\000p\000\000\002\141\000\000\000o\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\197\000\000\000\000\000\000\000\000\001\175\000\000\000\000\000\000\000\000\001\196\000\000\000\000\001\238\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\195\000\000\000\000\000\000\000\000\001\194\000\000\000\000\001\237\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\199\000\000\000\000\000\000\000\000\001\198\000\000\000\000\001\239\001\254\001\187\000\000\000\000\000\000\000\000\001\186\000\000\000\000\001\233\001\189\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\191\000\000\000\000\000\000\000\000\001\190\000\000\000\000\001\235\000\000\000\000\000\000\000\000\001\188\000\000\000\000\001\234\001\181\000\000\000\000\000\000\000\000\001\180\000\000\000\000\001\230\001\217\000\000\000\000\000\000\000\000\001\216\000\000\000\000\000\000\000\000\000\000\001\203\000\000\000\000\000\000\000\000\001\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\209\000\000\000\000\000\000\000\000\001\208\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\137\002\139\002\138\000\000\000\000\000\000\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\227\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\225\000\000\000\000\000\000\000\000\000\000\001\201\000\000\000\000\000\000\000\000\001\200\000\000\000\000\000\000\000\000\000\000\001\207\000\000\000\000\000\000\000\000\001\206\000\000\000\000\000\000\001\224\000\000\000\000\000\000\000\000\000\000\001\205\000\000\000\000\000\000\000\000\001\204\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\213\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\215\000\000\000\000\000\000\000\000\001\214\000\000\000\000\000\000\000\000\001\212\000\000\000\000\000\000\000\000\000\000\001\211\000\000\000\000\000\000\000\000\001\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\221\000\000\000\000\000\000\000\000\001\220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\219\000\000\000\000\000\000\000\000\001\218\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\223\000\000\000\000\000\000\000\000\001\222\002\002\001\255\001\183\000\000\000\000\000\000\001\242\000\000\000\000\000\000\001\243\000\000\000\000\000\000\000\000\000\000\000\000\001\248\000\000\000\000\000\000\001\249\000\000\000\000\000\000\000\000\001\182\000\000\000\000\001\231\002\007\000\000\002\006\000\000\000\000\000\000\000\000\002\003\001\177\000\000\000\000\000\000\000\000\001\176\000\000\000\000\001\228\001\185\000\000\000\000\000\000\001\240\000\000\000\000\000\000\001\241\000\000\000\000\000\000\000\000\000\000\000\000\001\246\000\000\000\000\000\000\001\247\000\000\000\000\000\000\000\000\001\184\000\000\000\000\001\232\001\179\000\000\000\000\000\000\000\000\001\178\000\000\000\000\001\229\001\244\000\000\000\000\000\000\001\245\000\000\000\000\000\000\000\000\000\000\000\000\001\250\000\000\000\000\000\000\001\251\001\252\000\000\000\000\001\253\002\t\000\000\000\000\000\000\000\000\002\b\000\000\000\000\002\n\002\011\001\193\000\000\000\000\000\000\000\000\001\192\000\000\000\000\001\236\002\004\000\000\000\000\000\000\002\005\002\000\000\000\000\000\000\000\002\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\159\002\156\002\162\002\157\002\153\002\154\002\155\002\161\002\158\002\163\002\160\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\023\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002=\000\000\000\000\000\000\002>\000\000\002?\000\144\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\000\000\000\000\000\000\142\000\000\000\143\000\134\000\000\000\000\000\000\000\135\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\000\000\000\000\000\000\137\000\000\000\000\000\000\000\000\000|\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000}\000\000\000\000\000\000\000~\000\000\000\127\000\000\000\000\000\000\000\000\000w\000{\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\138\000\000\000\000\000\000\000\139\000\000\000\000\000\000\000\000\000\129\000\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\130\000\000\000\000\000\000\000\131\000\000\000\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000x\000\000\000\000\000\000\000y\000\000\000z\000\000\000\000\002_\000\000\000\000\002a\000\000\000\000\000\000\000\000\002`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002c\000\000\000\000\000\000\000\000\002b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\017\001\021\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\018\000\000\000\000\000\000\001\019\000\000\001\020\000\000\000\000\000\000\000\000\000\000\000\000\002A\002E\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\000\000\002C\000\000\002D\002@\000\000\000\000\000\000\000\000\000\000\000\000\002Y\002]\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002Z\000\000\000\000\000\000\002[\000\000\002\\\002X\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002G\002K\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002H\000\000\000\000\000\000\002I\000\000\002J\002F\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002M\002Q\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002N\000\000\000\000\000\000\002O\000\000\002P\002L\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002S\002W\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002T\000\000\000\000\000\000\002U\000\000\002V\002R\000\000\000\000\000\000\000\000\002^\000\000\000\000\000\000\000\000\000\000\000\000\002f\000\000\000\000\000\000\000\000\002g\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001N\001O\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002i\000\000\002m\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002j\000\000\000\000\000\000\000\000\002k\000\000\000\000\002l\000\000\002h\000\000\000\000\002e\000\000\000\000\000\000\000\000\000\000\002d\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\025\000\000\000\000\000\000\001\026\000\000\001\027\001;\001=\000\000\000\000\000\000\000\000\001<\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001?\000\000\000\000\000\000\000\000\001>\000\000\000\000\000\000\000\000\000\000\001\029\001!\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\000\000\000\000\001\031\000\000\001 \001\028\000\000\000\000\000\000\000\000\000\000\000\000\0015\0019\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\000\000\000\000\0017\000\000\0018\0014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001#\001'\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001$\000\000\000\000\000\000\001%\000\000\001&\001\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001)\001-\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001*\000\000\000\000\000\000\001+\000\000\001,\001(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001/\0013\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\0011\000\000\0012\001.\000\000\000\000\000\000\000\000\001:\001B\000\000\000\000\000\000\000\000\001C\001E\000\000\001I\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001F\000\000\000\000\000\000\000\000\001G\000\000\000\000\001H\000\000\001D\001A\000\000\000\000\000\000\000\000\000\000\001@\000\000\002w\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001Q\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002v\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\157\000\000\000\000\000\000\000\000\000\185\000\000\000\000\000\000\000\000\000\168\000\184\000\000\000\000\000\000\002\131\000\000\000\000\000\000\000\000\000\187\000\000\000\000\000\000\000\000\000\169\000\186\000\000\000\000\000\000\000\000\000\230\000\000\000\000\000\000\000\000\000\219\000\229\000\000\000\000\000\000\000\000\000\232\000\000\000\000\000\000\000\000\000\220\000\231\000\000\000\000\000\000\000\000\000\154\000\000\000\000\000\000\000\214\000\000\000\000\000\000\000\000\000\000\000\213\000\208\000\000\000\000\000\000\000\000\000\000\000\155\000\000\000\000\000\000\000\000\000\177\000\000\000\000\000\000\000\000\000\164\000\176\000\000\000\000\000\000\000\000\000\179\000\000\000\000\000\000\000\000\000\165\000\178\000\000\000\000\000\000\000\000\000\222\000\000\000\000\000\000\000\000\000\215\000\221\000\000\000\000\000\000\000\000\000\224\000\000\000\000\000\000\000\000\000\216\000\223\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\210\000\000\000\000\000\000\000\000\000\000\000\209\000\206\000\000\000\000\000\000\000\156\000\000\000\000\000\000\000\000\000\181\000\000\000\000\000\000\000\000\000\166\000\180\000\000\000\000\000\000\000\000\000\183\000\000\000\000\000\000\000\000\000\167\000\182\000\000\000\000\000\000\000\000\000\226\000\000\000\000\000\000\000\000\000\217\000\225\000\000\000\000\000\000\000\000\000\228\000\000\000\000\000\000\000\000\000\218\000\227\000\000\000\000\000\000\000\000\000\153\000\000\000\000\000\000\000\212\000\000\000\000\000\000\000\000\000\000\000\211\000\207\000\162\000\000\000\000\000\000\000\000\000\000\000\163\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\158\000\000\000\000\000\000\000\000\000\000\000\159\000\000\000\000\000\000\000\000\000\000\000\000\000\160\000\000\000\000\000\000\000\000\000\000\000\161\000\151\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\149\000\000\000\000\000\000\000\000\000\000\000\150\000\148\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\146\000\000\000\000\000\000\000\000\000\000\000\147\001\t\000\000\000\000\000\000\000\000\000\000\000\000\001\b\000\199\000\000\000\000\000\000\000\000\000\190\000\198\000\000\000\000\000\000\000\000\000\201\000\000\000\000\000\000\000\000\000\191\000\200\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\251\000\000\000\000\000\000\000\000\000\238\000\250\000\000\000\000\000\000\002\166\000\000\000\000\000\000\002\167\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\253\000\000\000\000\000\000\000\000\000\239\000\252\000\000\000\000\000\000\000\000\000\000\000\249\000\000\000\000\000\000\000\000\000\234\000\248\000\174\000\000\000\000\000\000\000\000\000\000\000\000\000\175\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\170\000\000\000\000\000\000\000\000\000\000\000\000\000\171\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\172\000\000\000\000\000\000\000\000\000\000\000\000\000\173\000\195\000\000\000\000\000\000\000\000\000\188\000\194\000\000\000\000\000\000\000\000\000\197\000\000\000\000\000\000\000\000\000\189\000\196\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\245\000\000\000\000\000\000\000\000\000\236\000\244\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\247\000\000\000\000\000\000\000\000\000\237\000\246\000\000\000\000\000\000\000\000\000\000\000\243\000\000\000\000\000\000\000\000\000\233\000\242\001\007\000\000\000\000\000\000\000\000\000\203\000\000\000\000\000\000\000\000\000\192\000\202\000\000\000\000\000\000\000\000\000\205\000\000\000\000\000\000\000\000\000\193\000\204\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\001\000\000\000\000\000\000\000\000\000\240\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\003\000\000\000\000\000\000\000\000\000\241\001\002\000\000\000\000\000\000\000\000\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\255\000\000\000\000\000\000\000\000\000\235\000\254\001\011\000\000\000\000\000\000\000\000\000\000\002s\000\000\000\000\000\000\001\r\000\000\000\000\000\000\000\000\001\005\000\000\000\000\000\000\001\n\000\000\000\000\000\000\000\000\000\000\001\012\000\000\000\000\000\000\000\000\001\004\000\000\003\017")
  
  and error =
    (128, "@\000\000\000\181\005\168@!!\022!\1288K\024@\000\000\000\189\005\168@!!\022!\192<K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027o\168c\219?\131 \198\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000B\186\005\027o\168s\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000B\186\005\027o\168s\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no(q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000 \002\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\004\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027h\160#\027?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027h\160#\027?\131 \198\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\016@9@\161#\006\000\000\002\031(\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\002\000\000\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\001\nn a\202\006\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027h\160#\027?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027h\160#\027?\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\001\nn a\202\002\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026m(c\202\002\131 \198\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0002\005\nn a\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\026m(s\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\2022\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\2022\129 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026n c\202\002\131 \198\000\000\000\000@0\004\026m(s\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000@\000\000\000\000\b\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no(q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000@\n @\000\b\018\000\000\002\000\001\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \002\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nl c\202\002\130 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026h #J\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026h #J\002\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nl c\202\002\130 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\002\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no(q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no(q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\002\000\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no(q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no(q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000@\000\000\000\000\b\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\2022\129 \198\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0002\000\nn a\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn\160a\202\003\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\202\003\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\202\003\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\202\003\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\b\000\000\001\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\b\000\000\001\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000@\000\000\001\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\016H8@\161#\006\000\000\000\031(\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\003(\000\004\002\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000 \000\003(\002\004\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 @! \002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 @! \002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\004\000\002 \000\000\002\002\000\000\000\000\000\000\016@8@\161#\006@\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \002\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 @! \002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000H\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000 \000\003(\002\004\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000 \000\000\b\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no(q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002 \000\004\002\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no(q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000 \000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000 \000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000 \000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000 \000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000 \000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000 \000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000 \000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000 \000\000\b\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no(q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no(q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 0xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0020\000\nn a\202\n\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\203\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\011n a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\017\0008\011\028\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\177\005(@!!\018\001\0008\011\024 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\001\0008\011\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\218\002\129 \198\000\000\000\000\177\005(@!!\022\001\0008\011\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\203\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 0xK\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \176xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \176xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \176xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \176xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \176xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\0010\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 0xK\024@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 0xK\024@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 0xK\024@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn\160a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\177\005(@!!\018\001\0008\011\024\000\000\000\000\000\000\000\000\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\177\005(@!!\018\001\0008\011\024\000\000\000\000\000\000\000\000\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn\160a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1768K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1768K\024@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0020\000\nn a\202\n\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\203\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\011n a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\203\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\0010\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1768K\024@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1768K\024@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1768K\024@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\002\001\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000@\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\004\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000@\001 \002\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\t@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000 @\001 \002\004\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000 @\001 \002\004\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000@\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\001\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\016\000\b@\001!\002\000\000\000\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\006\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\001 \000\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\002\004\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\b(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\001 \000\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\b(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\001 \000\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\b(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\006\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\006\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\001\000\000\000\000\000\000\004\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\002\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\004\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")
  
  and start =
    2
  
  and action =
    ((16, "\028L\028L\000\000\000\000*\146\199X\000\141\199X\000\000\001\"\199\202\000\000\000\000\001\214\000\000\001\212\000\000\000%\000\003\000C\000\000\200<\000\000\199X\199X\199X\200<\000\000\000\000\002\002\000\000\002\134\000\000\199X\000p\000\000\200\174\000\000\000\000\002r\000\000\0038\000\000\000\000\000H\199X\002\202\000\000\003\234\000\000\199X\000\212\213d\000\186\000\222\031\020\001*\025v\001t\199XM\194\199X\n,\201 \001\224\199XR\244\199X\n\222\000}\000E\000\000\000<\000E\000\000\002\016\000\000\000\000\199X\011\144\0030\000\000J\226\000\000\199X\012B\199X\012\244\199X\r\166\199X\014X\199X\015\n\199X\015\188\199X\016n\199X\025x\199X\017 \199X\017\210\199X\026*\002h\201\190\199X\201\190\000f\201\190\000\000R\244\199X\018\132\199X\026\220\199X\027\142\199X\000\000\0196\202\\\000\000\019\232\199Xe\028\201\190\000\000\199X\020\154\199X\021L\199X\021\254\201\190\000\000\000\000\022\176\002\194\000\000\000\000.\000\202\\\000\000\003\002\000\000Kz\199X\000\000\199\202\003\004\202\206\000\000\003\208\000\000\004\024\004h\203@\000\000\004\164\000\000\000\000\0032\000\000L\014\000\000\000\000\004D\004v\029\252\000\000\203\178\000\000\005\142\000\000\200<\005^\204$\000\000\005\166\000\000\0060\006\026\204\150\000\000\006X\000\000L\162\000\000\201 \201 \199Xe\168\000\000\199X\006f\000\000\200\174\000\000\006j\000\000\000\000\003h\000\000M6\000\000\199XKz\199XKz\199XR\244\199XKz\000\000\006\018\199XM\194\030\136\000\000\205\b\000\000\006\132\000\000\200\174\006\134\205z\000\000\006\186\000\000\006\170\006\188\205\236\000\000\007\024\000\000NV\000\000\000\000\003j\000\000N\234\000\000\000\000\006\248\199Xe\028\000\028\000\000\201 \003|\000\000O~\000\000\201 \006\246\213\214\006\212\006\252\031D\007D\025v\000\000\006\248\007\026\000\000\025v\000\000\000\000\000\000\007:\199X\154<\030b\201 S\128\201 T\012\206^\000\000\007`\000\000\001\142\0004\000\000\007b\000\000\000\000\201 T\152\201 U$\201 \155Z\201 U\176\201 V<\201 V\200\201 WT\201 W\224\201 Xl\201 X\248\201 \197N\201 Y\132\201 Z\016\0078\201\190\007f\000\000\201 Z\156\201 \197\218\206\252\000\000[(\207\154\000\000[\180\201 \000\000\201 \\@\201 \\\204\201 \000\000\201 \155\228\201 \000\000\007*\001\142\206^\000\000\000\000\007j\000\000\000\000\007J\214H\007\024\007>\031p\007x\025v\000\000\202\\\007n\208\012\000\000\007\162\000\000\007\150\007|\208~\000\000\007\178\000\000\004\156\000\000 \004\007\154\025v\000\000\202\206\007\144\208\240\000\000\007\200\000\000\007\184\007\168\209b\000\000\007\220\000\000\005N\000\000Kz\199X\156n\007\188\025v\000\000\007`\025v\000|\025v\000\000\007\226\000\000\003\146\000\000P\018\000\000 0\007\198\025v\003\158\000\000P\166\000\000M\194\199X\156\250\007\200\025v\003\182\000\000Q:\000\000]X\007\220\003\184\000\000Q\206\000\000Rb\000\000]\228^p\007\226\000\000\000\000\003\202\000\000\006\000\000\000 `\007\208\025v\003\214\000\000\006\178\000\000e\028\199X\157\134\007\210\025v\003\220\000\000\007d\000\000\023b\154\206\000j\000\000\201 \007\228\003\222\000\000\b\022\000\000\b\200\000\000\007\252\000\000e\028\199XKz\007\148\199X\024\020\007\242\000\000f4\000\000\199X\b\b\000\000\024\198\b\020\000\000\b\024\000\000\203@\007\232\209\212\000\000\b\028\000\000\b\012\007\238\210F\000\000\b\"\000\000\156n\003\226\000\000\tz\000\000Kz\199XR\244\007\196\007\230#N\199XM\194\199Xe\028\007\202\007\234#N\000\216f\218\003Dgf\b\002\199X\156\250\002p\007\220\199XR\244g\242\007\240\bLh~\000\184\bPi\n\199Xi\150\000\137\210\184\bTj\"\003\166\007\244\199Xe\028j\174\007\228\b\006\001\168\007\250\199X\156nk:\000\000\0262\000\000\007\234\b\016\000\000\0262\000\000\bT\000\000\000=\201 \000\000\b\014\000\000\206\252\000\000\b`\000\000\001\154\003\222\000\000\bf\000\000\000\000\0262\000\000\bz\000\000\003\174\b\030\199X\158\024k\198\000@\b\144lR\002Z\b0\199X\158\170l\222\199X\159<mj\b\148m\246)B\b`\199X\157\134\003\204\b6\199X\159\206n\130\003\230\b<\199X\160`o\014\bj\199X\158\024\0010\bB\199X\160\242o\154\003\232\bD\199X\161\132p&\199X\162\022p\178\bl\214\186\b6\bX \236\b\140\025v\003\242\bR\199X\162\168q>\000\000\000*\199X\163:q\202\000\000\001\006\199X\163\204rV\000\000\b\182r\226\000\000!x\b\152\025v\004\000\bh\199X\164^sn\000\000\001>\199X\164\240s\250\000\000\b\206t\134\000\000\154\206\199X\165|\b\170\025v\004,\bp\199X\166\014u\018\000\000\001~\199X\166\160u\158\000\000\b\212v*\000\000\000\000\000\000\001\172\199X\1672v\182\000\000\b\214wB\000\000\000\000\201 \b\194\004X\bz\199X\167\196w\206\000\000\001\178\199X\168VxZ\000\000\b\224x\230\000\000\001\218\199X\168\232yr\000\000\b\226y\254\000\000\000\000\001\240\199X\169zz\138\000\000\b\228{\022\000\000\000\000\b\136\199X\170\012{\162\000\000\004\\\b\142\199X\170\158|.\000\000\b\148\199X\1710|\186\000\000\b\138\b\174\004`\b\164\199X\171\194}F\000\000\b\166\199X\172T}\210\000\000\000G\b\134\001\030\002\144\001\030\002\194\001\030\003\244\001\030\000\000\000\000\000\000\t\b\b\172\199X\172\230~^\000\000\b\140\001\030\t\018\b\182\199X\173x~\234\000\000\b\150\001\030\t \b\200\199X\174\n\127v\000\000\004p\b\206\199X\174\156\128\002\000\000\b\208\199X\175.\128\142\000\000\002\128\b\224\199X\175\192\129\026\000\000\b\226\199X\176R\129\166\000\000\199X\176\228\1302\000\000\004~\b\228\199X\177v\130\190\000\000\b\230\199X\178\b\131J\000\000\t\020\199X\158\170\002\014\b\238\199X\178\154\131\214\000\000\201 \t<\004\134\b\244\199X\179,\132b\000\000\b\246\199X\179\190\132\238\000\000\b\248\199X\180P\133z\000\000\004\150\b\250\199X\180\226\134\006\000\000\b\252\199X\181t\134\146\000\000\t(\215,\b\242\t\020\"\004\tJ\025v\004\152\t\026\199X\182\006\135\030\000\000\t\030\199X\182\152\135\170\000\000\"\144\t\\\025v\004\154\t\"\199X\183*\1366\000\000\t$\199X\183\188\136\194\000\000\156n\199X\184H\tb\025v\004\170\t(\199X\184\218\137N\000\000\t,\199X\185l\137\218\000\000\000\000\000\000\000\000\211*\t\146\138f\000\000\t\144\t\150\138\242\000\000\199X\t\134\tl\211\156\t\168\139~\000\000\t\172\t\180\140\n\000\000\002j\199X\185\254\140\150\000\000\t\184\141\"\000\000\000\000\141\174\000\000\tf\t\184\t\190\142:\000\000\000\000\002\160\199X\186\144\142\198\000\000\t\192\143R\000\000\000\000\212\014\t\194\143\222\000\000\t\196\t\202\144j\000\000\199X\t\182\t\160\212\128\t\220\144\246\000\000\t\222\t\228\145\130\000\000\002\162\199X\187\"\146\014\000\000\t\244\146\154\000\000\000\000\003\016\199X\187\180\147&\000\000\t\246\147\178\000\000\000\000\t\244\t\250\148>\000\000\199X\t\230\t\204\212\242\n\004\148\202\000\000\n\004\n\n\149V\000\000\000\000\188F\149\226\000\000\000\000\199X\159<\n\012\150n\000\000\n\014\150\250\000\000\000\000\000\000\003\022\199X\188\216\151\134\000\000\n\016\152\018\000\000\000\000\n\018\n\024\152\158\000\000\000\000\n\022\n\"\153*\000\000\t\192\t\230#N\t\204\t\236#N\199X\154\206#N\029\014#N\t\226\t\214\199XM\194\199XR\244\199XKz\t\242#N\199XKz\t\214\t\248\001D\221\198_\022\221\198_\162\221\198`.\221\198\t\208\t\242`\186\221\198aF\221\198a\210\221\198\201\190\n2b^\221\198b\234\221\198cv\221\198d\002\221\198d\142\221\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\153\182\199X\156n#N\000\012\199X\156\250#N\000\012\000\000\004\004\001D$\b\001D#N\t\212\001D\000\000\003\b\199X\157\134#N\000\012\004\024.\190\000\000#N\t\238/x\000\00002\000\000\000\000\003p\199X\158\024#N\000\012\004p\001D\000\000#N\t\244\001D\000\000\001D\000\000\000\000#N\t\252\001D\000\000\198J\199X\158\170#N\000\012\004v\001D\000\000#N\n\000\001D\000\000\001\246#N\t\240\001D\000\000\000\000\004\000\199X\159<#N\000\012\004\176\001D\000\000#N\n\006\001D\000\000\001D\000\000\002\168#N\t\244\001D\000\000\000\000\199XKz\198\204\199X\159\206#N\000\012\004\182\001D\000\000#N\n\n\001D\000\000\002\198#N\t\248\001D\000\000\000\000\004\"\199X\160`#N\000\012\004\192\001D\000\000#N\n\014\001D\000\000\001D\000\000\004X\199X\160\242#N\000\012\004\196\001D\000\000#N\n\020\001D\000\000\001D\000\000\n\0020\236\000\000\n\0041\166\000\000\n@#N\n\0202`\000\000\199Xe\028\199XM\194\nL#N\n\0283\026\000\000\n^#N\n.3\212\000\000\n0\029\006\199X\161\132$\194\029\006#N\n2\029\006\000\000\000\000\004\178\199X\162\022#N\000\012\004\202\029\006\000\000#N\nH\029\006\000\000\029\006\000\000#N%|$\b#N\n:4\142\000\000\000\000\004\180\199X\162\168#N\000\012\004\2145H\000\000#N\nP6\002\000\0006\188\000\000\000\000$\194&6%|#N\n@7v\000\000\000\000\005\002\199X\163:#N\000\012\004\23480\000\000#N\nV8\234\000\0009\164\000\000\000\000\000\163\199X\163\204#N\000\012\004\240\029\006&6&\240&\240#N\nD:^\000\000\000\000\005\n\199X\164^#N\000\012\004\244;\024\000\000#N\nZ;\210\000\000<\140\000\000\000\000#N\n\\\029\006'\170'\170(d#N\nN=F\000\000\000\000\005*\199X\164\240#N\000\012\005\030>\000\000\000#N\nd>\186\000\000?t\000\000\000\000\029\006)\030(d)\216#N\nR@.\000\000\000\000\0056\199X\165|#N\000\012\005(@\232\000\000#N\nnA\162\000\000B\\\000\000\000\000\nj#N\nzC\022\000\000\nj\011\000\199X\154<\n\130C\208\000\000\199X\189j\n\132D\138\000\000\nr\nf\n\158\n\144\n\176\002\230\199X\154<\002\230#N\n\128\003T\000\000\000\000\001|)\030\003\174#N\n\134\n\140ED\000\000E\254\000\000\005d\199X\166\014#N\000\012\005J\n\146F\184\000\000#N\n\174\n\158Gr\000\000\n\162H,\000\000H\230\000\000\n\164I\160\000\000\n\186\n\218#N\n\170JZ\000\000\n\172*\146\n\198\n\230#N\n\182\n\178\n\236\n\224\011\000\002\230\004\192)\216\005V#N\n\222\n\224*\146\n\246\011\022#N\n\230\011\128\199X\154\206\011\002*\146\199X\166\160*\146\029v#N\n\242\029\006*\146\011\026\011\014\199Xe\028\199Xe\168\199X\154\206\011*#N\n\250*\146\199XM\194\011\020\0114\001D\011\004*\146\005v\199X\1672#N\000\012\005h*\146\000\000#N\011 *\146\000\000*\146\000\000\000\000\000\000\011B#N\011\024*\146\000\000\199Xf4\199X\156n\011N#N\011\030*\146\000\000\011R#N\011\"*\146\000\000+L*\146#N\011$*\146\000\000\000\000\005z\199X\167\196#N\000\012\005|*\146\000\000#N\011:*\146\000\000*\146\000\000\000\000+L,\006+L#N\011**\146\000\000\000\000\005\134\199X\168V#N\000\012\005\136*\146\000\000#N\011B*\146\000\000*\146\000\000\000\000\001J\199X\168\232#N\000\012\005\156\029\006,\006,\192,\006#N\0110*\146\000\000\000\000\005\180\199X\169z#N\000\012\005\162*\146\000\000#N\011F*\146\000\000*\146\000\000\000\000#N\011L\029\006,\192-z,\192#N\011>*\146\000\000\000\000\005\188\199X\170\012#N\000\012\005\166*\146\000\000#N\011X*\146\000\000*\146\000\000\000\000\029\006-z.\190-z#N\011L*\146\000\000\000\000\005\220\199X\170\158#N\000\012\005\208*\146\000\000#N\011d*\146\000\000*\146\000\000\000\000\011`#N\011j*\146\000\000\000\000\199X\189\252\011l*\146\000\000\000\000*\146\000\000\005\232\199X\1710#N\000\012\005\218\011Z*\146\000\000#N\011p\011^*\146\000\000\011d*\146\000\000*\146\000\000\000\000\011z\011\154#N\011r*\146\000\000\011\138\000\000\028<\000\000\215~\003\248\011\132\011\166\001\002\011\164\215~\000\023\011\152\011\186\011\208\025v\011\190\012\024\025v\000\000\012\004\012\030\011\186\215~\011\174\011\208\000;\025v\001\004\011\192\215~\026\218\000~\011\246\"\220\011\200\011\232#N\011\190\215~\000x#r\004z\011\214\215~\005\018\011\208\011\244\012\n\005\138\005`\005\138\000\000\0126\012N\011\234\215~\025v\001 \011\240\199X\190\142\011\240\215~\025v\002J\011\248\199X\191 \011\246\215~\025v\0032\012\"\199Xe\168\012d\012\004\215~\0036\000\182\012\n\215~\000\000$,\006\024\012\018\215~\000\000\215~#N\012\002\215~\000\000\000\000\012,\002\196\025v\000\000\012~\006\028\012\030\215~\000\000\215\224#N\012\012\215~\000\000\000\000\025v\006(\012\"\215~\000\000\2162#N\012\016\215~\000\000\000\000\012~\006R\012,\215~\000\000\216b#N\012\026\215~\000\000\000\000\199X\191\178\0128\215~\000\000\006z\012>\215~\000\000#N\0120\215\224\012F\215~\000\000\000\000\012H\012j\000\194\012Z\215~\000\000$\230\006h\012\\\215~\000\000\216\160#N\012J\215~\000\000\000\000\012\198\006\138\012f\215~\000\000\216\208#N\012V\215~\000\000\000\000\026\218\006\144\012l\215~\000\000\217\014#N\012Z\215~\000\000\000\000\012\196\006\146\012r\215~\000\000\217>#N\012d\215~\000\000\000\000\199X\192D\012z\215~\000\000\006\160\012|\215~\000\000#N\012p\2162\012\136\215~\000\000\000\000\000\250\012\144\215~\000\000%\160\006\148\012\148\215~\000\000\217|#N\012\130\215~\000\000\000\000\012\250\006\156\012\154\215~\000\000\217\172#N\012\136\215~\000\000\000\000\"\220\006\158\012\158\215~\000\000\217\234#N\012\142\215~\000\000\000\000\012\250\006\168\012\168\215~\000\000\218\026#N\012\150\215~\000\000\000\000\199X\192\214\012\176\215~\000\000\006\204\012\182\215~\000\000#N\012\168\216\160\012\196\215~\000\000\000\000\000\000\199X\193b\r.\012\204\215~\000\000\012\192\012\226\012\252\199Xf4\r:\012\214\215~\000\000\199X\193\238\rB\012\222\215~\000\000\r\n\199X\154<\rP\012\240\215~\000\000\199X\194z\r\\\012\248\215~\000\000\000\000\012\250\r\028\r\016\199X\195\012\r\014\215~\000\000\r\020\199X\195\158\r\022\215~\000\000\000\000\r\n\r.\r\"\199X\1960\r \215~\000\000\r&\199X\196\194\r$\215~\000\000\000\000\rP\005\138\r|\r\148\r6\215~\000\000\000\000\218X#N\r&\215~\000\000\000\000\r\164\006\180\rF\215~\000\000\218\136#N\r4\215~\000\000\000\000.(\rN\025v\r^\006\198\rN\215~\000\000\218\198#N\r<\215~\000\000\000\000\005\240\004\230\025v\000\000\rf\006P\025v\000\000\r\172\r^\025v\rn\006\202\rb\215~\000\000\218\246#N\rT\215~\000\000\000\000\025v\r\128\006\218\rv\215~\000\000\2194#N\rf\215~\000\000\000\000\000\000\r\224\r\128\r\160#N\rp\215~\000\000\rx\r\154\r\190&Z\r\144\r\176#N\r\136\215~\000\000\014\004\r\168\r\200#N\r\166\215~\000\000\r\236'\020\r\190\r\222#N\r\174\215~\000\000\014*\r\202\r\236#N\r\188\215~\000\000\000\000\219d#N\r\190\215~\000\000\000\000\0146\006\224\r\214\215~\000\000\219\162#N\r\200\215~\000\000\000\000^\164\r\226\025v\r\242\006\236\r\232\215~\000\000\219\210#N\r\216\215~\000\000\000\000\014H\r\252\025v\014\012\006\244\r\252\215~\000\000\220\016#N\r\234\215~\000\000\000\000\025v\014\018\007\000\014\002\215~\000\000\220@#N\r\242\215~\000\000\000\000\000\000'\206\0074\014\n\215~\000\000\220~#N\r\248\215~\000\000\000\000\014p\007<\014\020\215~\000\000\220\174#N\014\006\215~\000\000\000\000fh\014$\025v\014:\007B\014,\215~\000\000\220\236#N\014\028\215~\000\000\000\000\014\134\0148\025v\014H\007D\0148\215~\000\000\221\028#N\014&\215~\000\000\000\000\014f\025v\014\146\014\170\014N\215~\000\000\025v\014f\007N\014Z\215~\000\000\221Z#N\014H\215~\000\000\000\000\000\000\014\156\025v\014\128\006\182(\136\000\000\014\210\014r\215~\000\000\025v\014\218\014z\215~\000\000\002&\014|\215~\000\000\014\176\025v\014\228\014\132\215~\000\000\025v\014\236\014\136\215~\000\000\014\140\000\000"), (16, "\000R\000\030\001\165\bn\0212\000!\001\165\000!\015\214\000!\000!\000!\001\026\000!\022\014\012\002\n-\017\154\004U\001\030\000!\012U\000!\n-\0016\001\165\000!\000!\012U\000!\000!\012F\000!\000!\001\165\000!\000!\000!\000V\000!\b\214\000!\027\230\005\154\b\230\"\230\027\170\003\234\000!\000!\005\202\012f\001\"\000!\000!\000!\000!\012U\000!\000!#\138\000!\000!#\226#V\000!\000!\000!\000!\000!\000!\000!\b\246\t6\n\r$R\014\238\000!\000!\004z\t\014\000!$n\n\r\000J\000N\007.\000!\000!\000\142\003\238\b\214\000!\000!\000%\b\230\000%\006\182\000%\000%\000%\004U\000%\014\246\017\154\004U\t\233\000\182\n\181\000%\012Q\000%\001\"\027\254\n\022\000%\000%\012Q\000%\000%\"\030\000%\000%\b\246\000%\000%\000%\000\146\000%\0072\000%\028\030\005\226\bZ!>\028\190\007J\000%\000%\006\018\001&\029\214\000%\000%\000%\000%\012Q\000%\000%\"b\000%\000%\b\030!\206\000%\000%\000%\000%\000%\000%\000%\001\190\028\202\016\022\016\238\0292\000%\000%\029\226\030\214\000%\030:\006>\027\158\027\238\n\r\000%\000%\016*\016v\000\210\000%\000%\000)\029\138\000)\029\158\000)\000)\000)\030\146\000)\030\166\012\n\028f\000\218\030\226\000\222\000)\031:\000) \158\t\174\n\r\000)\000)$\162\000)\000)\012\018\000)\000)\000\230\000)\000)\000)\000*\000)\031\146\000)\031\166\007\162$\202\017\182\n*\"\162\000)\000)\011\002\012\026 \190\000)\000)\000)\000)\n\r\000)\000)\011B\000)\000)\001&\017\190\000)\000)\000)\000)\000)\000)\000)\025\158\022\238\nn\016\238\t\181\000)\000)\000\238\n\r\000)\026z\n\r\b\154\017\154\004U\000)\000)\001\213\000:\001&\000)\000)\001=\004v\001=\000B\001=\001=\001=\b\250\001=\n\r\001\157\0152\n\186\004\134\001\157\001=\015R\001=\000z\t\n\n\r\001=\001=\023V\001=\001=\015~\001=\001=\001&\001=\001=\001=\001\157\001=\n\226\001=\005b\011&\001\006\017\182\r*\001\157\001=\001=\0012\000>$\226\001=\001=\001=\001=\001&\001=\001=\001&\001=\001=\011F\018\138\001=\001=\001=\001=\001=\001=\001=\r>\000~\011j\016\238\028\130\001=\001=\000\162\001&\001=\rr b\tB$\238\n\r\001=\001=\001\213\016\238\001&\001=\001=\0015\b:\0015\000\130\0015\0015\0015%\006\0015\012\182\001\161\014~\022\202\n\025\001\161\0015\014\158\0015 \130\n\r\n\r\0015\0015\001\174\0015\0015\014\202\0015\0015\000\190\0015\0015\0015\001\161\0015\000\166\0015\016>\n\029\n\005\017\182\014\206\001\161\0015\0015\012\202\n\005\0026\0015\0015\0015\0015\012\222\0015\0015\017\182\0015\0015\001&\018\218\0015\0015\0015\0015\0015\0015\0015\022\202\015\018\015\130\002N\0051\0015\0015\019*\n\r\0015\012\014\n\r\000\194\001F\002\150\0015\0015\001\213\001&\001&\0015\0015\001E\022\214\001E\000\170\001E\001E\001E\002f\001E\028\158\001\213\028\186\b&\012\022\028\254\001E\031\238\001E\029\202\0036\003\202\001E\001E\017\210\001E\001E\0051\001E\001E\003\246\001E\001E\001E\017\254\001E\015\166\001E\005-\016B\016b\006R\001J\002\154\001E\001E *\006n\030\210\001E\001E\001E\001E\001&\001E\001E\001&\001E\001E\006\146\006\170\001E\001E\001E\001E\001E\001E\001E\b~\006\214\003:\003\206\t\"\001E\001E\006\242\018\014\001E\007\022\007>\003\250\007\218\005-\001E\001E\002r\018:\tz\001E\001E\001]\006V\001]\000\198\001]\001]\001]\006r\001]\b\254\t\142\t\194\022\246\n\021\015\162\001]\t\254\001]\015\014\006\150\006\174\001]\001]\nV\001]\001]\027\146\001]\001]\006\218\001]\001]\001]\011\138\001]\006\246\001]\023\n\007\026\007B\002z\007\222\001\"\001]\001]\n\162\011f\n\222\001]\001]\001]\001]\n&\001]\001]$\222\001]\001]\018\162\nj\001]\001]\001]\001]\001]\001]\001]\011\014\018\206\011\162\017\178\011\214\001]\001]\018F\019B\001]\012\030\028&\012\138\017\230\n\182\001]\001]\017\238\019n\012\242\001]\001]\001U\rJ\001U\005\206\001U\001U\001U\002~\001U\r\138\r\210\014\n\002\138\019z\011\"\001U\011\182\001U\011\234\014J\002\170\001U\001U\019\166\001U\001U\012\158\001U\001U\002\174\001U\001U\001U\r\006\001U\018\"\001U\r^\018n\018* \250\023\178\018v\001U\001U\r\158\r\230\014\030\001U\001U\001U\001U\n\141\001U\001U\014^\001U\001U\020B\020\154\001U\001U\001U\001U\001U\001U\001U\018\182\020n\020\198\019\014\018\190\001U\001U\019\022\019V\001U\019\142\0282\019^\020V\019\150\001U\001U\020^\027V\020\174\001U\001U\001M\020\182\001M\006\022\001M\001M\001M\021\n\001M\020\246\021F\021\018\021\130\021n\021\166\001M\021\138\001M \218\021\"!~\001M\001M\021\154\001M\001M\t\205\001M\001M\021\214\001M\001M\001M\021\234\001M\0226\001M\021\242\022J\022\002\002\194\002\206\022R\001M\001M\022b\023\186\t\209\001M\001M\001M\001M\002\218\001M\001M\023*\001M\001M\023\022\0236\001M\001M\001M\001M\001M\001M\001M\024^\023J\025\006\024r\027\n\001M\001M\024z\025b\001M\024\138\028B\0252\025\026\028F\001M\001M\025\"\025\142\025v\001M\001M\001\133\025~\001\133\006\222\001\133\001\133\001\133\025\178\001\133\025\218\025\238\026\018\026V\026B\025\246\001\133\026^\001\133\028\210\026\006\029\014\001\133\001\133\026n\001\133\001\133\029:\001\133\001\133\026\162\001\133\001\133\001\133\026\182\001\133\027\022\001\133\026\190\027*\026\206!z\002\226\0276\001\133\001\133\027J\002\230\029f\001\133\001\133\001\133\001\133\002\242\001\133\001\133\n\145\001\133\001\133\029\234\003\026\001\133\001\133\001\133\001\133\001\133\001\133\001\133\029\162\003*\028\222\003j\029\026\001\133\001\133\003\134\030\022\001\133\029F\030B\030n\030\234!\134\001\133\001\133\031\022\031B\030\170\001\133\001\133\001}\031n\001}\006\250\001}\001}\001}!\026\001}\029r\t\193\003\146\003\158\003\166\029\174\001}!R\001}!\170\031\170\029\246\001}\001}!\142\001}\001}!\218\001}\001}\"\194\001}\001}\001}\030\182\001}\"\250\001}\030\"\003\170#2\030N\030z\030\246\001}\001}#b\031\"\031N\001}\001}\001}\001}\031z\001}\001}\031\182\001}\001}!&\003\182\001}\001}\001}\001}\001}\001}\001}!^\003\222!\182\004\n#\146\001}\001}$\178#\190\001}!\230#\246$.\"\206\004\018\001}\001}$z\004\022#\006\001}\001}\001\141#>\001\141\007\030\001\141\001\141\001\141#n\001\141\004\030\004*\004.\004F\004n\004\130\001\141\004\246\001\141\004\254\005^\005r\001\141\001\141\005~\001\141\001\141\005\134\001\141\001\141\005\138\001\141\001\141\001\141#\158\001\141\005\146\001\141#\202\005\162\005\174$\002$:\005\182\001\141\001\141\005\186$\134\005\198\001\141\001\141\001\141\001\141\005\218\001\141\001\141\005\234\001\141\001\141\005\246\005\254\001\141\001\141\001\141\001\141\001\141\001\141\001\141\006\002\006\014\006*\0066\006J\001\141\001\141\006f\006\138\001\141\006\166\006\202\006\234\007\014\007:\001\141\001\141\007V\007j\007v\001\141\001\141\001m\007\138\001m\007F\001m\001m\001m\007\150\001m\007\158\007\170\007\182\007\190\007\194\007\206\001m\007\246\001m\007\250\b\018\b\022\001m\001m\b.\001m\001m\b>\001m\001m\bN\001m\001m\001m\bR\001m\b^\001m\bv\b\130\b\146\b\150\b\158\b\186\001m\001m\b\190\b\206\b\226\001m\001m\001m\001m\b\242\001m\001m\t\006\001m\001m\t\026\t&\001m\001m\001m\001m\001m\001m\001m\t:\tF\tb\tn\t~\001m\001m\t\146\t\162\001m\t\178\t\198\t\226\t\234\t\238\001m\001m\t\246\n\002\n>\001m\001m\001e\nN\001e\007N\001e\001e\001e\nZ\001e\n\130\n\154\n\166\n\206\n\246\011\n\001e\011\018\001e\011:\011Z\011~\001e\001e\011\142\001e\001e\011\166\001e\001e\011\186\001e\001e\001e\011\206\001e\011\210\001e\011\218\011\238\012\006\0122\0126\012J\001e\001e\012R\012V\012j\001e\001e\001e\001e\012r\001e\001e\012v\001e\001e\012\142\012\162\001e\001e\001e\001e\001e\001e\001e\012\186\012\206\012\246\r\n\r\030\001e\001e\r.\rF\001e\rN\rb\rv\r\142\r\162\001e\001e\r\182\r\190\r\194\001e\001e\001u\r\202\001u\007\226\001u\001u\001u\r\214\001u\r\234\014\002\014\014\014\"\014B\014N\001u\014b\001u\014\134\014\146\014\150\001u\001u\014\166\001u\001u\014\170\001u\001u\014\178\001u\001u\001u\014\190\001u\014\194\001u\014\226\014\250\014\254\015\002\015&\015:\001u\001u\015F\015J\015Z\001u\001u\001u\001u\015^\001u\001u\015f\001u\001u\015r\015v\001u\001u\001u\001u\001u\001u\001u\015\150\015\186\015\202\015\206\015\222\001u\001u\015\226\015\234\001u\015\246\015\250\016\"\016.\016V\001u\001u\016f\016j\016z\001u\001u\000\181\016~\000\181\016\138\000\181\000\181\000\181\016\142\000\181\016\150\016\154\016\182\016\186\016\214\016\230\000\181\016\234\000\181\017\014\017\018\0172\000\181\000\181\017\198\000\181\000\181\017\246\000\181\000\181\0182\000\181\000\181\000\181\018N\000\181\018~\000\254\018\146\018\198\018\226\019\030\0192\019f\000\181\000\181\019\158\019\178\019\190\000\181\000\181\000\181\000\181\019\202\000\181\000\181\019\210\000\181\000\181\019\238\019\246\000\181\000\181\000\181\000\181\001\022\000\181\000\181\020\002\020\n\020\022\0202\020f\000\181\000\181\020\138\020\190\001:\020\230\021\026\021^\021\146\021\174\000\181\000\181\021\198\021\250\022&\000\181\000\181\000\189\022Z\000\189\022r\000\189\000\189\000\189\022z\000\189\022\134\022\138\022\150\022\170\022\182\022\186\000\189\022\190\000\189\022\194\022\198\022\222\000\189\000\189\022\254\000\189\000\189\023\002\000\189\000\189\023.\000\189\000\189\000\189\023>\000\189\023B\000\254\023N\023b\023n\023r\023z\023\134\000\189\000\189\023\142\023\146\023\154\000\189\000\189\000\189\000\189\023\158\000\189\000\189\023\162\000\189\000\189\023\166\023\170\000\189\000\189\000\189\000\189\001\022\000\189\000\189\023\194\023\198\023\206\023\210\023\218\000\189\000\189\023\222\023\234\001:\024\006\024\018\024\022\0242\024:\000\189\000\189\024J\024N\024V\000\189\000\189\000\201\024\130\000\201\024\158\000\201\000\201\000\201\024\166\000\201\024\194\024\202\024\214\024\222\024\246\025*\000\201\025R\000\201\025\134\025\202\025\254\000\201\000\201\026\026\000\201\000\201\0262\000\201\000\201\026f\000\201\000\201\000\201\026\146\000\201\026\198\000\254\026\222\026\230\026\254\027.\027>\027B\000\201\000\201\027N\027f\027j\000\201\000\201\000\201\000\201\027r\000\201\000\201\027\127\000\201\000\201\027\150\027\154\000\201\000\201\000\201\000\201\001\022\000\201\000\201\027\162\027\174\027\178\027\182\027\190\000\201\000\201\027\194\027\206\000\201\027\210\027\214\027\222\027\226\027\242\000\201\000\201\028\002\028\n\028\014\000\201\000\201\000\169\028\022\000\169\028*\000\246\001\014\000\169\0286\000\169\028:\028>\028R\028V\028Z\028j\000\169\028v\000\169\028\134\028\146\028\162\000\169\000\169\028\174\000\169\000\169\028\178\001Z\000\169\028\194\001b\000\169\000\169\028\214\000\169\028\234\000\254\028\250\029\n\029\018\029&\029>\029R\000\169\000\169\029b\029j\029~\000\169\001j\000\169\000\169\029\150\000\169\000\169\029\166\000\169\000\169\029\182\029\190\000\169\000\169\000\169\000\169\001\022\000\169\001r\029\206\029\210\029\218\029\238\030\002\000\169\000\169\030\018\030\026\001:\030.\030F\030Z\030j\030r\000\169\000\169\030\134\030\158\030\174\000\169\000\169\000\177\030\190\000\177\030\198\000\177\000\177\000\177\030\218\000\177\030\238\031\002\031\018\031\026\031.\031F\000\177\031Z\000\177\031j\031r\031\134\000\177\000\177\031\158\000\177\000\177\031\174\000\177\000\177\031\190\000\177\000\177\000\177\031\198\000\177\031\226\000\254\031\230\031\242\031\246\031\250 \006 \n\000\177\000\177 \030 \" .\000\177\000\177\000\177\000\177 :\000\177\000\177 >\000\177\000\177 R V\000\177\000\177\000\177\000\177\001\022\000\177\000\177 f j n z \134\000\177\000\177 \146 \162\001: \166 \170 \182 \194 \206\000\177\000\177 \222 \230 \234\000\177\000\177\000\193 \238\000\193!\006\000\193\000\193\000\193!\022\000\193!\030!2!F!N!V!j\000\193!\138\000\193!\154!\158!\166\000\193\000\193!\174\000\193\000\193!\194\000\193\000\193!\214\000\193\000\193\000\193!\222\000\193!\242\000\254\"\006\"\n\"\014\"\022\"\"\"&\000\193\000\193\"*\"2\"6\000\193\000\193\000\193\000\193\">\000\193\000\193\"J\000\193\000\193\"N\"R\000\193\000\193\000\193\000\193\001\022\000\193\000\193\"Z\"f\"n\"r\"z\000\193\000\193\"\134\"\138\001:\"\142\"\150\"\174\"\190\"\198\000\193\000\193\"\218\"\238\"\246\000\193\000\193\000\197\"\254\000\197#\018\000\197\000\197\000\197#\"\000\197#&#.#6#J#^#f\000\197#z\000\197#\150#\170#\186\000\197\000\197#\194\000\197\000\197#\214\000\197\000\197#\234\000\197\000\197\000\197#\242\000\197#\250\000\254$\014$\030$\"$*$2$F\000\197\000\197$V$^$b\000\197\000\197\000\197\000\197$f\000\197\000\197$v\000\197\000\197$~$\146\000\197\000\197\000\197\000\197\001\022\000\197\000\197$\166$\174$\190$\194$\210\000\197\000\197$\214$\230\001:$\242$\250$\254%\014%\018\000\197\000\197%\031\000\000\000\000\000\197\000\197\000\141\000\000\000\141\000\000\000\141\000\141\000\141\000\000\000\141\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\000\000\141\000\000\000\000\000\000\000\141\000\141\000\000\000\141\000\141\000\000\000\141\000\141\000\000\000\141\000\141\000\141\000\000\000\141\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\000\000\000\141\000\141\000\141\000\141\000\000\000\141\000\141\000\000\000\141\000\141\000\000\000\000\000\141\000\141\000\141\000\141\001\022\000\141\000\141\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\000\000\000\141\000\141\000\185\000\000\000\185\000\000\000\246\001\014\000\185\000\000\000\185\000\000\000\000\000\000\000\000\000\000\000\000\000\185\000\000\000\185\000\000\000\000\000\000\000\185\000\185\000\000\000\185\000\185\000\000\001Z\000\185\000\000\001b\000\185\000\185\000\000\000\185\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\000\185\000\185\000\000\000\000\000\000\000\185\001j\000\185\000\185\000\000\000\185\000\185\000\000\000\185\000\185\000\000\000\000\000\185\000\185\000\185\000\185\001\022\000\185\001r\000\000\000\000\000\000\000\000\000\000\000\185\000\185\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\000\185\000\185\000\000\000\000\000\000\000\185\000\185\000\173\000\000\000\173\000\000\000\246\001\014\000\173\000\000\000\173\000\000\000\000\000\000\000\000\000\000\000\000\000\173\000\000\000\173\000\000\000\000\000\000\000\173\000\173\000\000\000\173\000\173\000\000\001Z\000\173\000\000\001b\000\173\000\173\000\000\000\173\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\000\173\000\173\000\000\000\000\000\000\000\173\001j\000\173\000\173\000\000\000\173\000\173\000\000\000\173\000\173\000\000\000\000\000\173\000\173\000\173\000\173\001\022\000\173\001r\000\000\000\000\000\000\000\000\000\000\000\173\000\173\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\000\173\000\173\000\000\000\000\000\000\000\173\000\173\000\145\000\000\000\145\000\000\000\246\001\014\000\145\000\000\000\145\000\000\000\000\000\000\000\000\000\000\000\000\000\145\000\000\000\145\000\000\000\000\000\000\000\145\000\145\000\000\000\145\000\145\000\000\001Z\000\145\000\000\001b\000\145\000\145\000\000\000\145\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\000\145\000\145\000\000\000\000\000\000\000\145\001j\000\145\000\145\000\000\000\145\000\145\000\000\000\145\000\145\000\000\000\000\000\145\000\145\000\145\000\145\001\022\000\145\001r\000\000\000\000\000\000\000\000\000\000\000\145\000\145\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\000\145\000\145\000\000\000\000\000\000\000\145\000\145\000\129\000\000\000\129\000\000\000\246\001\014\000\129\000\000\000\129\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\000\000\129\000\000\000\000\000\000\000\129\000\129\000\000\000\129\000\129\000\000\001Z\000\129\000\000\001b\000\129\000\129\000\000\000\129\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\000\000\000\129\001j\000\129\000\129\000\000\000\129\000\129\000\000\000\129\000\129\000\000\000\000\000\129\000\129\000\129\000\129\001\022\000\129\001r\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\000\000\000\129\000\129\000\161\000\000\000\161\000\000\000\246\001\014\000\161\000\000\000\161\000\000\000\000\000\000\000\000\000\000\000\000\000\161\000\000\000\161\000\000\000\000\000\000\000\161\001R\000\000\001z\000\161\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\161\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\000\161\000\000\000\000\000\000\000\161\001j\001\210\001\218\000\000\000\161\001\226\000\000\001\146\000\161\000\000\000\000\000\161\000\161\000\161\000\161\001\022\000\161\001r\000\000\000\000\000\000\000\000\000\000\000\161\000\161\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\000\161\001\238\000\000\000\000\000\000\001\154\000\161\000\149\000\000\000\149\000\000\000\246\001\014\000\149\000\000\000\149\000\000\000\000\000\000\000\000\000\000\000\000\000\149\000\000\000\149\000\000\000\000\000\000\000\149\001R\000\000\001z\000\149\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\149\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\000\149\000\000\000\000\000\000\000\149\001j\001\210\001\218\000\000\000\149\000\149\000\000\001\146\000\149\000\000\000\000\000\149\000\149\000\149\000\149\001\022\000\149\001r\000\000\000\000\000\000\000\000\000\000\000\149\000\149\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\000\149\000\149\000\000\000\000\000\000\001\154\000\149\000\153\000\000\000\153\000\000\000\246\001\014\000\153\000\000\000\153\000\000\000\000\000\000\000\000\000\000\000\000\000\153\000\000\000\153\000\000\000\000\000\000\000\153\001R\000\000\001z\000\153\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\153\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\000\153\000\000\000\000\000\000\000\153\001j\001\210\001\218\000\000\000\153\000\153\000\000\001\146\000\153\000\000\000\000\000\153\000\153\000\153\000\153\001\022\000\153\001r\000\000\000\000\000\000\000\000\000\000\000\153\000\153\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\000\153\000\153\000\000\000\000\000\000\001\154\000\153\001\149\000\000\001\149\000\000\000\246\001\014\001\149\000\000\001\149\000\000\000\000\000\000\000\000\000\000\000\000\001\149\000\000\001\149\000\000\000\000\000\000\001\149\001R\000\000\001z\001\149\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\001\149\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\001\149\001j\001\210\001\218\000\000\001\149\001\226\000\000\001\146\001\149\000\000\000\000\001\149\001\149\001\149\001\149\001\022\001\149\001r\000\000\000\000\000\000\000\000\000\000\001\149\001\149\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\137\000\000\000\137\000\000\000\246\001\014\000\137\000\000\000\137\000\000\000\000\000\000\000\000\000\000\000\000\000\137\000\000\000\137\000\000\000\000\000\000\000\137\001R\000\000\001z\000\137\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\137\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\000\137\000\000\000\000\000\000\000\137\001j\001\210\001\218\000\000\000\137\001\226\000\000\001\146\000\137\000\000\000\000\000\137\000\137\000\137\000\137\001\022\000\137\001r\000\000\000\000\000\000\000\000\000\000\000\137\000\137\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\000\137\001\238\000\000\000\000\000\000\001\154\000\137\000\133\000\000\000\133\000\000\000\246\001\014\000\133\000\000\000\133\000\000\000\000\000\000\000\000\000\000\000\000\000\133\000\000\000\133\000\000\000\000\000\000\000\133\001R\000\000\001z\000\133\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\133\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\000\133\000\000\000\000\000\000\000\133\001j\001\210\001\218\000\000\000\133\001\226\000\000\001\146\000\133\000\000\000\000\000\133\000\133\000\133\000\133\001\022\000\133\001r\000\000\000\000\000\000\000\000\000\000\000\133\000\133\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\000\133\001\238\000\000\000\000\000\000\001\154\000\133\000y\000\000\000y\000\000\000\246\001\014\000y\000\000\000y\000\000\000\000\000\000\000\000\000\000\000\000\000y\000\000\000y\000\000\000\000\000\000\000y\000y\000\000\000y\000y\000\000\001Z\000y\000\000\001b\000y\000y\000\000\000y\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\000y\000y\000\000\000\000\000\000\000y\001j\000y\000y\000\000\000y\000y\000\000\000y\000y\000\000\000\000\000y\000y\000y\000y\001\022\000y\001r\000\000\000\000\000\000\000\000\000\000\000y\000y\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\000y\000y\000\000\000\000\000\000\000y\000y\000u\000\000\000u\000\000\000u\000u\000u\000\000\000u\000\000\000\000\000\000\000\000\000\000\000\000\000u\000\000\000u\000\000\000\000\000\000\000u\000u\000\000\000u\000u\000\000\000u\000u\000\000\000u\000u\000u\000\000\000u\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\000u\000u\000\000\000\000\000\000\000u\000u\000u\000u\000\000\000u\000u\000\000\000u\000u\000\000\000\000\000u\000u\000u\000u\001\022\000u\000u\000\000\000\000\000\000\000\000\000\000\000u\000u\000\000\000\000\000u\000\000\000\000\000\000\000\000\000\000\000u\000u\000\000\000\000\000\000\000u\000u\000\217\000\000\000\217\000\000\000\246\001\014\000\217\000\000\000\217\000\000\000\000\000\000\000\000\000\000\000\000\000\217\000\000\000\217\000\000\000\000\000\000\000\217\001R\000\000\001z\000\217\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\217\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\217\001j\001\210\001\218\000\000\000\217\001\226\000\000\001\146\000\217\000\000\000\000\000\217\000\217\000\217\000\217\001\022\000\217\001r\000\000\000\000\000\000\000\000\000\000\000\217\002\n\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000}\000\000\000}\000\000\000}\000}\000}\000\000\000}\000\000\000\000\000\000\000\000\000\000\000\000\000}\000\000\000}\000\000\000\000\000\000\000}\000}\000\000\000}\000}\000\000\000}\000}\000\000\000}\000}\000}\000\000\000}\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\000}\000}\000\000\000\000\000\000\000}\000}\000}\000}\000\000\000}\000}\000\000\000}\000}\000\000\000\000\000}\000}\000}\000}\001\022\000}\000}\000\000\000\000\000\000\000\000\000\000\000}\000}\000\000\000\000\000}\000\000\000\000\000\000\000\000\000\000\000}\000}\000\000\000\234\000\000\000}\000}\000\165\000\000\000\165\000\000\000\246\001\014\000\165\027\234\000\165\000\000\000\000\000\000\000\000\004\"\0296\000\165\005=\000\165\004&\000\000\000\000\000\165\001R\000\000\001z\000\165\000\000\001Z\001\130\000\000\001b\000\000\0042\000\000\000\165\005~\000\254\000\000\000\000\000\000\0046\000\000\000\000\000\000\000\165\000\000\000\000\004:\000\165\001j\000\000\000\000\000\000\000\165\000\165\000\000\001\146\000\165\000\000\000\000\000\165\000\165\000\165\000\165\001\022\000\165\001r\000\000\000\000\000\000\000\000\000\000\000\165\000\165\000\000\000\000\001:\004>\000\000\004B\005v\000\000\000\165\000\165\000\000\005z\000\000\001\154\000\165\000\205\000\000\000\205\000\000\000\246\001\014\000\205\000\000\000\205\000\000\000\000\000\000\000\000\000\000\000\000\000\205\b\178\000\205\000\000\000\000\000\000\000\205\001R\b\182\001z\000\205\000\000\001Z\001\130\000\000\001b\000\000\b\170\000\000\000\205\000\000\000\254\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\205\000\000\000\000\000\000\000\205\001j\000\000\000\000\b\198\000\205\000\205\000\000\001\146\000\205\000\000\000\000\000\205\000\205\000\205\000\205\001\022\000\205\001r\000\000\000\000\000\000\000\000\000\000\000\205\000\205\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\000\205\000\205\000\000\000\234\000\000\001\154\000\205\000\157\000\000\000\157\000\000\000\246\001\014\000\157\027\250\000\157\000\000\000\000\000\000\000\000\004\"\030>\000\157\000\000\000\157\004&\000\000\000\000\000\157\001R\000\000\001z\000\157\000\000\001Z\001\130\000\000\001b\000\000\0042\000\000\000\157\000\000\000\254\000\000\000\000\000\000\0046\000\000\000\000\000\000\000\157\000\000\000\000\004:\000\157\001j\000\000\000\000\000\000\000\157\000\157\000\000\001\146\000\157\000\000\000\000\000\157\000\157\000\157\000\157\001\022\000\157\001r\000\000\000\000\000\000\000\000\000\000\000\157\000\157\000\000\000\000\001:\004>\000\000\004B\005v\000\000\000\157\000\157\000\000\005z\000\000\001\154\000\157\000\209\000\000\000\209\000\000\000\246\001\014\000\209\000\000\000\209\000\000\000\000\000\000\000\000\000\000\000\000\000\209\000\000\000\209\000\000\000\000\000\000\000\209\001R\000\000\001z\000\209\000\000\001Z\001\130\000\000\001b\000\000\000\000\000\000\000\209\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\209\000\000\000\000\000\000\000\209\001j\000\000\000\000\000\000\000\209\000\209\000\000\001\146\000\209\001\205\000\000\000\209\000\209\000\209\000\209\001\022\000\209\001r\000\000\000\000\000\000\000\000\000\000\000\209\000\209\000\000\000\000\001:\000\000\000\000\000\000\000\000\000\000\000\209\000\209\001\205\001\205\000\000\001\154\000\209\001\205\000\000\001\205\001\205\001\205\001\205\000\000\001\205\000\000\000\000\001\205\000\000\001\205\001\205\000\000\001\205\001\205\001\205\001\205\000\000\001\205\000\000\000\000\000\000\000\000\001\205\000\000\000\000\000\000\000\000\000\000\001\205\000\000\000\000\001\205\000\000\000\000\000\000\000\000\001\205\000\000\000\000\001\205\000\000\000\000\000\000\001\205\001\205\000\000\000\000\000\000\001\205\000\000\001\205\001\205\000\006\001\205\001\205\001\205\000\000\000\000\000\000\004=\000\006\001\205\001\205\004=\000\000\001\205\001\205\000\000\000\000\000\000\000\000\001\205\001\205\001\205\001\205\001\205\001\205\000\000\001\205\000\000\000\000\001\205\000\000\001\205\001\205\000\000\000\000\000\000\001\205\001\205\004=\000\000\004=\004=\004=\004=\004=\004=\000\000\004=\000\000\004=\000\000\004=\000\000\004=\004=\004=\004=\004=\004=\000\000\004=\000\000\004=\004=\000\000\000\000\000\000\004=\000\000\000\000\000\000\000\000\004=\000\000\000\000\000\000\004=\004=\000\000\000\000\004=\004=\000\000\000\000\004=\004=\020*\000\000\000\000\004=\016\174\004=\004=\004=\004=\004=\004=\004=\000\000\004=\004=\004=\004=\000\000\020\026\004=\000\000\004=\020\026\004=\004=\004=\004=\004=\004=\004=\004=\004=\004=\004=\000\000\000\000\004=\004=\004=\004=\004=\000\000\004=\004=\004=\000\000\000\000\004=\004=\000\000\004=\000\000\000\000\000\000\000\000\004=\023\254\000\000\000\000\004=\000\000\004=\004=\000\000\000\000\000\000\004=\000\000\000\000\000\000\000\000\000\000\004=\000\000\020\026\004=\002\178\000\000\000\000\000\000\000\000\000\000\004=\004=\004=\n\213\n\213\000\000\000\000\004=\000\000\000\000\004=\000\000\004=\004=\n\213\000\000\000\000\004=\004=\000\000\n\213\n\213\000\000\n\213\000\000\000\000\n\213\n\213\000\000\n\213\n\213\000\000\002\182\000\000\000\000\n\213\000\000\002\198\000\000\000\000\000\000\000\000\n\213\n\213\002\246\012]\000\000\n\213\n\213\n\213\n\213\000\000\000\000\n\213\000\000\n\213\012]\000\000\012]\000\000\000\000\000\000\012]\n\213\003v\n\213\000\000\000\000\000\000\012]\000\000\n\213\n\213\n\217\n\217\n\213\000\000\000\000\000\000\000\000\000\000\n\213\n\213\000\000\n\217\000\000\n\213\n\213\004R\000\000\n\217\n\217\000\000\n\217\000\000\012]\n\217\n\217\012]\n\217\n\217\000\000\003z\000\000\000\000\n\217\000\000\003\138\000\000\000\000\000\000\000\000\n\217\n\217\003\186\000\000\000\000\n\217\n\217\n\217\n\217\000\000\012]\n\217\000\000\n\217\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\217\000R\n\217\000\000\000\000\000\000\012]\000\000\n\217\n\217\000!\000!\n\217\000\000\000\000\000\000\000\000\000\000\n\217\n\217\000\000\000\226\000\000\n\217\n\217\000R\000\000\000\000\000!\000\000\000!\000\000\000\000\000!\000!\000!\000!\000!\000!\000V\000\000\000\000\000!\000\000\005\154\004\026\000\000\000R\000\000\000!\000!\005\202\000!\000\000\000!\000!\000!\000!\000!\000\000\000!\000!\000!\000V\000\000\000\000\000!\005\142\005\154\000!\000!\000\000\000!\000!\000!\005\202\000!\000\000\000\000\000!\000!\000!\000!\000!\000!\000V\000!\000\000\000!\000!\005\154\000\000\000\000\000!\000!\000!\000!\005\202\000\000\000\000\000\000\000!\000!\000!\000\000\000\000\000!\000\000\000!\000\000\000\000\000\000\000!\000!\000\000\000!\000!\000!\000!\000\000\000\000\000\142\000\000\000\000\000\000\000!\000\000\000\000\000!\000\000\000%\000%\000\000\000\000\000!\000!\000\000\000\000\000\000\000!\000!\005\214\000\000\000\142\000\000\000\000\000\000\000\000\000%\000\000\000%\000\000\000%\000%\000%\000\000\000%\000%\000%\000\146\000\000\000\000\000%\006b\005\226\000\000\000\000\000\142\000\000\000%\000%\006\018\000%\000\000\000\000\000%\000%\000%\000%\000%\000%\000\146\000%\000\000\000%\000\000\005\226\006\230\000\000\000%\000%\000%\000%\006\018\000%\000\000\000%\000%\000%\000%\000%\000\000\000%\000%\000%\000\146\000\000\000\000\000%\000%\005\226\000%\000%\000%\000%\000%\000%\006\018\000\000\000\000\000\000\000%\000%\000%\000%\000\000\000%\000\000\000%\000\000\000%\000%\000\000\000\000\000\000\000%\000%\000R\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000!\000!\000%\000\000\000\000\000\000\000\000\000\000\000%\000%\000\000\t\242\000\000\000%\000%\000\000\000\000\000\000\000!\000\000\000!\000\000\000\000\000!\000!\000\000\000!\000!\000!\000V\000\000\000\000\000!\000\000\005\154\000\000\000\000\000\000\000\000\000!\000!\005\202\000\000\000\000\000\000\000!\000!\000!\000\000\000\000\000!\000\000\000!\000\000\000\000\000\000\000\000\000\000\000\000\000!\000!\000\142\000!\000\000\000\000\000\000\000\000\000\000\000\000\000!\000%\000%\000!\000\000\000\000\000\000\000\000\000\000\000!\000!\000\000\nJ\000\000\000!\000!\000\000\000\000\000\000\000%\000\000\000%\000\000\000\000\000%\000%\000\000\000%\000%\000%\000\146\000\000\000\000\000%\000\000\005\226\000\000\000\000\000\000\000\000\000%\000%\006\018\000\000\000\000\000\000\000%\000%\000%\000\000\000\000\000%\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\000R\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000!\000!\000%\000\000\000\000\000\000\000\000\000\000\000%\000%\000\000\r\198\000\000\000%\000%\000\000\000\000\000\000\000!\000\000\000!\000\000\000\000\000!\000!\000\000\000!\000!\000!\000V\000\000\000\000\000!\000\000\005\154\000\000\000\000\000\000\000\000\000!\000!\005\202\000\000\000\000\000\000\000!\000!\000!\000\000\000\000\000!\000\000\000!\000\000\000\000\000\000\000\000\000\000\000\000\000!\000!\000\142\000!\000\000\000\000\000\000\000\000\000\000\000\000\000!\000%\000%\000!\000\000\000\000\000\000\000\000\000\000\000!\000!\000\000\r\254\000\000\000!\000!\000\000\000\000\000\000\000%\000\000\000%\000\000\000\000\000%\000%\000\000\000%\000%\000%\000\146\000\000\000\234\000%\000\000\005\226\000\000\000\000\000\000\000\000\000%\000%\006\018\028\006\000\000\000\000\000%\000%\000%\004\"\031>\000%\000\000\000%\004&\007\254\000\000\000\000\000\000\000\000\000%\000%\000\000\000%\000\000\000\000\000\000\000\000\0042\000\000\000%\000\000\000\000\000%\000\000\000\000\0046\000\000\000\000\000%\000%\000\000\000\000\004:\000%\000%\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\234\000\000\000\000\000\000\b\142\000\000\004>\000\000\004B\005v\000\000\028\"\000\000\b\170\005z\000\000\000\000\004\"\b\174\000\000\000\000\b\194\004&\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\0042\016\178\000\000\000\000\000\000\007\254\016\170\000\000\0046\000\000\020z\000\000\000\000\000\000\000\000\004:\b9\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\004>\000\000\004B\005v\bV\000\000\bb\016\146\005z\bj\000\000\bz\000\234\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\028\206\000\000\b\170\000\000\000\000\000\000\004\"\b\174\000\000\000\000\b\194\004&\000\000\000\000\000\000\t\030\020\130\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\0042\016\178\000\000\000\000\000\000\007\254\017\186\000\000\0046\000\000\000\000\000\000\000\000\000\000\000\000\004:\bM\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\004>\000\000\004B\005v\bV\000\000\bb\016\146\005z\bj\000\000\bz\000\234\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\029\230\000\000\b\170\000\000\000\000\000\000\004\"\b\174\000\000\000\000\b\194\004&\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\0042\016\178\000\000\000\000\000\000\007\254\020&\000\000\0046\000\000\020\214\000\000\000\000\000\000\000\000\004:\b\153\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\004>\000\000\004B\005v\bV\000\000\bb\016\146\005z\bj\000\000\bz\000\234\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\030\230\000\000\b\170\000\000\000\000\000\000\004\"\b\174\000\000\000\000\b\194\004&\000\000\000\000\000\000\t\030\020\222\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\0042\016\178\000\000\000\000\000\000\007\254\020~\000\000\0046\000\000\000\000\000\000\000\000\000\000\000\000\004:\b\173\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\004>\000\000\004B\005v\bV\000\000\bb\016\146\005z\bj\000\000\bz\000\234\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\".\000\000\b\170\000\000\000\000\000\000\004\"\b\174\000\000\000\000\b\194\004&\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\0042\016\178\000\000\000\000\000\000\007\254\020\218\000\000\0046\000\000\021N\000\000\000\000\000\000\000\000\004:\bQ\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\004>\000\000\004B\005v\bV\000\000\bb\016\146\005z\bj\000\000\bz\000\234\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\"j\000\000\b\170\000\000\000\000\000\000\004\"\b\174\000\000\000\000\b\194\004&\000\000\000\000\000\000\t\030\021V\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\0042\016\178\000\000\000\000\000\000\007\254\021R\000\000\0046\000\000\000\000\000\000\000\000\000\000\000\000\004:\be\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\004>\000\000\004B\005v\bV\000\000\bb\016\146\005z\bj\000\000\bz\000\234\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000#\142\000\000\b\170\000\000\000\000\000\000\004\"\b\174\000\000\000\000\b\194\004&\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\0042\016\178\000\000\000\000\000\000\007\254\021\186\000\000\0046\000\000\021\182\000\000\000\000\000\000\000\000\004:\bi\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\004>\000\000\004B\005v\bV\000\000\bb\016\146\005z\bj\000\000\bz\000\234\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\t\197\000\000\b\170\000\000\000\000\000\000\004\"\b\174\000\000\000\000\b\194\004&\000\000\000\000\000\000\t\030\021\190\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\0042\016\178\000\000\000\000\000\000\007\254\022\026\000\000\0046\000\000\000\000\000\000\000\000\000\000\000\000\004:\b}\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\004>\000\000\004B\005v\bV\000\000\bb\016\146\005z\bj\000\000\bz\tj\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\011\158\b\174\000\000\000\000\b\194\011\202\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\011\254\016\178\000\000\000\000\000\000\007\254\022\242\000\000\012\134\000\000\022\022\000\000\000\000\000\000\000\000\012\178\b\129\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\012\238\000\000\r\026\r\134\bV\000\000\bb\016\146\r\178\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\022\030\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\000\022\023\182\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\149\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\023\138\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\023\202\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\024\238\000\000\000\000\t2\000\000\023\238\t>\000\000\000\000\000\000\024\014\000\000\000\000\000\000\000\022\023\250\004]\000\000\000\000\024\230\000\000\000\000\000\000\000\000\000\000\000\000\tR\t^\tf\000\000\000\000\000\000\000\000\024>\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\023\138\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\023\202\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\025J\000\000\000\000\t2\000\000\023\238\t>\000\000\000\000\000\000\024\014\000\000\000\000\000\000\000\022\024\234\004]\000\000\000\000\025B\000\000\000\000\000\000\000\000\000\000\000\000\tR\t^\tf\000\000\000\000\000\000\000\000\024>\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\023\138\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\023\202\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\025\194\000\000\000\000\t2\000\000\023\238\t>\000\000\000\000\000\000\024\014\000\000\000\000\000\000\000\022\025F\004]\000\000\000\000\025\186\000\000\000\000\000\000\000\000\000\000\000\000\tR\t^\tf\000\000\000\000\000\000\000\000\024>\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\023\138\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\023\202\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\026*\000\000\000\000\t2\000\000\023\238\t>\000\000\000\000\000\000\024\014\000\000\000\000\000\000\000\022\025\190\004]\000\000\000\000\026\"\000\000\000\000\000\000\000\000\000\000\000\000\tR\t^\tf\000\000\000\000\000\000\000\000\024>\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\023\138\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\023\202\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\026\138\000\000\000\000\t2\000\000\023\238\t>\000\000\000\000\000\000\024\014\000\000\000\000\000\000\000\000\026&\004]\000\000\000\000\026\130\000\000\000\000\000\000\000\000\000\000\000\000\tR\t^\tf\n\221\n\221\000\000\000\000\024>\000\000\000\000\t\138\000\000\t\158\t\190\n\221\000\000\000\234\t\210\t\222\000\000\n\221\n\221\000\000\n\221\000\000\000\000\n\221\n\221\000\000\n\221\n\221\000\000\002B\004\"!B\n\221\000\000\002^\004&\000\000\000\000\000\000\n\221\n\221\000\000\000\000\000\000\n\221\n\221\n\221\n\221\000\000\0042\n\221\000\000\n\221\000\000\007\254\000\000\000\000\0046\000\000\000\000\n\221\000\000\n\221\000\000\004:\000\000\000\000\000\000\n\221\n\221\000\000\000\000\n\221\000\000\000\000\000\000\000\000\000\000\n\221\n\221\000\000\000\000\000\000\n\221\n\221\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\004>\000\000\004B\005v\bV\000\000\bb\016\146\005z\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\026\134\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b-\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b1\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b5\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\181\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\189\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\185\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\197\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\193\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b=\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bA\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bE\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bI\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\157\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\161\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\165\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\169\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bU\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bY\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b]\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\ba\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bm\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bq\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bu\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\by\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\133\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\137\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\141\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\145\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\177\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\209\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\213\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\221\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\237\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\225\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\229\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\233\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\217\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\205\tR\t^\tf\000\000\000\000\000\000\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\000\000\000\000\t\210\t\222\b\026\000\000\b\"\b*\000\000\016\134\000\000\bJ\000\000\000\000\000\000\000\000\000\000\bV\000\000\bb\016\146\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\016\158\t>\000\000\000\000\000\000\016\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\201\tR\t^\tf\001N\012!\012!\000\000\016\218\000\000\000\000\t\138\000\000\t\158\t\190\000\000\012!\000\000\t\210\t\222\000\000\000\000\012!\012!\000\000\012!\000\000\000\000\012!\012!\000\000\012!\012!\000\000\000\000\000\000\000\000\012!\000\000\000\000\000\000\000\000\000\000\000\000\012!\012!\000\000\000\000\000\000\012!\012!\012!\012!\000\000\000\000\012!\000\000\012!\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012!\000\000\012!\000\000\000\000\000\000\000\000\000\000\012!\012!\000\000\000\000\012!\000\000\003J\000\000\000\246\001\014\012!\012!\t\253\000\000\000\000\012!\012!\000\000\000\000\t\253\000\000\t\253\000\000\000\000\000\000\000\000\001R\000\000\001z\016\226\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\007\234\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\018\246\001\226\000\000\001\146\016\210\000\000\000\000\003R\0045\000\000\006\030\001\022\027b\001r\000\000\000\000\000\000\000\000\000\000\002V\002\n\000\000\000\000\001:\002\158\011\233\011\233\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\011\233\000\000\000\000\000\000\000\000\000\000\011\233\011\233\000\000\011\233\000\000\000\000\011\233\011\233\000\000\011\233\011\233\000\000\000\000\000\000\000\000\011\233\000\000\000\000\000\000\000\000\000\000\000\000\011\233\011\233\000\000\000\000\000\000\011\233\011\233\011\233\011\233\000\000\000\000\011\233\000\000\011\233\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\233\000\000\011\233\000\000\000\000\000\000\000\000\000\000\011\233\011\233\000\000\000\000\011\233\002\250\012\001\012\001\000\000\000\000\011\233\011\233\000\000\000\000\000\000\011\233\011\233\012\001\000\000\000\000\000\000\000\000\000\000\012\001\012\001\000\000\012\001\000\000\000\000\012\001\012\001\000\000\012\001\012\001\000\000\000\000\000\000\000\000\012\001\000\000\000\000\000\000\000\000\000\000\000\000\012\001\012\001\000\000\000\000\000\000\012\001\012\001\012\001\012\001\000\000\000\000\012\001\000\000\012\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\001\000\000\012\001\000\000\000\000\000\000\000\000\000\000\012\001\012\001\000\000\000\000\012\001\003>\011\225\011\225\000\000\000\000\012\001\012\001\000\000\000\000\000\000\012\001\012\001\011\225\000\000\000\000\000\000\000\000\000\000\011\225\011\225\000\000\011\225\000\000\000\000\011\225\011\225\000\000\011\225\011\225\000\000\000\000\000\000\000\000\011\225\000\000\000\000\000\000\000\000\000\000\000\000\011\225\011\225\000\000\000\000\000\000\011\225\011\225\011\225\011\225\000\000\000\000\011\225\000\000\011\225\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\225\000\000\011\225\000\000\000\000\000\000\016\194\000\000\011\225\011\225\000\246\001\014\011\225\000\000\006\206\000\000\000\000\000\000\011\225\011\225\000\000\011\133\000\000\011\225\011\225\000\000\000\000\011\133\001R\000\000\001z\024F\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\b\006\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\011\133\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\019\234\000\000\000\000\000\000\000\000\019\218\006~\001\022\023j\001r\000\000\000\000\000\000\000\000\000\000\011\133\002\n\000\000\000\000\001:\003\190\011\249\011\249\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\011\249\000\000\000\000\000\000\000\000\000\000\011\249\011\249\000\000\011\249\000\000\000\000\011\249\011\249\000\000\011\249\011\249\000\000\000\000\000\000\000\000\011\249\000\000\000\000\000\000\000\000\000\000\000\000\011\249\011\249\000\000\000\000\000\000\011\249\011\249\011\249\011\249\000\000\000\000\011\249\000\000\011\249\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\249\000\000\011\249\000\000\000\000\000\000\000\000\000\000\011\249\011\249\000\000\000\000\011\249\003\210\011\241\011\241\000\000\000\000\011\249\011\249\000\000\000\000\000\000\011\249\011\249\011\241\000\000\000\000\000\000\000\000\000\000\011\241\011\241\000\000\011\241\000\000\000\000\011\241\011\241\000\000\011\241\011\241\000\000\000\000\000\000\000\000\011\241\000\000\000\000\000\000\000\000\000\000\000\000\011\241\011\241\000\000\000\000\000\000\011\241\011\241\011\241\011\241\000\000\000\000\011\241\000\000\011\241\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\241\000\000\011\241\000\000\000\000\000\000\000\000\000\000\011\241\011\241\000\000\000\000\011\241\003\254\012\t\012\t\000\000\000\000\011\241\011\241\000\000\000\000\000\000\011\241\011\241\012\t\000\000\000\000\000\000\000\000\000\000\012\t\012\t\000\000\012\t\000\000\000\000\012\t\012\t\000\000\012\t\012\t\000\000\000\000\000\000\000\000\012\t\000\000\000\000\000\000\000\000\000\000\000\000\012\t\012\t\000\000\000\000\000\000\012\t\012\t\012\t\012\t\000\000\000\000\012\t\000\000\012\t\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\t\000\000\012\t\000\000\000\000\000\000\000\000\000\000\012\t\012\t\000\000\000\000\012\t\006Z\0121\0121\000\000\000\000\012\t\012\t\000\000\000\000\000\000\012\t\012\t\0121\000\000\000\000\000\000\000\000\000\000\0121\0121\000\000\0121\000\000\000\000\0121\0121\000\000\0121\0121\000\000\000\000\000\000\000\000\0121\000\000\000\000\000\000\000\000\000\000\000\000\0121\0121\000\000\000\000\000\000\0121\0121\0121\0121\000\000\000\000\0121\000\000\0121\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0121\000\000\0121\000\000\000\000\000\000\000\000\000\000\0121\0121\000\000\000\000\0121\006v\012)\012)\000\000\000\000\0121\0121\000\000\000\000\000\000\0121\0121\012)\000\000\000\000\000\000\000\000\000\000\012)\012)\000\000\012)\000\000\000\000\012)\012)\000\000\012)\012)\000\000\000\000\000\000\000\000\012)\000\000\000\000\000\000\000\000\000\000\000\000\012)\012)\000\000\000\000\000\000\012)\012)\012)\012)\000\000\000\000\012)\000\000\012)\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012)\000\000\012)\000\000\000\000\000\000\000\000\000\000\012)\012)\000\000\000\000\012)\006\154\0129\0129\000\000\000\000\012)\012)\000\000\000\000\000\000\012)\012)\0129\000\000\000\000\000\000\000\000\000\000\0129\0129\000\000\0129\000\000\000\000\0129\0129\000\000\0129\0129\000\000\000\000\000\000\000\000\0129\000\000\000\000\000\000\000\000\000\000\000\000\0129\0129\000\000\000\000\000\000\0129\0129\0129\0129\000\000\000\000\0129\000\000\0129\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0129\000\000\0129\000\000\000\000\000\000\000\000\000\000\0129\0129\000\000\000\000\0129\006\178\012\025\012\025\000\000\000\000\0129\0129\000\000\000\000\000\000\0129\0129\012\025\000\000\000\000\000\000\000\000\000\000\012\025\012\025\000\000\012\025\000\000\000\000\012\025\012\025\000\000\012\025\012\025\000\000\000\000\000\000\000\000\012\025\000\000\000\000\000\000\000\000\000\000\000\000\012\025\012\025\000\000\000\000\000\000\012\025\012\025\012\025\012\025\000\000\000\000\012\025\000\000\012\025\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\025\000\000\012\025\000\000\000\000\000\000\000\000\000\000\012\025\012\025\000\000\000\000\012\025\006\186\012\017\012\017\000\000\000\000\012\025\012\025\000\000\000\000\000\000\012\025\012\025\012\017\000\000\000\000\000\000\000\000\000\000\012\017\012\017\000\000\012\017\000\000\000\000\012\017\012\017\000\000\012\017\012\017\000\000\000\000\000\000\000\000\012\017\000\000\000\000\000\000\000\000\000\000\000\000\012\017\012\017\000\000\000\000\000\000\012\017\012\017\012\017\012\017\000\000\000\000\012\017\000\000\012\017\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\017\000\000\012\017\000\000\000\000\000\000\000\000\000\000\012\017\012\017\000\000\003Z\012\017\000\246\001\014\bF\000\000\001B\012\017\012\017\000\000\000\000\000\000\012\017\012\017\000\000\t\221\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\016\202\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\019\198\000\000\000\000\000\000\000\000\000\000\001\250\001\022\007\242\001r\000\000\000\000\000\000\000\000\000\000\002\"\002\n\004Z\004\146\001:\000\000\000\000\000\000\000\000\000\000\002\018\001\238\000\000\n\157\000\000\001\154\002\026\000\000\000\000\004\154\004\162\000\000\004\202\000\000\000\000\004\170\004\210\000\000\004\178\004\218\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\242\005\002\000\000\000\000\000\000\n\157\004\186\005\n\n\157\000\000\000\000\005\018\000\000\004\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\005B\005J\011i\011i\004\138\000\000\000\000\000\000\000\000\000\000\0052\005\030\000\000\011i\000\000\004\234\005:\000\000\000\000\011i\011i\000\000\011i\000\000\000\000\011i\011i\000\000\011i\011i\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\011i\011i\000\000\000\000\000\000\011i\011i\011i\011i\000\000\000\000\011i\000\000\011i\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\011i\000\000\000\000\000\000\000\000\000\000\011i\011i\011}\011}\004\138\000\000\000\000\000\000\000\000\000\000\011i\011i\000\000\011}\000\000\011i\011i\000\000\000\000\011}\011}\000\000\011}\000\000\000\000\011}\011}\000\000\011}\011}\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\011}\011}\000\000\000\000\000\000\011}\011}\011}\011}\000\000\000\000\011}\000\000\011}\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\011}\000\000\000\000\000\000\000\000\000\000\011}\011}\011q\011q\011}\000\000\000\000\000\000\000\000\000\000\011}\011}\000\000\011q\000\000\011}\011}\000\000\000\000\011q\011q\000\000\011q\000\000\000\000\011q\011q\000\000\011q\011q\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\011q\011q\000\000\000\000\000\000\011q\011q\011q\011q\000\000\000\000\011q\000\000\011q\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\011q\000\000\000\000\000\000\000\000\000\000\011q\011q\004Z\004\146\004\138\000\000\000\000\000\000\000\000\000\000\011q\011q\000\000\011]\000\000\011q\011q\000\000\000\000\011]\011]\000\000\011]\000\000\000\000\004\170\011]\000\000\004\178\011]\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\011]\011]\000\000\000\000\000\000\011]\004\186\011]\011]\000\000\000\000\011]\000\000\011]\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\011]\011]\011e\011e\004\138\000\000\000\000\000\000\000\000\000\000\011]\011]\000\000\011e\000\000\011]\011]\000\000\000\000\011e\011e\000\000\011e\000\000\000\000\011e\011e\000\000\011e\011e\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\011e\011e\000\000\000\000\000\000\011e\011e\011e\011e\000\000\000\000\011e\000\000\011e\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\011e\000\000\000\000\000\000\000\000\000\000\011e\011e\011u\011u\004\138\000\000\000\000\000\000\000\000\000\000\011e\011e\000\000\011u\000\000\011e\011e\000\000\000\000\011u\011u\000\000\011u\000\000\000\000\011u\011u\000\000\011u\011u\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\011u\011u\000\000\000\000\000\000\011u\011u\011u\011u\000\000\000\000\011u\000\000\011u\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\011u\000\000\000\000\000\000\000\000\000\000\011u\011u\011y\011y\004\138\000\000\000\000\000\000\000\000\000\000\011u\011u\000\000\011y\000\000\011u\011u\000\000\000\000\011y\011y\000\000\011y\000\000\000\000\011y\011y\000\000\011y\011y\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\011y\011y\000\000\000\000\000\000\011y\011y\011y\011y\000\000\000\000\011y\000\000\011y\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\011y\000\000\000\000\000\000\000\000\000\000\011y\011y\011A\011A\004\138\000\000\000\000\000\000\000\000\000\000\011y\011y\000\000\011A\000\000\011y\011y\000\000\000\000\011A\011A\000\000\011A\000\000\000\000\011A\011A\000\000\011A\011A\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\011A\011A\000\000\000\000\000\000\011A\011A\011A\011A\000\000\000\000\011A\000\000\011A\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\011A\000\000\000\000\000\000\000\000\000\000\011A\011A\004Z\004\146\004\138\000\000\000\000\000\000\000\000\000\000\011A\011A\000\000\011m\000\000\011A\011A\000\000\000\000\011m\011m\000\000\011m\000\000\000\000\004\170\011m\000\000\004\178\011m\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\011m\011m\000\000\000\000\000\000\011m\004\186\011m\011m\000\000\000\000\011m\000\000\011m\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\011m\011m\004Z\004\146\004\138\000\000\000\000\000\000\000\000\000\000\011m\011m\000\000\011a\000\000\011m\011m\000\000\000\000\011a\011a\000\000\011a\000\000\000\000\004\170\011a\000\000\004\178\011a\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\011a\011a\000\000\000\000\000\000\011a\004\186\011a\011a\000\000\000\000\011a\000\000\011a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\011a\011a\004Z\004\146\004\138\000\000\000\000\000\000\000\000\000\000\011a\011a\000\000\011E\000\000\011a\011a\000\000\000\000\011E\011E\000\000\011E\000\000\000\000\004\170\011E\000\000\004\178\011E\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\011E\011E\000\000\000\000\000\000\011E\004\186\011E\011E\000\000\000\000\011E\000\000\011E\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\011E\011E\004Z\004\146\004\138\000\000\000\000\000\000\000\000\000\000\011E\011E\000\000\0115\000\000\011E\011E\000\000\000\000\0115\0115\000\000\0115\000\000\000\000\004\170\0115\000\000\004\178\0115\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\0115\0115\000\000\000\000\000\000\0115\004\186\0115\0115\000\000\000\000\0115\000\000\0115\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\0115\0115\004Z\004\146\004\138\000\000\000\000\000\000\000\000\000\000\0115\0115\000\000\011U\000\000\0115\0115\000\000\000\000\011U\004\162\000\000\004\202\000\000\000\000\004\170\004\210\000\000\004\178\004\218\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\242\011U\000\000\000\000\000\000\011U\004\186\005\n\011U\000\000\000\000\005\018\000\000\004\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\011U\011U\004Z\004\146\004\138\000\000\000\000\000\000\000\000\000\000\011U\005\030\000\000\011I\000\000\004\234\011U\000\000\000\000\011I\004\162\000\000\004\202\000\000\000\000\004\170\004\210\000\000\004\178\004\218\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\242\011I\000\000\000\000\000\000\011I\004\186\005\n\011I\000\000\000\000\011I\000\000\004\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\011I\011I\004Z\004\146\004\138\000\000\000\000\000\000\000\000\000\000\011I\011I\000\000\011M\000\000\004\234\011I\000\000\000\000\011M\004\162\000\000\004\202\000\000\000\000\004\170\004\210\000\000\004\178\004\218\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\242\011M\000\000\000\000\000\000\011M\004\186\005\n\011M\000\000\000\000\011M\000\000\004\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\011M\011M\004Z\004\146\004\138\000\000\000\000\000\000\000\000\000\000\011M\011M\000\000\011=\000\000\004\234\011M\000\000\000\000\011=\004\162\000\000\004\202\000\000\000\000\004\170\004\210\000\000\004\178\004\218\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\242\011=\000\000\000\000\000\000\011=\004\186\005\n\011=\000\000\000\000\005\018\000\000\004\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\011=\011=\004Z\004\146\004\138\000\000\000\000\000\000\000\000\000\000\011=\005\030\000\000\0119\000\000\004\234\011=\000\000\000\000\0119\004\162\000\000\004\202\000\000\000\000\004\170\004\210\000\000\004\178\004\218\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\242\0119\000\000\000\000\000\000\0119\004\186\005\n\0119\000\000\000\000\005\018\000\000\004\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\0119\0119\011)\011)\004\138\000\000\000\000\000\000\000\000\000\000\0119\005\030\000\000\011)\000\000\004\234\0119\000\000\000\000\011)\011)\000\000\011)\000\000\000\000\011)\011)\000\000\011)\011)\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\011)\011)\000\000\000\000\000\000\011)\011)\011)\011)\000\000\000\000\011)\000\000\011)\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\011)\000\000\000\000\000\000\000\000\000\000\011)\011)\004Z\004\146\011)\000\000\000\000\000\000\000\000\000\000\011)\011)\000\000\011-\000\000\011)\011)\000\000\000\000\011-\011-\000\000\011-\000\000\000\000\004\170\011-\000\000\004\178\011-\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\011-\011-\000\000\000\000\000\000\011-\004\186\011-\011-\000\000\000\000\011-\000\000\011-\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\011-\011-\0111\0111\004\138\000\000\000\000\000\000\000\000\000\000\011-\011-\000\000\0111\000\000\011-\011-\000\000\000\000\0111\0111\000\234\0111\000\000\000\000\0111\0111\000\000\0111\0111\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\004\"\"\234\000\000\0111\0111\004&\000\000\000\000\0111\0111\0111\0111\000\000\000\000\0111\000\000\0111\000\000\000\000\0042\000\000\000\000\000\000\000\000\004r\000\000\0111\0046\000\000\000\000\000\000\000\000\0111\0111\004:\000\000\0111\nQ\000\000\nQ\nQ\000\000\0111\0111\nQ\000\000\000\000\0111\0111\000\000\nQ\000\000\nQ\000\000\000\000\nQ\000\000\nQ\000\000\000\000\000\000\000\000\nQ\000\000\004>\000\000\004B\005v\000\000\000\000\000\000\nQ\005z\000\000\000\000\000\000\nQ\000\000\000\000\nQ\000\000\000\000\000\000\000\000\nQ\000\000\000\000\000\000\nQ\000\000\nQ\nQ\000\000\000\000\000\000\000\000\nQ\000\000\000\000\000\000\nQ\000\000\000\000\000\000\000\000\000\000\000\000\n]\000\000\n]\n]\nQ\nQ\nQ\n]\016\246\000\000\000\000\000\000\000\000\n]\nQ\n]\nQ\nQ\n]\000\000\n]\nQ\nQ\nQ\000\000\n]\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n]\000\000\000\000\000\000\000\000\n]\000\000\000\000\n]\000\000\000\000\000\000\000\000\n]\000\000\000\000\000\000\n]\000\000\n]\n]\000\000\000\000\000\000\000\000\n]\000\000\000\000\000\000\n]\000\000\000\000\000\000\000\000\000\000\000\000\nI\000\000\nI\nI\n]\n]\n]\nI\016\254\000\000\000\000\000\000\000\000\nI\n]\nI\n]\n]\nI\000\000\nI\n]\n]\n]\000\000\nI\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nI\000\000\000\000\000\000\000\000\nI\000\000\000\000\nI\000\000\000\000\000\000\000\000\nI\000\000\000\000\000\000\nI\000\000\nI\nI\000\000\000\000\000\000\000\000\nI\000\000\000\000\000\000\nI\000\000\000\000\000\000\000\000\000\000\000\000\nU\000\000\nU\nU\nI\nI\nI\nU\017\006\000\000\000\000\000\000\000\000\nU\nI\nU\nI\nI\nU\000\000\nU\nI\nI\nI\000\000\nU\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nU\000\000\000\000\000\000\000\000\nU\000\000\000\000\nU\000\000\000\000\000\000\000\000\nU\000\000\000\000\000\000\nU\000\000\nU\nU\000\000\000\000\000\000\000\000\nU\000\000\000\000\000\000\nU\000\000\000\000\000\000\000\000\000\000\000\000\n=\000\000\n=\n=\nU\nU\nU\n=\017\022\000\000\000\000\000\000\000\000\n=\nU\n=\nU\nU\n=\000\000\n=\nU\nU\nU\000\000\n=\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n=\000\000\000\000\000\000\000\000\n=\000\000\000\000\n=\000\000\000\000\000\000\000\000\n=\000\000\000\000\000\000\n=\000\000\n=\n=\000\000\000\000\000\000\000\000\n=\000\000\000\000\000\000\n=\000\000\000\000\000\000\000\000\000\000\000\000\n9\000\000\n9\n9\n=\n=\n=\n9\017\030\000\000\000\000\000\000\000\000\n9\n=\n9\n=\n=\n9\000\000\n9\n=\n=\n=\000\000\n9\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n9\000\000\000\000\000\000\000\000\n9\000\000\000\000\n9\000\000\000\000\000\000\000\000\n9\000\000\000\000\000\000\n9\000\000\n9\n9\000\000\000\000\000\000\000\000\n9\000\000\000\000\000\000\n9\000\000\000\000\000\000\000\000\000\000\000\000\n5\000\000\n5\n5\n9\n9\n9\n5\017&\000\000\000\000\000\000\000\000\n5\n9\n5\n9\n9\n5\000\000\n5\n9\n9\n9\000\000\n5\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n5\000\000\000\000\000\000\000\000\n5\000\000\000\000\n5\000\000\000\000\000\000\000\000\n5\000\000\000\000\000\000\n5\000\000\n5\n5\000\000\000\000\000\000\000\000\n5\000\000\000\000\000\000\n5\000\000\000\000\000\000\000\000\000\000\000\000\nE\000\000\nE\nE\n5\n5\n5\nE\0176\000\000\000\000\000\000\000\000\nE\n5\nE\n5\n5\nE\000\000\nE\n5\n5\n5\000\000\nE\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nE\000\000\000\000\000\000\000\000\nE\000\000\000\000\nE\000\000\000\000\000\000\000\000\nE\000\000\000\000\000\000\nE\000\000\nE\nE\000\000\000\000\000\000\000\000\nE\000\000\000\000\000\000\nE\000\000\000\000\000\000\000\000\000\000\000\000\nY\000\000\nY\nY\nE\nE\nE\nY\017>\000\000\000\000\000\000\000\000\nY\nE\nY\nE\nE\nY\000\000\nY\nE\nE\nE\000\000\nY\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nY\000\000\000\000\000\000\000\000\nY\000\000\000\000\nY\000\000\000\000\000\000\000\000\nY\000\000\000\000\000\000\nY\000\000\nY\nY\000\000\000\000\000\000\000\000\nY\000\000\000\000\000\000\nY\000\000\000\000\000\000\000\000\000\000\000\000\nA\000\000\nA\nA\nY\nY\nY\nA\017F\000\000\000\000\000\000\000\000\nA\nY\nA\nY\nY\nA\000\000\nA\nY\nY\nY\000\000\nA\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nA\000\000\000\000\000\000\000\000\nA\000\000\000\000\nA\000\000\000\000\000\000\000\000\nA\000\000\000\000\000\000\nA\000\000\nA\nA\000\000\000\000\000\000\000\000\nA\000\000\000\000\000\000\nA\000\000\000\000\000\000\000\000\000\000\000\000\nM\000\000\nM\nM\nA\nA\nA\nM\017N\000\000\000\000\000\000\000\000\nM\nA\nM\nA\nA\nM\000\000\nM\nA\nA\nA\000\000\nM\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nM\000\000\000\000\000\000\000\000\nM\000\000\000\000\nM\000\000\000\000\000\000\000\000\nM\000\000\000\000\000\000\nM\000\000\nM\nM\000\000\000\000\000\000\000\000\nM\000\000\000\000\000\000\nM\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nM\nM\nM\024\030\017V\007^\000\000\000\246\001\014\b\138\nM\003\230\nM\nM\000\000\000\000\000\000\nM\nM\nM\t\225\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\019\226\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\019\254\000\000\000\000\000\000\000\000\024\174\007\002\001\022\b\014\001r\000\000\000\000\000\000\000\000\000\000\002\002\002\n\000\246\001\014\001:\000\000\003\014\000\000\000\000\000\000\002\018\001\238\000\000\028\170\000\000\001\154\002\026\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\024&\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\024\154\000\000\000\000\000\000\000\000\000\000\031\214\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\003\018\002\n\000\246\001\014\001:\000\000\007~\000\000\000\000\000\000\002\018\001\238\000\000 \002\000\000\001\154\002\026\000\000\000\000\000\000\001R\000\234\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\024\182\000\000\000\254\000\000\000\000\000\000\004\"#\230\000\000\001\170\001\202\004&\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\024\210\000\000\0042\000\000\000\000\000\000 \018\001\022\000\000\001r\0046\000\000\000\000\000\000\000\000\007\130\002\n\004:\000\000\001:\b\026\000\000\b\"\b*\000\000\002\018\001\238\bJ\000\000\000\000\001\154\002\026\000\000\bV\000\000\bb\000\000\000\000\bj\000\000\bz\000\000\000\000\000\000\000\000\b\142\000\000\004>\000\000\004B\005v\000\000\000\000\000\000\b\170\005z\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\137\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\137\000\000\000\000\006\137\006\137\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\153\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\153\000\000\000\000\006\153\006\153\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\141\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\141\000\000\000\000\005\141\005\141\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\181\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\181\000\000\000\000\006\181\006\181\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\173\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\173\000\000\000\000\006\173\006\173\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006y\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006y\000\000\000\000\006y\006y\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006Y\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006Y\000\000\000\000\006Y\006Y\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005U\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005U\000\000\000\000\005U\005U\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005m\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005m\000\000\000\000\005m\005m\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005M\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005M\000\000\000\000\005M\005M\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\165\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\165\000\000\000\000\006\165\006\165\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005e\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005e\000\000\000\000\005e\005e\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\133\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\133\000\000\000\000\006\133\006\133\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\145\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\145\000\000\000\000\006\145\006\145\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\237\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\237\000\000\000\000\005\237\005\237\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005]\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005]\000\000\000\000\005]\005]\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005}\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005}\000\000\000\000\005}\005}\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005u\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005u\000\000\000\000\005u\005u\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\129\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\129\000\000\000\000\006\129\006\129\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\157\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\157\000\000\000\000\005\157\005\157\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005E\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005E\000\000\000\000\005E\005E\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\153\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\153\000\000\000\000\005\153\005\153\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006A\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006A\000\000\000\000\006A\006A\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\149\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\149\000\000\000\000\005\149\005\149\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\145\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\145\000\000\000\000\005\145\005\145\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006=\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006=\000\000\000\000\006=\006=\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\165\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\165\000\000\000\000\005\165\005\165\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\161\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\161\000\000\000\000\005\161\005\161\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006E\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006E\000\000\000\000\006E\006E\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005q\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005q\000\000\000\000\005q\005q\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006-\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006-\000\000\000\000\006-\006-\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\133\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\133\000\000\000\000\005\133\005\133\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\129\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\129\000\000\000\000\005\129\005\129\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\0065\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0065\000\000\000\000\0065\0065\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005y\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005y\000\000\000\000\005y\005y\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\0061\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0061\000\000\000\000\0061\0061\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005Y\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005Y\000\000\000\000\005Y\005Y\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006!\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006!\000\000\000\000\006!\006!\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\233\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\233\000\000\000\000\005\233\005\233\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\181\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\181\000\000\000\000\005\181\005\181\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\177\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\177\000\000\000\000\005\177\005\177\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\205\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\205\000\000\000\000\005\205\005\205\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\201\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\201\000\000\000\000\005\201\005\201\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\017\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\017\000\000\000\000\006\017\006\017\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\021\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\021\000\000\000\000\006\021\006\021\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\r\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\r\000\000\000\000\006\r\006\r\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\173\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\173\000\000\000\000\005\173\005\173\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\169\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\169\000\000\000\000\005\169\005\169\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\197\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\197\000\000\000\000\005\197\005\197\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\193\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\193\000\000\000\000\005\193\005\193\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\t\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\t\000\000\000\000\006\t\006\t\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\189\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\189\000\000\000\000\005\189\005\189\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\185\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\185\000\000\000\000\005\185\005\185\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\221\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\221\000\000\000\000\005\221\005\221\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\229\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\229\000\000\000\000\005\229\005\229\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\225\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\225\000\000\000\000\005\225\005\225\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\217\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\217\000\000\000\000\005\217\005\217\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\213\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\213\000\000\000\000\005\213\005\213\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\209\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\209\000\000\000\000\005\209\005\209\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\253\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\253\000\000\000\000\005\253\005\253\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\249\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\249\000\000\000\000\005\249\005\249\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\245\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\245\000\000\000\000\005\245\005\245\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\241\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\241\000\000\000\000\005\241\005\241\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\005\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\005\000\000\000\000\006\005\006\005\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\001\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\001\000\000\000\000\006\001\006\001\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006Q\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006Q\000\000\000\000\006Q\006Q\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006U\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006U\000\000\000\000\006U\006U\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006i\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006i\000\000\000\000\006i\006i\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006m\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006m\000\000\000\000\006m\006m\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005a\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005a\000\000\000\000\005a\005a\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006%\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006%\000\000\000\000\006%\006%\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\161\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\161\000\000\000\000\006\161\006\161\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\149\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\149\000\000\000\000\006\149\006\149\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005I\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005I\000\000\000\000\005I\005I\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\025\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\025\000\000\000\000\006\025\006\025\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006I\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006I\000\000\000\000\006I\006I\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006M\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006M\000\000\000\000\006M\006M\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006a\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006a\000\000\000\000\006a\006a\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006e\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006e\000\000\000\000\006e\006e\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005i\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005i\000\000\000\000\005i\005i\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006)\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006)\000\000\000\000\006)\006)\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005Q\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005Q\000\000\000\000\005Q\005Q\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\029\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\029\000\000\000\000\006\029\006\029\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006]\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006]\000\000\000\000\006]\006]\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006q\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006q\000\000\000\000\006q\006q\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006u\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006u\000\000\000\000\006u\006u\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006}\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006}\000\000\000\000\006}\006}\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\169\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\169\000\000\000\000\006\169\006\169\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\177\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\177\000\000\000\000\006\177\006\177\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\005\137\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\137\000\000\000\000\005\137\005\137\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\0069\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0069\000\000\000\000\0069\0069\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\157\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\157\000\000\000\000\006\157\006\157\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\006\141\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\141\000\000\000\000\006\141\006\141\000\000\000\000\b\026\000\000\b\"\b*\tR\t^\tf\bJ\000\000\000\000\000\000\000\000\000\000\bV\t\138\bb\t\158\t\190\bj\000\000\bz\t\210\t\222\000\000\000\000\b\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\017\138\t>\000\000\000\000\000\000\000\000\018V\000\000\000\000\000\000\018\214\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\tR\t^\tf\000\246\001\014\022\146\000\000\004N\000\000\000\000\t\138\000\000\t\158\t\190 6\000\000\000\000\t\210\t\222\018\238\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\022\158\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\022\210\000\000\000\000\000\000\000\000\000\000 F\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\016\166\001:\000\246\001\014\023\230\000\000\007*\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\026\242\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\024.\000\000\000\000\000\000\000\000\000\000\n\142\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\004Z\004\146\001:\000\000\000\000\000\000\000\000\000\000\002\018\001\238\000\000\n\165\000\000\001\154\002\026\000\000\000\000\000\000\004\162\000\000\004\202\000\000\000\000\004\170\004\210\000\000\004\178\004\218\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\242\005\002\000\000\000\000\000\000\n\165\004\186\005\n\n\165\000\000\000\000\005\018\000\000\004\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\005*\004Z\004\146\000\000\004\138\000\000\000\000\000\000\000\000\000\000\0052\005\030\n\161\000\000\000\000\004\234\005:\000\000\000\000\004\162\000\000\004\202\000\000\000\000\004\170\004\210\000\000\004\178\004\218\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\242\005\002\000\000\000\000\000\000\n\161\004\186\005\n\n\161\000\000\000\000\005\018\000\000\004\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\017\146\005R\000\246\001\014\b\166\004\138\007\214\000\000\000\000\000\000\000\000\0052\005\030\006&\000\000\000\000\004\234\005:\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\024\190\000\000\000\000\000\000\000\000\000\000\0146\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\017\162\002\n\000\246\001\014\001:\000\000\b6\000\000\000\000\000\000\002\018\001\238\000\000\006\134\000\000\001\154\002\026\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\017\218\002\n\000\246\001\014\001:\000\000\tv\000\000\000\000\000\000\002\018\001\238\000\000\007\n\000\000\001\154\002\026\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\018\022\001:\000\246\001\014\t.\000\000\t\170\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\018b\001:\000\246\001\014\tN\000\000\r&\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\018\170\001:\000\246\001\014\tZ\000\000\016\030\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\019\002\001:\000\246\001\014\t\134\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\019J\001:\000\246\001\014\t\154\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\019\130\001:\000\246\001\014\t\186\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\020\"\001:\000\246\001\014\t\206\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\020J\001:\000\246\001\014\t\218\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\020\162\001:\000\246\001\014\n\n\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\020\254\001:\000\246\001\014\n\030\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\021:\001:\000\246\001\014\n2\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\021v\001:\000\246\001\014\nb\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\021\222\001:\000\246\001\014\nv\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\022>\002\n\000\246\001\014\001:\000\000\000\000\000\000\000\000\000\000\002\018\001\238\000\000\n\150\000\000\001\154\002\026\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\023\030\001:\000\246\001\014\n\174\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\023\246\001:\000\246\001\014\n\194\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\024f\001:\000\246\001\014\n\234\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\025\014\001:\000\246\001\014\011\026\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\025j\001:\000\246\001\014\011.\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\025\166\001:\000\246\001\014\011N\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\025\226\001:\000\246\001\014\011r\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\026J\001:\000\246\001\014\011\150\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\026\170\001:\000\246\001\014\011\174\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\027\030\001:\000\246\001\014\011\194\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\011\226\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\011\246\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\012>\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\012^\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\012~\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\012\150\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\012\170\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\012\194\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\012\214\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\012\230\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\012\254\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\r\018\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\r6\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\rV\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\rj\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\r~\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\r\150\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\r\170\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\r\222\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\r\242\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\014\022\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\014*\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\246\001\014\001:\000\000\000\000\000\000\000\000\000\000\002\018\001\238\000\000\014>\000\000\001\154\002\026\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\014V\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\014j\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\014\214\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\015\026\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\015\138\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\015\174\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\016\n\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\016J\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\022\166\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\026\250\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\028r\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\028\142\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\029\146\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\030\154\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014\031\154\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\246\001\014\001:\000\000\000\000\000\000\000\000\000\000\002\018\001\238\000\000\031\222\000\000\001\154\002\026\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\246\001\014\001:\000\000\000\000\000\000\000\000\000\000\002\018\001\238\000\000 \026\000\000\001\154\002\026\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\246\001\014\001:\000\000\000\000\000\000\000\000\000\000\002\018\001\238\000\000 N\000\000\001\154\002\026\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014 v\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014 \142\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014 \178\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001:\000\246\001\014 \202\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001R\000\000\001z\000\000\000\000\001Z\001\130\000\000\001b\001\138\001\162\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001j\001\210\001\218\000\000\000\000\001\226\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\001r\000\000\000\000\000\000\000\000\000\000\000\000\002\n\004Z\004\146\001:\000\000\000\000\000\000\000\000\000\000\002\018\001\238\000\000\011Y\000\000\001\154\002\026\000\000\000\000\011Y\004\162\000\000\004\202\000\000\000\000\004\170\004\210\000\000\004\178\000\000\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011Y\000\000\000\000\000\000\011Y\004\186\000\000\011Y\000\000\000\000\011Y\000\000\004\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004r\000\000\004\194\000\000\000\000\000\000\000\000\000\000\011Y\011Y\004Z\004\146\004\138\000\000\000\000\000\000\000\000\000\000\011Y\011Y\000\000\011Q\000\000\004\234\011Y\000\000\000\000\011Q\004\162\000\000\004\202\000\000\000\000\004\170\004\210\000\000\004\178\000\000\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011Q\000\000\000\000\000\000\011Q\004\186\b\026\011Q\b\"\b*\011Q\000\000\004\226\bJ\000\000\000\000\000\000\000\000\000\000\bV\004r\bb\004\194\000\000\bj\000\000\bz\000\000\011Q\011Q\000\000\b\142\004\138\000\000\000\000\000\000\000\000\000\000\011Q\011Q\b\170\000\000\000\000\004\234\011Q\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\018Z\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\018\134\000\000\b\026\000\000\b\"\b*\000\000\000\000\000\000\bJ\000\000\tR\t^\tf\000\000\bV\000\000\bb\000\000\000\000\bj\t\138\bz\t\158\t\190\000\000\000\000\b\142\t\210\t\222\000\000\000\000\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\000\000\b\174\000\000\000\000\b\194\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\t2\000\000\018\250\t>\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\019&\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\tR\t^\tf\000\000\000\000\000\"\000\000\000\000\bf\000\000\t\138\000\000\t\158\t\190\000&\0002\0006\t\210\t\222\t\229\000\000\000F\000\000\000\000\000\000\000\000\000\000\000\000\000^\000\000\000b\001\230\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000.\000\000\000\000\000\000\000&\0002\0006\001\182\000\000\002b\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000Z\000\000\000\000\000\000\000&\0002\0006\000n\000\000\002\202\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\150\000\000\000\000\000\000\000&\0002\0006\003\"\000\000\003\142\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\001\002\000\000\000\000\000\000\000\000\000\000\002:\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002>\002\142\002\146\002\162\000\000\005%\000\000\002\166\000\154\000\158\000\174\000\178\000\186\000\000\002\254\000\202\003\002\000\206\000\000\000\000\000\000\003\006\000\000\000\000\003\030\000\000\000\000\000\000\003.\0032\000\000\000\000\000\000\000\000\000\000\003B\003r\000\000\000\000\b\218\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\003\194\003\198\003\214\003\218\003\242\000\"\000\000\004\002\000\000\004\006\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\000\000\000\000\000\000\000\000\000\000\000\000^\000\000\001\178\001\186\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\000\154\000\158\000\174\000\178\000\186\000\"\000\000\000\202\000\000\000\206\002F\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\005\158\000\000\000F\000\000\000\000\000\000\000\000\000\000\000\000\000^\000\000\000b\001\242\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\002j\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\005\230\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\002\130\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\007\166\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\002\186\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\002\210\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\002\234\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\003~\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\003\150\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\003\174\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\001\002\000\000\000\000\000\000\000\000\000\000\002:\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002>\002\142\002\146\004f\000\000\t\185\000\000\002\166\000\154\000\158\000\174\000\178\000\186\000\000\002\254\000\202\003\002\000\206\000\000\000\000\000\000\003\006\000\000\000\000\003\030\000\000\000\000\000\000\003.\0032\000\000\000\000\000\000\000\000\000\000\003B\003r\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\002\003\194\003\198\003\214\003\218\003\242\002:\000\000\004\002\000\000\004\006\000\000\000\000\000\000\000\000\002>\002\142\002\146\b\234\000\000\000\000\000\000\002\166\000\000\000\000\000\000\000\000\000\000\000\000\002\254\000\000\003\002\005\022\000\000\000\000\000\000\003\006\000\000\000\000\003\030\000\000\000\000\000\000\003.\0032\000\000\000\000\000\000\000\000\000\000\003B\003r\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\002\003\194\003\198\003\214\003\218\003\242\002:\000\000\004\002\000\000\004\006\000\000\000\000\000\000\000\000\002>\002\142\002\146\000\000\000\000\000\000\000\000\002\166\000\000\000\000\000\000\000\000\000\000\000\000\002\254\000\000\003\002\005\"\000\000\000\000\000\000\003\006\000\000\000\000\003\030\000\000\000\000\000\000\003.\0032\000\000\000\000\000\000\000\000\000\000\003B\003r\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\005\166\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\003\194\003\198\003\214\003\218\003\242\000\000\000^\004\002\000b\004\006\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\005\190\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\005\238\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\006\006\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\007\174\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\007\198\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\br\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\014\130\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\014\174\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\0156\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\015b\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\015\230\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000\214\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\006\226\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\004\014\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\006^\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\005\130\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\005\210\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\t\230\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\nF\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\r\186\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\234\027\142\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\r\250\000\000\000\000\000\000\000\000\027\166\000\000\004\"\000\000\000\000\000\000\000\000\027\218\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\246\000\000\000\000\000\154\000\158\000\174\000\178\000\186\0046\028\226\000\202\000\000\000\206\000\234\027\142\028\026\000\000\000\000\000\000\000\000\000\000\000\000\029\186\000\000\000\000\002A\028.\000\000\027\166\000\000\004\"\000\000\000\000\000\000\000\000\027\218\000\000\028^\028z\000\000\000\000\000\000\000\000\000\000\000\000\004>\000\000\004B\005v\027\246\000\000\000\000\000\000\028\150\000\234\027\142\000\000\0046\029\030\000\000\000\000\000\000\000\000\030\194\028\026\000\000\000\000\000\000\000\000\027\166\000\000\004\"\000\000\000\000\002A\028.\027\218\000\000\000\234\027\142\000\000\000\000\000\000\000\000\000\000\000\000\028^\028z\000\000\000\000\027\246\000\000\000\000\027\166\004>\004\"\004B\005v\0046\029J\027\218\000\000\028\150\000\000\000\000\028\026\000\000\000\000\000\000\000\234\027\142\000\000\000\000\000\000\027\246\002A\028.\000\000\031\194\000\000\000\000\000\000\0046\029v\027\166\000\000\004\"\028^\028z\028\026\000\000\027\218\000\000\000\234\027\142\004>\000\000\004B\005v\002A\028.\000\000\000\000\028\150\000\000\027\246\000\000\000\000\027\166\000\000\004\"\028^\028z\0046\029\250\027\218\000\000\000\000\000\000\004>\028\026\004B\005v\000\000\000\234\027\142\000\000\028\150\000\000\027\246\002A\028.\000\000\000\000\000\000\000\000\000\000\0046\030&\027\166\000\000\004\"\028^\028z\028\026\000\000\027\218\000\000\000\234\027\142\004>\000\000\004B\005v\002A\028.\000\000\000\000\028\150\000\000\027\246\000\000\000\000\027\166\000\000\004\"\028^\028z\0046\030R\027\218\000\000\000\000\000\000\004>\028\026\004B\005v\000\000\000\234\027\142\000\000\028\150\000\000\027\246\002A\028.\000\000\000\000\000\000\000\000\000\000\0046\030~\027\166\000\000\004\"\028^\028z\028\026\000\000\027\218\000\000\000\234\027\142\004>\000\000\004B\005v\002A\028.\000\000\000\000\028\150\000\000\027\246\000\000\000\000\027\166\000\000\004\"\028^\028z\0046\030\250\027\218\000\000\000\000\000\000\004>\028\026\004B\005v\000\000\000\234\027\142\000\000\028\150\000\000\027\246\002A\028.\000\000\000\000\000\000\000\000\000\000\0046\031&\027\166\000\000\004\"\028^\028z\028\026\000\000\027\218\000\000\000\234\027\142\004>\000\000\004B\005v\002A\028.\000\000\000\000\028\150\000\000\027\246\000\000\000\000\027\166\000\000\004\"\028^\028z\0046\031R\027\218\000\000\000\000\000\000\004>\028\026\004B\005v\000\000\000\234\027\142\000\000\028\150\000\000\027\246\002A\028.\000\000\000\000\000\000\000\000\000\000\0046\031~\027\166\000\000\004\"\028^\028z\028\026\000\000\027\218\000\000\000\234\027\142\004>\000\000\004B\005v\002A\028.\000\000\000\000\028\150\000\000\027\246\000\000\000\000\027\166\000\000\004\"\028^\028z\0046 \254\027\218\000\000\000\000\000\000\004>\028\026\004B\005v\000\000\000\234\027\142\000\000\028\150\000\000\027\246\002A\028.\000\000\000\000\000\000\000\000\000\000\0046!*\027\166\000\000\004\"\028^\028z\028\026\000\000\027\218\000\000\000\234\027\142\004>\000\000\004B\005v\002A\028.\000\000\000\000\028\150\000\000\027\246\000\000\000\000\027\166\000\000\004\"\028^\028z\0046!b\027\218\000\000\000\000\000\000\004>\028\026\004B\005v\000\000\000\234\027\142\000\000\028\150\000\000\027\246\002A\028.\000\000\000\000\000\000\000\000\000\000\0046!\186\027\166\000\000\004\"\028^\028z\028\026\000\000\027\218\000\000\000\234\027\142\004>\000\000\004B\005v\002A\028.\000\000\000\000\028\150\000\000\027\246\000\000\000\000\027\166\000\000\004\"\028^\028z\0046!\234\027\218\000\000\000\000\000\000\004>\028\026\004B\005v\000\000\000\234\027\142\000\000\028\150\000\000\027\246\002A\028.\000\000\000\000\000\000\000\000\000\000\0046\"\166\027\166\000\000\004\"\028^\028z\028\026\000\000\027\218\000\000\000\234\027\142\004>\000\000\004B\005v\002A\028.\000\000\000\000\028\150\000\000\027\246\000\000\000\000\027\166\000\000\004\"\028^\028z\0046\"\210\027\218\000\000\000\000\000\000\004>\028\026\004B\005v\000\000\000\234\027\142\000\000\028\150\000\000\027\246\002A\028.\000\000\000\000\000\000\000\000\000\000\0046#\n\027\166\000\000\004\"\028^\028z\028\026\000\000\027\218\000\000\000\234\027\142\004>\000\000\004B\005v\002A\028.\000\000\000\000\028\150\000\000\027\246\000\000\000\000\027\166\000\000\004\"\028^\028z\0046#B\027\218\000\000\000\000\000\000\004>\028\026\004B\005v\000\000\000\234\027\142\000\000\028\150\000\000\027\246\002A\028.\000\000\000\000\000\000\000\000\000\000\0046#r\027\166\000\000\004\"\028^\028z\028\026\000\000\027\218\000\000\000\234\027\142\004>\000\000\004B\005v\002A\028.\000\000\000\000\028\150\000\000\027\246\000\000\000\000\027\166\000\000\004\"\028^\028z\0046#\162\027\218\000\000\000\000\000\000\004>\028\026\004B\005v\000\000\000\234\027\142\000\000\028\150\000\000\027\246\002A\028.\000\000\000\000\000\000\000\000\000\000\0046#\206\027\166\000\000\004\"\028^\028z\028\026\000\000\027\218\000\000\000\234\027\142\004>\000\000\004B\005v\002A\028.\000\000\000\000\028\150\000\000\027\246\000\000\000\000\027\166\000\000\004\"\028^\028z\0046$\006\027\218\000\000\000\000\000\000\004>\028\026\004B\005v\000\000\000\234\027\142\000\000\028\150\000\000\027\246\002A\028.\000\000\000\000\000\000\000\000\000\000\0046$>\027\166\000\000\004\"\028^\028z\028\026\000\000\027\218\000\000\000\000\000\000\004>\000\000\004B\005v\002A\028.\000\000\000\000\028\150\000\000\027\246\000\000\000\000\000\000\000\000\000\000\028^\028z\0046$\138\000\000\000\000\000\000\000\000\004>\028\026\004B\005v\000\000\000\000\000\000\000\000\028\150\000\000\016\242\002A\028.\000\000\000\000\000\000\000\000\000\000\000\000\016\250\017\002\000\000\000\000\028^\028z\000\000\017\n\000\000\000\000\000\000\000\000\004>\000\000\004B\005v\017\026\017\"\000\000\000\000\028\150\000\000\000\000\000\000\000\000\000\000\017*\000\000\017:\000\000\000\000\000\000\000\000\000\000\000\000\000\000\017B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\017J\000\000\017R"))
  
  and lhs =
    (8, "\001\000                                                                                                    \031\031\031\031\031\031\031\031\031\031\031\031\031\030\030\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\027\027\026\026\026\026\026\026\025\025\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\023\023\022\022\022\022\021\021\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\018\018\018\017\017\017\016\016\016\015\014\014\014\014\014\014\014\014\r\r\012\012\011\011\n\n\n\n\n\n\t\t\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\007\007\007\007\006\006\006\006\006\006\005\005\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\003\002\002\002\002\002\002\002\002\002\002\002\002\002")
  
  and goto =
    ((16, "\000\028\000'\000\000\000\000\000\015\000)\000\000\000\015\000\000\000\000\000B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000F\000\000\000\018\000\204\000\250\000J\000\000\000\000\000\000\000\000\000\000\000\000\001(\000\000\000\000\000t\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001V\000\000\000\000\000\000\000\000\001\132\000\000\001\178\000\000\000\000\000\000\000\000\002\028\000\000\002\018\000\000\002\030\000\000\000\176\000\000\002r\000\000\002\160\000\000\000\000\003*\000\000\000\000\003f\000\000\000\000\000\000\000\000\003\168\000\000\000\000\000\000\000\000\000\000\003\210\000\000\003\238\000\000\004\012\000\000\004\030\000\000\004Z\000\000\004f\000\000\004x\000\000\004\132\000\000\004\136\000\000\004\162\000\000\004\166\000\000\000\000\002\250\000\204\003L\000\000\003|\000\000\000\000\004\180\000\000\005\012\000\000\006j\000\000\006p\000\000\000\000\006\170\000\000\000\000\t\224\000\000\003\156\000\000\t\228\000\000\t\234\000\000\t\248\000\000\003\172\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\166\000\000\000\000\000\000\000\000\000\208\000\000\000\212\000\000\000\254\000\000\000\000\000\000\000\000\000\000\001\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001,\000\000\000\000\000\000\0010\000\000\001Z\000\000\000\000\000\000\000\000\000\000\001^\000\000\000\000\000\000\000\000\000\000\n2\n4\n\000\000\000\000\000\001\136\000\000\000\000\001\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\004\000\000\n\b\n\020\n\020\000\000\n\022\n\"\000\000\000\000\n\026\000\000\000\000\000\000\001\182\000\000\000\000\000\000\001\186\000\000\001\228\000\000\000\000\000\000\000\000\000\000\001\232\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\028\000\000\000\000\000\000\000\t\000\000\000\000\000\000\000\000\nV\000\000\n \000\000\000\000\000\000\000\000\n^\000\000\000\000\000\000\000\000\n`\000\000\000\000\000\000\000\000\n&\000\000\000\000\000\007\000\000\n`\000\000\000\214\000\000\000\000\000\000\000\000\nT\000\000\000\000\000\000\000\000\nd\000\000\nf\000\000\nh\000\000\nj\000\000\nl\000\000\nn\000\000\np\000\000\nr\000\000\nt\000\000\nv\000\000\nx\000\000\nz\000\000\n|\000\000\000\000\003\188\000\000\000\000\n~\000\000\n\128\000\000\n\130\000\000\000\000\n\132\000\000\000\000\002$\000\000\n\134\000\000\n\136\000\000\002\194\000\000\n\138\000\000\003\030\000\000\000\000\000\000\0000\000\000\000\000\000\000\000\000\000\000\000\000\nT\000\000\000\000\000\000\000\000\n\146\000\000\002b\000\000\002l\000\000\000\000\000\000\000\000\000\000\002\170\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\148\000\000\003\242\000\000\004\230\000\000\000\000\000\000\000\000\000\000\004\234\000\000\000\000\000\000\000\000\000\000\000\000\nZ\000\000\000\000\n\152\000\000\000\000\005\030\000\000\005,\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\154\000\000\000\000\000\000\000\000\000\000\n`\000\000\000\000\n\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\160\000\000\000\000\000\000\000\000\000\000\nf\000\000\000\000\n\164\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nj\nv\000\000\nn\000\000\000\000\000\000\000\000\000\000\004\248\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\004\000\000\005\018\000\000\000\000\000\000\000\000\000\000\005\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\np\000\000\000\000\000\000\000\024\nr\000\000\nt\000\000\000\000\000\000\000\028\000\000\000\031\000\000\005\018\000\000\nv\000\000\n\162\000\000\nz\000\000\005\022\000\000\000\000\005\024\000\000\000\000\005\026\n|\005\030\000\000\005\"\000\000\005 \n\168\000\000\n\128\000\000\005\"\000\000\000\000\n\172\000\000\n\132\000\000\005&\000\000\003\186\000\000\000\000\000\000\000\000\004>\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\004\128\000\000\000\000\000\000\000\000\n\176\000\000\000\000\000\000\000\000\004\152\000\000\000\000\000\000\n\178\000\000\n\138\000\000\005>\000\000\000\000\005@\n\182\000\000\n\142\000\000\005B\n\144\000\000\005D\000\000\005F\000\000\000\000\n\146\000\000\000\000\000\000\n\148\000\000\005H\n\192\000\000\n\152\000\000\005J\000\000\n\154\000\000\n\198\000\000\n\158\000\000\005L\n\202\000\000\n\162\000\000\005N\n\164\000\000\005P\000\000\n\166\000\000\000\000\000\000\000\000\n\228\n\212\000\000\n\172\000\000\005R\000\000\000\000\n\174\000\000\005j\000\000\000\000\n\176\000\000\005l\000\000\000\000\005n\000\000\000\000\000\000\n\238\n\222\000\000\n\182\000\000\005p\000\000\000\000\n\184\000\000\005r\000\000\000\000\005t\000\000\000\000\n\186\000\000\000\000\n\248\n\232\000\000\n\192\000\000\005v\000\000\000\000\n\194\000\000\005x\000\000\000\000\005z\000\000\000\000\000\000\000\000\n\196\000\000\005|\000\000\000\000\005~\000\000\000\000\000\006\000\000\n\240\000\000\n\200\000\000\005\150\000\000\000\000\n\202\000\000\005\152\000\000\000\000\005\154\000\000\000\000\n\204\000\000\005\156\000\000\000\000\005\158\000\000\000\000\000\000\n\206\000\000\005\160\000\000\000\000\005\162\000\000\000\000\000\000\n\208\000\000\005\164\000\000\000\000\000\000\n\210\000\000\005\166\000\000\000\000\n\212\000\000\005\168\000\000\000\000\000\000\000\000\000\000\n\214\000\000\005\170\000\000\000\000\n\216\000\000\005\194\000\000\000\000\000\000\011\006\000\000\011\b\000\000\011\n\000\000\011\012\000\000\000\000\000\000\000\000\000\000\n\226\000\000\005\196\000\000\000\000\011\016\000\000\000\000\n\230\000\000\005\198\000\000\000\000\011\020\000\000\000\000\n\234\000\000\005\200\000\000\000\000\000\000\n\236\000\000\005\202\000\000\000\000\n\238\000\000\005\204\000\000\000\000\000\000\n\240\000\000\005\206\000\000\000\000\n\242\000\000\005\208\000\000\n\244\000\000\005\210\000\000\000\000\000\000\n\246\000\000\005\212\000\000\000\000\n\248\000\000\005\214\000\000\000\000\n\250\000\000\000\000\000\000\n\252\000\000\005\238\000\000\000\b\000\000\000\000\000\000\n\254\000\000\005\240\000\000\000\000\011\000\000\000\005\242\000\000\000\000\011\002\000\000\005\244\000\000\000\000\000\000\011\004\000\000\005\246\000\000\000\000\011\006\000\000\005\248\000\000\000\000\011\b\000\000\000\000\000\000\000\000\011F\000\000\000\000\011\012\000\000\005\250\000\000\000\000\011\014\000\000\005\252\000\000\000\000\000\000\011L\000\000\000\000\011\018\000\000\005\254\000\000\000\000\011\020\000\000\006\000\000\000\000\000\011\022\000\000\000\000\011T\000\000\000\000\011\026\000\000\006\002\000\000\000\000\011\028\000\000\006\026\000\000\000\000\000\000\000\000\006*\000\000\006\030\000\000\000\000\000\000\006 \000\000\0060\000\000\000\000\0062\000\000\006&\000\000\000\000\000\000\006(\000\000\000\000\011\030\000\000\006*\000\000\000\000\006.\000\000\000\000\0068\000\000\000\000\000\000\000\000\006:\000\000\000\000\000\000\011 \000\000\006F\000\000\000\000\006L\000\000\000\000\006:\000\000\006T\000\000\000\000\000\000\006V\000\000\006@\000\000\000\000\006h\000\000\006^\000\000\000\000\000\000\006`\000\000\000\000\011\"\000\000\006d\000\000\000\000\006f\000\000\000\000\000\000\011$\000\000\006h\000\000\000\000\006n\000\000\000\000\000\000\000\000\006p\000\000\006\128\000\000\000\000\006\134\000\000\006\138\000\000\000\000\000\000\006\140\000\000\000\000\000\000\006\142\000\000\000\000\011&\000\000\000\000\006\144\000\000\000\000\006\146\000\000\000\000\000\000\000\000\011(\000\000\006\148\000\000\000\000\006\150\000\000\000\000\000\000\000\000\006\154\000\000\000\000\000\000\000\000\006\156\000\000\000\000\000\000\000 \000\000\000\000\000$\011*\000\000\006\174\0118\000(\000\000\000\000\011.\000\000\0110\000\000\0112\000\000\000\000\000B\0114\000\000\000\000\000\000\011<\011h\000\000\011j\000\000\011l\000\000\011n\000\000\000\000\000\000\011p\000\000\011r\000\000\011t\006\192\000\000\000\000\011v\000\000\011x\000\000\011z\000\000\011|\000\000\011~\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\182\011P\000\000\006\184\011`\011T\000\000\006\186\011d\000\000\000\000\011^\006\188\011`\000F\000\000\011b\000\000\000\000\011^\000\000\006\190\011n\000\000\000J\000\000\006\192\000\000\000N\000\000\000R\000\000\000\000\000\000\011b\000\000\006\198\011r\000\000\011l\000\000\006\200\000\000\011n\000\000\011p\000\000\000\000\006\202\000\000\011r\000\000\006\218\011n\000\000\006\226\011~\000\000\011x\000\000\006\228\000\000\011z\000\000\011|\000V\000\000\011~\000\000\000\000\000\000\011z\000\000\006\230\011\138\000\000\011\132\000\000\006\232\000\000\011\134\000\000\011\136\000\000\011\138\000p\000\000\011\140\000\000\000\000\011\136\000\000\006\234\011\138\000\000\006\236\011\154\000\000\011\148\000\000\006\238\000\000\011\150\000\000\011\152\000t\000\000\011\154\000\000\000\000\000\000\011\150\000\000\006\242\011\166\000\000\011\160\000\000\006\244\000\000\011\162\000\000\011\164\000\000\000\000\011\160\000\000\006\246\011\176\000\000\011\170\000\000\007\006\000\000\011\172\000\000\011\174\000\000\000\000\000x\000\000\000\000\000|\000\000\000\000\000\128\000\000\000\132\000\000\011\170\000\000\011\172\000\000\000\000\000\158\000\000\000\162\000\000\000\000\000\166\000\000\000\170\000\000\000\000\011\186\011\176\000\000\007\014\011\190\000\174\000\000\011\192\000\000\000\000\000\000\011\182\000\000\007\016\011\198\000\000\011\198\000\000\007\018\000\000\011\200\000\000\011\202\000\000\000\178\007\020\000\204\000\208\000\000\000\212\000\000\000\000\000\000\011\192\000\000\007\022\011\208\000\000\000\216\000\000\007\024\000\000\000\220\000\000\000\224\000\000\000\000\000\250\007\026\000\254\001\002\000\000\001\006\000\000\000\000\000\000\011\196\000\000\007\030\011\212\000\000\001\n\000\000\007 \000\000\001\014\000\000\001(\000\000\000\000\011\214\011\202\000\000\007\"\011\218\000\000\011\218\001,\0072\0010\0014\000\000\0018\000\000\000\000\000\000\011\208\000\000\007:\011\224\000\000\001<\000\000\007<\000\000\001V\000\000\001Z\000\000\000\000\007>\000\000\011\224\001^\007@\001b\001f\000\000\001j\000\000\000\000\000\000\011\214\000\000\007B\011\230\000\000\001\132\000\000\007D\000\000\001\136\000\000\001\140\000\000\000\000\011\230\001\144\007F\001\148\001\152\000\000\001\178\000\000\000\000\000\000\011\220\000\000\007J\011\236\000\000\001\182\000\000\007L\000\000\001\186\000\000\001\190\000\000\000\000\000\000\007N\000\000\001\194\000\000\000\000\000\000\011\224\000\000\000\000\001\198\000\000\011\226\000\000\000\000\001\224\000\000\000\000\000\000\000\000\000\000\000\000\011\248\011\230\000\000\011\252\001\228\000\000\011\254\000\000\000\000\000\000\007^\000\000\001\232\000\000\000\000\001\236\000\000\001\240\000\000\000\000\011\236\000\000\007f\011\252\000\000\000\000\001\244\000\000\007h\000\000\000\000\002\014\000\000\000\000\002\018\000\000\002\022\000\000\000\000\002\026\000\000\000\000\000\000\002\030\000\000\002\"\000\000\000\000\002&\000\000\000\000\002@\000\000\000\000\000\000\000\000\000\000\012\004\000\000\007j\000\000\002D\000\000\000\000\0022\000\000\000\000\002L\000\000\000\000\011\242\000\000\000\000\002F\011\244\000\000\007l\012\002\002R\000\000\012\004\002X\000\000\000\000\011\250\000\000\011\252\000\000\011\254\000\000\000\000\002f\000\000\002j\012\000\000\000\000\000\000\000\012\b\000\000\002l\000\000\012\004\000\000\007n\012\020\000\000\002p\000\000\007p\000\000\002v\000\000\002\136\000\000\000\000\000\000\000\000\002\148\000\000\002\142\000\000\012\b\000\000\012\n\000\000\000\000\002\154\000\000\002\160\000\000\000\000\002\174\000\000\002\178\000\000\007r\002\180\002\192\000\000\002\198\000\000\000\000\000\000\012\012\000\000\007v\012\028\000\000\002\204\000\000\007x\000\000\002\208\000\000\002\210\000\000\000\000\002\228\007z\002\234\002\224\000\000\002\240\000\000\000\000\000\000\012\016\000\000\007\138\012 \000\000\002\244\000\000\007\146\000\000\003\004\000\000\003\b\000\000\000\000\012\"\012\022\000\000\007\148\012&\000\000\012&\003\014\007\150\003\020\003\"\000\000\003&\000\000\000\000\000\000\012\028\000\000\007\152\012,\000\000\003(\000\000\007\154\000\000\003,\000\000\0032\000\000\000\000\007\156\000\000\012,\003D\007\158\003F\003R\000\000\003V\000\000\000\000\000\000\012\"\000\000\007\162\0122\000\000\003X\000\000\007\164\000\000\003b\000\000\003r\000\000\000\000\0122\003t\007\166\003v\003\130\000\000\003\134\000\000\000\000\000\000\012(\000\000\007\182\0128\000\000\003\146\000\000\007\190\000\000\003\150\000\000\003\162\000\000\000\000\000\000\007\192\000\000\003\166\000\000\000\000\012,\000\000\000\000\003\178\000\000\000\000\003\182\000\000\000\000\012.\000\000\007\194\012>\000\000\000\000\003\194\000\000\007\196\000\000\000\000\003\198\000\000\000\000\003\210\000\000\003\214\000\000\000\000\000\000\000\000\003\226\000\000\003\230\000\000\000\000\000\000\007\232\000\000\007\238\000\000\000\000\000\000\000\000\000\000\007\242\000\000\000\000\000\000\000\000\007\236\000\000\000\000\007\244\000\000\000\000\000\000\000\000\007\246\000\000\000\000\000\000\003Z\000\000\000\000\b\000\n`\000\000\000\000\b\002\000\000\000\000\003\242\000\000\b\004\000\000\b\b\000\000\000\000\b\006\000\000\000\000\000\000\000\000\012R\000\000\012T\000\000\000\000\000\000\000\000\b\n\012r\000\000\000\000\0128\000\000\000\000\b\012\012v\000\000\000\000\012<\000\000\000\000\b\014\012z\000\000\000\000\012@\000\000\000\000\000\000\b\016\000\000\000\000\000\000\b\020\000\000\b\024\000\000\000\000\b\030\000\000\b$\003\246\000\000\b(\000\000\000\000\000\000\000\000\b2\000\000\000\000\000\000\000\000\b.\000\000\b0\004\000\000\000\b6\000\000\000\000\b<\000\000\000\000\bJ\000\000\bL\004\004\000\000\bN\000\000\000\000\000\000\000\000\000\000\bT\000\000\bV\004\016\000\000\bZ\000\000\000\000\012B\000\000\000\000\b^\000\000\000\000\000\000\b`\000\000\004\020\000\000\bf\000\000\bh\000\000\000\000\000\000\000\000\000\000\000\000\bl\000\000\bp\000\000\000\000\bn\000\000\br\004\030\000\000\bt\000\000\000\000\000\000\000\000\000\000\bv\000\000\bx\004\"\000\000\bz\000\000\000\000\b|\000\000\000\000\b\134\000\000\b\140\004.\000\000\b\150\000\000\000\000\000\000\000\000\000\000\b\152\000\000\b\158\0042\000\000\b\164\000\000\000\000\012D\000\000\000\000\b\176\000\000\000\000\000\000\b\178\000\000\004<\000\000\b\180\000\000\b\182\000\000\000\000\000\000\000\000\b\184\000\000\b\188\000\000\000\000\b\190\000\000\b\194\004@\000\000\b\196\000\000\000\000\000\000\000\000\000\000\b\198\000\000\b\200\004L\000\000\b\206\000\000\000\000\b\218\000\000\000\000\b\212\000\000\b\214\004P\000\000\b\220\000\000\000\000\000\000\000\000\000\000\b\222\000\000\b\224\004Z\000\000\b\226\000\000\000\000\012F\000\000\000\000\b\240\000\000\000\000\000\000\b\244\000\000\004^\000\000\b\254\000\000\t\000\000\000\000\000\000\000\012H\000\000\000\000\000\000\t\004\000\000\000\000\000\000\000\000\012J\000\000\000\000\000\000\t\006\000\000\012L\000\000\000\000\000\000\t\012\000\000\000\000\012N\000\000\000\000\000\000\t\014\000\000\012P\000\000\000\000\000\000\t\024\000\000\000\000\000\000\000\000\000\000\012R\000\000\000\000\t\026\000\000\000\000\012T\000\000\000\000\t\028\000\000\000\000\000\000\000\000\000\000\012V\000\000\000\000\t\030\000\000\000\000\012X\000\000\000\000\t \000\000\000\000\000\000\012z\000\000\000\000\000\000\t\"\000\000\000\000\t&\004j\000\000\t*\000\000\000\000\000\000\000\000\000\000\t,\000\000\t.\004n\000\000\t0\000\000\000\000\t<\000\000\012\152\000\000\000\000\000\000\t6\000\000\t>\004x\000\000\tD\000\000\000\000\000\000\000\000\t\\\000\000\000\000\000\000\tl\000\000\000\000\000\000\012\154\000\000\000\000\000\000\tH\000\000\tJ\004|\000\000\tX\000\000\000\000\012\156\000\000\000\000\000\000\th\000\000\tn\004\136\000\000\tp\000\000\000\000\000\000\000\000\000\000\000\000\004\140\000\000\tt\000\000\000\000\000\000\000\000\tz\000\000\000\000\004\150\000\000\t\128\000\000\000\000\000\000\000\000\004\154\000\000\t\130\000\000\000\000\t\132\000\000\000\000\004\166\000\000\t\134\000\000\000\000\000\000\000\000\004\170\000\000\t\136\000\000\000\000\t\138\004\180\000\000\t\144\000\000\000\000\000\000\000\000\000\000\t\146\000\000\t\148\004\184\000\000\t\150\000\000\000\000\t\160\000\000\012\158\000\000\000\000\000\000\t\154\000\000\t\158\004\196\000\000\t\166\000\000\000\000\000\000\000\000\012\160\000\000\000\000\000\000\t\172\000\000\t\174\004\200\000\000\t\176\000\000\000\000\012\162\000\000\000\000\000\000\t\178\000\000\t\184\004\210\000\000\t\192\000\000\000\000\000\000\t\194\000\000\000\000\t\204\000\000\t\208\004\214\000\000\t\212\000\000\000\000\000\000\000\000\000\000\t\216\000\000\t\220\004\226\000\000\t\222\000\000\000\000\t\232\000\000\012\164\000\000\000\000\000\000\t\234\000\000\t\238\004\230\000\000\t\240\000\000\000\000\000\000\000\000\012\166\000\000\000\000\000\000\t\246\000\000\t\248\004\240\000\000\t\250\000\000\000\000\000\000\n\002\000\000\000\000\000\000\t\252\000\000\012\168\000\000\000\000\000\000\t\254\000\000\n\006\004\244\000\000\n\n\000\000\000\000\000\000\000\000\000\142\000\000\000\000\003\138\000\000\000\000\000\000\n\014\000\000\012\170\000\000\000\000\n\020\000\000\000\000\000\000\n\022\000\000\000\000\004\030\000\000\000\000\n\024\000\000\012\172\000\000\000\000\n\026\000\000\000\000\000\000"), (16, "\001\022\001\022\001W\001W\001\022\004\029\001W\001\022\001\022\001W\001W\000\003\001\250\006\023\001[\001[\002\133\006\223\001[\001\169\001\\\001[\001[\001\206\002\133\001\245\002\194\003Q\001\022\000\004\001W\005\225\004t\005\216\004t\005\173\004t\005\161\004t\005\005\004t\001\228\001Z\002\133\000\005\002\133\001\231\002\133\001\229\002\133\001\221\002\133\004\239\004t\004q\004t\004{\004t\004\127\004t\004\129\004t\004\164\004t\002\133\000\149\002\133\000\149\002\133\000\149\002\133\001\213\002\133\t+\002\133\004\184\004t\004\204\004t\004\238\004t\004\241\004t\004\244\004t\004\246\004t\002\133\t/\002\133\000\149\002\133\001\022\002\133\001\178\002\133\000\147\002\133\004\253\004t\004\255\004t\005\002\004t\005\004\004t\005\012\004t\0054\004t\002\133\001\022\002\133\001\027\002\133\000\149\002\133\000\151\002\133\000\158\002\133\005%\004t\005\"\004t\005$\004t\005-\004t\0051\004t\0053\004t\002\133\000\140\002\133\000\149\002\133\000\149\002\133\000\156\002\133\000\162\002\133\005K\004t\005<\004t\0059\004t\005;\004t\005D\004t\005H\004t\002\133\001\223\002\133\000\149\002\133\000\149\002\133\000\176\002\133\000\184\002\133\005J\004t\005i\004t\005Z\004t\005W\004t\005Y\004t\005b\004t\002\133\001\215\002\133\000\149\002\133\000\149\002\133\000\182\002\133\000\188\002\133\005f\004t\005h\004t\005\131\004t\005t\004t\005q\004t\005s\004t\002\133\001\202\002\133\000\149\002\133\000\149\002\133\000\198\002\133\000\202\002\133\005|\004t\005\128\004t\005\130\004t\005\155\004t\005\140\004t\005\137\004t\002\133\001\201\002\133\000\149\002\133\000\149\002\133\000\225\002\133\000\233\002\133\005\139\004t\005\148\004t\005\152\004t\005\154\004t\005\160\004t\005\167\004t\002\133\001\192\002\133\000\149\002\133\000\149\002\133\000\231\002\133\000\237\002\133\005\172\004t\005\183\004t\005\191\004t\005\194\004t\005\196\004t\005\205\004t\002\133\001\181\002\133\000\149\002\133\000\149\002\133\001\022\002\133\001L\002\133\005\210\004t\005\213\004t\005\215\004t\005\218\004t\005\222\004t\005\224\004t\002\133\006\023\002\133\000=\002\133\006\216\002\133\006\023\002\133\000?\002\133\006\194\002\133\005\230\004t\005\240\004t\006\023\002\133\005\246\004t\006\188\006\001\004t\001m\002\133\006\023\002\133\002\133\001k\006O\002\133\006\014\004t\002\133\006\023\006\023\002\133\006\023\006&\006%\006\023\006\030\000\149\002\133\006\"\002\133\002\133\000\149\002\133\006\023\000C\002\133\006\023\006$\006)\004t\006+\0062\004t\001q\002\133\006\023\001\022\002\133\001R\0064\002\133\0067\004t\002\133\006\023\006\023\002\133\000E\0069\006@\006=\004t\000\149\002\133\006\023\002\133\002\133\006\023\006?\006\023\006\023\006H\002\133\006L\006N\002\133\006T\004t\002\133\006\023\002\133\002\133\006\023\006f\000\141\006\023\006W\006\023\002\133\006V\002\133\006_\001\022\002\133\001V\006\023\002\133\006\023\002\133\006c\006\023\006e\000r\006\023\006\132\000L\002\133\006u\002\133\006r\004t\002\133\006\023\006\023\002\133\006\023\006t\006}\006\023\006\129\007>\002\133\006\131\002\133\002\133\000\139\002\133\006\023\006\023\002\133\b\175\006\158\006\143\006\140\004t\000K\006\023\006\023\002\133\002\133\006\142\006\151\006\023\000r\t+\002\133\006\155\002\133\002\133\000q\006\023\006\023\006\023\002\133\006\157\006\182\006\167\006\164\004t\t.\006\023\002\133\002\133\002\133\006\166\000\130\006\023\000r\006\023\002\133\006\175\002\133\006\179\000\138\006\023\002F\006\023\002\133\006\181\002\133\006\187\001?\006\023\000r\006\023\002\133\006\193\002\133\006\196\000P\006\023\000r\006\023\002\133\006\205\002\133\006\210\0025\006\023\000r\006\023\002\133\006\213\002\133\006\215\006\220\004t\001\127\006\023\002\133\000V\002\133\006\222\007\005\004t\007:\004t\002\133\t+\002\133\007I\004t\007T\004t\000X\002\133\000\149\002\133\007_\004t\007m\004t\002\133\t>\002\133\007\128\004t\007\139\004t\000Z\002\133\0023\002\133\007\150\004t\007\161\004t\002\133\000\\\002\133\007\175\004t\007\192\004t\001\022\002\133\0028\002\133\007\203\004t\007\214\004t\002\133\0025\002\133\007\225\004t\007\239\004t\001\022\002\133\002<\002\133\bA\004t\bL\004t\002\133\000^\002\133\bZ\004t\bp\004t\000`\002\133\002E\002\133\b|\004t\b\133\004t\002\133\000b\002\133\b\143\004t\b\150\004t\000d\002\133\000f\002\133\b\158\004t\b\165\004t\002\133\0025\002\133\b\171\004t\b\182\004t\000h\002\133\000j\002\133\b\196\004t\b\210\004t\002\133\000t\002\133\b\222\004t\b\234\004t\001}\002\133\001\131\002\133\b\245\004t\t\003\004t\002\133\001\226\002\133\t\017\004t\t$\004t\001\239\002\133\001\143\002\133\000\149\001\146\000\149\001\237\002\133\001\143\002\133\001\243\001\145\000\149\004\024\003\242\004\015\004\014\004\005\000\149\004\001\003\241\003\232\000v\003\204\002\133\000\149\002\133\002\133\002\133\000\149\002\133\002\133\002\133\000\149\002\133\003\195\003\187\003\159\003\158\003\157\002\226\002\217\002\192\002\183\002\182\002\132\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\137\002\142\002\145\002\154\002\159\002\162\002\173\002\178\002\181\002\188\002\191\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\200\002\205\002\208\002\213\002\216\002\222\002\225\002\231\002\237\002\242\002\250\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\255\003\017\003\025\003!\003'\003,\0032\0037\003;\003A\003F\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\003O\003W\003\\\003a\003g\003l\003y\003~\003\135\003\140\003\151\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\002\133\003\156\003\164\003\163\003\167\003\169\003\175\003\174\003\178\003\183\003\209\003\186\002\133\003\214\002\133\002\133\003\189\003\194\002\133\002\133\002\133\000\149\002\133\003\200\000\149\000\149\003\203\002\133\002\133\000\149\003\208\003\212\000\149\003\220\002\133\003\219\003\223\002\133\003\228\003\231\003\237\002\133\002\133\003\240\003\245\003\247\002\133\002\133\003\253\002\133\002\133\002\133\000\149\000x\002\133\002\133\000{\003\252\004\000\004\004\004\n\004\r\004\020\004\023\000\149\004\028\004!\000\149\002\133\002\133\002\133\002\133\002\133\002\133\002\133\005L\002\133\002\133\004L\004\222\004f\004j\004\131\004x\004}\000~\002\133\004\135\004\140\004\147\002\133\002\133\002\133\002\133\002\133\002\133\000r\004\168\002\133\002\133\002\133\004\154\004\159\004\172\004\177\004\208\004\194\004\199\002\133\004\212\004\217\004\226\002\133\002\133\002\133\002\133\002\133\002\133\002\133\004\231\002\133\002\133\002\133\005\016\005\020\005\025\005&\005*\005/\005=\002\133\005A\005F\005P\002\133\002\133\002\133\002\133\002\133\002\133\002\133\005[\002\133\002\133\002\133\005_\005d\005k\005u\005y\005~\005\141\002\133\005\145\005\150\005\158\002\133\002\133\002\133\002\133\002\133\002\133\002\133\005\197\002\133\002\133\002\133\005\201\005\207\006\197\006g\006\027\006 \006A\002\133\006E\006J\006X\002\133\002\133\002\133\002\133\002\133\002\133\002\133\006\\\002\133\002\133\002\133\006a\006k\006v\006z\006\127\006\134\006\144\002\133\006\148\006\153\006\168\002\133\002\133\002\133\002\133\002\133\002\133\002\133\006\172\002\133\002\133\002\133\006\177\006\185\006\201\006\207\006\226\006\239\007.\002\133\007.\006\239\007.\002\133\002\133\002\133\002\133\007.\007>\007.\007.\007>\007.\007.\007.\007.\006\243\007.\b\129\007>\006\242\bE\007.\006\227\tG\007.\t(\007.\b\226\007B\007.\007.\007>\b\168\007.\b\128\b>\007>\b6\b'\b\024\007\245\007A\0072\007.\007.\007.\007X\0077\007.\007.\007=\007.\007<\007.\007.\007F\007L\007.\007.\007K\007.\007.\007>\007.\007.\007.\007.\007.\007>\007Q\007W\007V\007\132\007.\007\\\007b\007.\007a\007\154\007g\007k\007.\007.\007r\007q\007.\007x\007}\007.\007\131\007\130\007\136\007\142\007\141\007.\007.\007.\007.\007.\007\147\007>\007.\007\153\007.\007.\007.\007.\007\152\007\158\007.\007\196\007\164\007.\007.\007\163\007>\007.\007.\007.\007.\007\169\007\173\007\180\007\179\007\184\007\218\007.\007\189\007.\007\195\007\194\007\200\007\206\007.\007.\007\205\007.\007.\007\211\007\217\007.\007.\007\216\007\222\007\228\007\227\007.\007.\007.\007.\007.\007.\007\233\007.\007\237\007.\007.\007.\007.\007\244\007\243\007.\007\251\b\004\b^\007.\b\n\b\017\007.\bf\007.\007.\b\023\b \b&\b/\b5\b=\007.\bD\b^\bC\bI\bO\bN\ba\007.\bW\b^\007.\007.\b]\007.\be\b\\\007>\bm\bs\007.\007.\007>\007.\007.\007.\br\b\146\007.\007.\007.\007.\b\161\007.\by\007.\b^\b\127\b~\007.\b\135\b\200\007.\007.\007.\007.\b\145\b\152\007.\b\160\b\167\b\174\007.\007>\b\173\b\179\b\185\b\184\007.\b\193\007.\b\199\007.\b\238\007.\b\198\007.\007.\b\207\b\213\b\212\b\219\b^\007.\b\225\007.\007.\t\007\b\224\007.\007.\007.\007.\007.\b\231\006\239\b\237\007.\b\236\007.\b\242\007.\b\248\b\247\007.\007.\007.\007.\000\128\t\000\000\132\t\006\t\005\000\134\t\023\t\014\t\020\t\019\t\027\t!\000\136\001\177\001\176\t'\000\195\t&\000\210\t2\000\212\000\218\t7\t;\tA\tF\000\214\000\216\000\217\000\220\000\249\001\168\001\159\001\148\001\141\001\019\001\024\001 \001$\001&\001(\001*\001,\001.\0010\0012\0014\0016\0018\001:\001<\001B\001D\001G\001J\001N\001P\001T\001\135\001f\001x\001\137\001\140\001\155\001\161\001\164\001\188\001\194\001\197\001\217\001\218\001\220\001\252\002\001\002\003\002\r\004\021\002\017\004\002\003\238\002\"\003\229\002)\002A\003\201\002K\003\184\002S\002V\002]\002a\002\223\002f\002j\002\214\002n\002\189\002s\002v\002\163\002\127\002\143\002\130\002\135\002\140\002\149\002\160\002\152\002\157\002\165\002\168\002\179\002\171\002\176\002\186\002\206\002\198\002\203\002\211\002\220\002\229\002\235\002\240\002\248\002\253\003\012\003\011\003\n\003\t\003\015\003\020\003\023\003\028\003\031\003%\003*\0030\0035\0039\003?\003D\003I\003M\003U\003Z\003_\003e\003j\003\141\003t\003w\003|\003\130\003\133\003\138\003\143\003\146\003\149\003\154\003\181\003\198\003\226\003\235\004\007\004\018\004)\0055\0040\0042\0044\0048\004\236\004b\004a\004`\004_\004^\004]\004\\\004[\004Z\004Y\004X\004W\004d\004l\004h\004k\004\145\004\130\004s\004v\004y\004\133\004\136\004\138\004\142\004\144\004\149\004\152\004\155\004\157\004\161\004\167\004\166\004\170\004\173\004\175\004\179\004\181\004\187\004\186\004\189\004\192\004\195\004\197\004\201\004\207\004\206\004\210\004\213\004\215\004\219\004\221\004\224\004\227\004\229\004\233\004\235\004\248\004\250\005\030\005\b\005\015\005\014\005\018\005\021\005\023\005\027\005\029\005(\005+\005?\005B\005\156\005N\005Q\005S\005]\005`\005m\005w\005z\005\133\005\143\005\146\005\164\005\169\005\187\005\180\005\186\005\185\005\199\005\202\005\236\005\249\005\253\006P\006\003\006\007\006\t\006\011\006\017\006\021\006\025\006\028\006-\006/\006C\006F\006Z\006]\006\183\006i\006l\006n\006x\006{\006\136\006\146\006\149\006\160\006\170\006\173\006\190\006\199\006\202\007\020\007\019\007\025\007\028\007 \007#\007'\007*\007d\007\166\007\230\007\247\b\000\b\006\b\r\b\019\b\029\b#\b,\b2\b9\bS\bi\bu\b\189\b\203\b\215\b\252\t\n\t\029\t4\tC"))
  
  and semantic_action =
    [|
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.expr) = 
# 205 "<standard.mly>"
    ( x )
# 815 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 87 "asllib/Parser0.mly"
       (bool)
# 836 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 401 "asllib/Parser0.mly"
                       AST.L_Bool        
# 848 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 854 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 863 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Z.t)
# 885 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 402 "asllib/Parser0.mly"
                       AST.L_Int         
# 897 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 903 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 912 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 86 "asllib/Parser0.mly"
       (Q.t)
# 934 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 403 "asllib/Parser0.mly"
                       AST.L_Real        
# 946 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 952 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 961 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (Bitvector.t)
# 983 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 404 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 995 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 1001 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1010 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1032 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 405 "asllib/Parser0.mly"
                       AST.L_String      
# 1044 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 1050 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1059 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1093 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 1099 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1111 "asllib/Parser0.ml"
              
            in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1117 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1126 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1148 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1159 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1168 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 1196 "asllib/Parser0.ml"
             in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1201 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1210 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1258 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 1264 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 1274 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 1280 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1285 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1293 "asllib/Parser0.ml"
              
            in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1299 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1308 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1363 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 1369 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 1379 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1387 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1395 "asllib/Parser0.ml"
              
            in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1401 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1410 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1446 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 1456 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 1462 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1467 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1474 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1483 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1526 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 1536 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1544 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1551 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1560 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 1602 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 1608 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1613 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 1619 "asllib/Parser0.ml"
             in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1624 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1633 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 1682 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1690 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 1696 "asllib/Parser0.ml"
             in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1701 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1710 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1772 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 1778 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 1789 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1794 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 1801 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1806 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1814 "asllib/Parser0.ml"
              
            in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1820 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1829 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.expr list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1898 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 1904 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1917 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 1924 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1929 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1937 "asllib/Parser0.ml"
              
            in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1943 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1952 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 2021 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 2027 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 2038 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2043 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2052 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 2060 "asllib/Parser0.ml"
              
            in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2066 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2075 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 2151 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 2157 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined4 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2170 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2179 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 2187 "asllib/Parser0.ml"
              
            in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2193 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2202 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 2252 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 2263 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2268 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 2275 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2280 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2287 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2296 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.expr list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 2353 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2366 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 2373 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2378 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2385 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2394 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 2451 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 2462 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2467 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2476 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2483 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2492 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 2556 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined4 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2569 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2578 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2585 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2594 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 2651 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2656 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 2663 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2668 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 2674 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2679 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2688 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.expr list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2754 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 2761 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2766 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 2772 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2777 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2786 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 2850 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2855 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2864 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 2870 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2875 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2884 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined4 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2957 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2966 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 2972 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2977 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2986 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 772 "asllib/Parser0.mly"
            ( AST.BNOT )
# 3021 "asllib/Parser0.ml"
             in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 3026 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3035 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 773 "asllib/Parser0.mly"
            ( AST.NEG )
# 3070 "asllib/Parser0.ml"
             in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 3075 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3084 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 774 "asllib/Parser0.mly"
            ( AST.NOT )
# 3119 "asllib/Parser0.ml"
             in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 3124 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3133 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 779 "asllib/Parser0.mly"
                 ( AST.AND    )
# 3175 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3180 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3189 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 780 "asllib/Parser0.mly"
                 ( AST.BAND   )
# 3231 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3236 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3245 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 781 "asllib/Parser0.mly"
                 ( AST.BOR    )
# 3287 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3292 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3301 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 782 "asllib/Parser0.mly"
                 ( AST.DIV    )
# 3343 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3348 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3357 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 783 "asllib/Parser0.mly"
                 ( AST.EOR    )
# 3399 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3404 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3413 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 784 "asllib/Parser0.mly"
                 ( AST.EQ_OP  )
# 3455 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3460 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3469 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 785 "asllib/Parser0.mly"
                 ( AST.NEQ    )
# 3511 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3516 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3525 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 786 "asllib/Parser0.mly"
                 ( AST.GEQ    )
# 3567 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3572 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3581 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 787 "asllib/Parser0.mly"
                 ( AST.IMPL   )
# 3623 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3628 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3637 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 788 "asllib/Parser0.mly"
                 ( AST.LEQ    )
# 3679 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3684 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3693 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 789 "asllib/Parser0.mly"
                 ( AST.PLUS   )
# 3735 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3740 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3749 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 790 "asllib/Parser0.mly"
                 ( AST.MINUS  )
# 3791 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3796 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3805 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 791 "asllib/Parser0.mly"
                 ( AST.MOD    )
# 3847 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3852 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3861 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 792 "asllib/Parser0.mly"
                 ( AST.MUL    )
# 3903 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3908 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3917 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 793 "asllib/Parser0.mly"
                 ( AST.OR     )
# 3959 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3964 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3973 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 794 "asllib/Parser0.mly"
                 ( AST.RDIV   )
# 4015 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 4020 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4029 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 795 "asllib/Parser0.mly"
                 ( AST.SHL    )
# 4071 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 4076 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4085 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 796 "asllib/Parser0.mly"
                 ( AST.SHR    )
# 4127 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 4132 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4141 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 776 "asllib/Parser0.mly"
                                  ( AST.PLUS )
# 4183 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 4188 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4197 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 804 "asllib/Parser0.mly"
                 ( AST.LT     )
# 4239 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 4244 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4253 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 805 "asllib/Parser0.mly"
                 ( AST.GT     )
# 4295 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 4300 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4309 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.expr) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 4369 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 4375 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 373 "asllib/Parser0.mly"
                                                        AST.E_Tuple      
# 4382 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4391 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = c;
                    MenhirLib.EngineTypes.startp = _startpos_c_;
                    MenhirLib.EngineTypes.endp = _endpos_c_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let desc =
            let e_else =
              let _1 = _1_inlined1 in
              let _1_1 = _1 in
              
# 393 "asllib/Parser0.mly"
                                                build_expr_conds  
# 4464 "asllib/Parser0.ml"
               (_1_1, expr)
            in
            
# 374 "asllib/Parser0.mly"
                                                        AST.E_Cond       
# 4470 "asllib/Parser0.ml"
             (c, e, e_else)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4479 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 4513 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 375 "asllib/Parser0.mly"
                                                        AST.E_GetField   
# 4526 "asllib/Parser0.ml"
             (e, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4535 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 4585 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 4590 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 376 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 4597 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4606 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 4664 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 376 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 4671 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4680 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 4723 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 4728 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 377 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 4735 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4744 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 4795 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 377 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 4802 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4811 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 4847 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 4852 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 378 "asllib/Parser0.mly"
                                                        make_concat      
# 4859 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4868 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 4912 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 378 "asllib/Parser0.mly"
                                                        make_concat      
# 4919 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4928 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let bpattern =
              let desc =
                let x =
                  let _1 = _1_inlined1 in
                  let _1_1 = _1 in
                  
# 747 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 4989 "asllib/Parser0.ml"
                   _1_1
                in
                
# 205 "<standard.mly>"
    ( x )
# 4995 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5004 "asllib/Parser0.ml"
              
            in
            
# 379 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 5010 "asllib/Parser0.ml"
             (e, bpattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5019 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 5053 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern_mask =
              let desc =
                let _1_1 = _1 in
                
# 734 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 5068 "asllib/Parser0.ml"
                 _1_1
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5077 "asllib/Parser0.ml"
              
            in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 5083 "asllib/Parser0.ml"
             (e, pattern_mask)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5092 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1_inlined1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 5126 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let desc =
            let _2 =
              let desc =
                let pm =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let _1_1 = _1 in
                    
# 734 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 5144 "asllib/Parser0.ml"
                     _1_1
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5153 "asllib/Parser0.ml"
                  
                in
                
# 381 "asllib/Parser0.mly"
                                                     AST.Pattern_Not  
# 5159 "asllib/Parser0.ml"
                 pm
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5168 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 381 "asllib/Parser0.mly"
                                                                           AST.E_Pattern  
# 5175 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5184 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 5220 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5228 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5235 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5244 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 5280 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5288 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5295 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5304 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 5340 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5348 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5355 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5364 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 5393 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let tident = _1 in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 5406 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5415 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5422 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5431 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 5472 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 5478 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let tident =
                  let i = _1 in
                  
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 5493 "asllib/Parser0.ml"
                  
                in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 5499 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5508 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5515 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5524 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 5560 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5568 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5575 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5584 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 5642 "asllib/Parser0.ml"
                 in
                
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 5647 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5656 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5663 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5672 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 5754 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 5760 "asllib/Parser0.ml"
                 in
                
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 5765 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5774 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5781 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5790 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 5849 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 5856 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5865 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5872 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5881 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 5943 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 5964 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 5972 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5981 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5988 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5997 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 6071 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 6077 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 6099 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 6107 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6115 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6124 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 6131 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6140 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 6234 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6242 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6251 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 6258 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6267 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6303 "asllib/Parser0.ml"
               in
              let _1 = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 6308 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6315 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6324 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 6358 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6371 "asllib/Parser0.ml"
               in
              let _1 = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 6376 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6383 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6392 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6428 "asllib/Parser0.ml"
               in
              let _1 = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 6433 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6440 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6449 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 6483 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6496 "asllib/Parser0.ml"
               in
              let _1 = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 6501 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6508 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6517 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6553 "asllib/Parser0.ml"
               in
              let _1 = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 6558 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6565 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6574 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 6608 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6621 "asllib/Parser0.ml"
               in
              let _1 = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 6626 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6633 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6642 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 6671 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6682 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 6689 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6697 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6706 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 6740 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 6746 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6757 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 6764 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6772 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6781 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 6822 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 6828 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6839 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 6848 "asllib/Parser0.ml"
                  
                in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 6854 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6862 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6871 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 6917 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 6923 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 6929 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6940 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 6949 "asllib/Parser0.ml"
                  
                in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 6955 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6963 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6972 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7008 "asllib/Parser0.ml"
               in
              let _1 = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 7013 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7020 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7029 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 7063 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 7076 "asllib/Parser0.ml"
               in
              let _1 = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 7081 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7088 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7097 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7154 "asllib/Parser0.ml"
               in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 7160 "asllib/Parser0.ml"
                 in
                
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 7165 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7173 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7182 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 7234 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 7252 "asllib/Parser0.ml"
                
              in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 7259 "asllib/Parser0.ml"
                 in
                
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 7264 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7272 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7281 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7359 "asllib/Parser0.ml"
               in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 7368 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 7374 "asllib/Parser0.ml"
                 in
                
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 7379 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7387 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7396 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 7466 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 7487 "asllib/Parser0.ml"
                
              in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 7497 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 7503 "asllib/Parser0.ml"
                 in
                
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 7508 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7516 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7525 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7582 "asllib/Parser0.ml"
               in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 7589 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7596 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7604 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7613 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 7665 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 7683 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 7691 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7698 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7706 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7715 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 7777 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7790 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7804 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7812 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7820 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7829 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 7893 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 7902 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 7915 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7929 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7937 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7945 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7954 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 8028 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 8034 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 8047 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 8061 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 8069 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 8077 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 8085 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8094 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 8170 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 8179 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 8185 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 8198 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 8212 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 8220 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 8228 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 8236 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8245 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 8330 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 8344 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 8352 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 8360 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8369 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 8445 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 8465 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 8479 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 8487 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 8495 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8504 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc = 
# 359 "asllib/Parser0.mly"
          ( AST.E_Binop (BV_CONCAT, e1, e2) )
# 8545 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8553 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 673 "asllib/Parser0.mly"
                    ( AST.LE_Discard )
# 8580 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8588 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 8622 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 8628 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 8640 "asllib/Parser0.ml"
              
            in
            
# 672 "asllib/Parser0.mly"
                             AST.LE_Var  
# 8646 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8655 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 8677 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 672 "asllib/Parser0.mly"
                             AST.LE_Var  
# 8688 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8697 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 8725 "asllib/Parser0.ml"
             in
            
# 672 "asllib/Parser0.mly"
                             AST.LE_Var  
# 8730 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8739 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 8782 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 8787 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 680 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 8794 "asllib/Parser0.ml"
             (lexpr, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8803 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = lexpr;
                MenhirLib.EngineTypes.startp = _startpos_lexpr_;
                MenhirLib.EngineTypes.endp = _endpos_lexpr_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 8854 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 680 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 8861 "asllib/Parser0.ml"
             (lexpr, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8870 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _3 = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 8912 "asllib/Parser0.ml"
             in
            let _3_1 = _3 in
            
# 681 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 8918 "asllib/Parser0.ml"
             (lexpr, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8927 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = lexpr;
                MenhirLib.EngineTypes.startp = _startpos_lexpr_;
                MenhirLib.EngineTypes.endp = _endpos_lexpr_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _3 = _1 in
            let _3_1 = _3 in
            
# 681 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 8978 "asllib/Parser0.ml"
             (lexpr, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8987 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.lexpr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 9031 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 682 "asllib/Parser0.mly"
                                                 AST.LE_Destructuring  
# 9038 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9047 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 9081 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 683 "asllib/Parser0.mly"
                                                 AST.LE_SetField     
# 9094 "asllib/Parser0.ml"
             (lexpr, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9103 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = l;
                MenhirLib.EngineTypes.startp = _startpos_l_;
                MenhirLib.EngineTypes.endp = _endpos_l_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let l : (AST.lexpr) = Obj.magic l in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_l_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let f =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 9153 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 9158 "asllib/Parser0.ml"
              
            in
            
# 684 "asllib/Parser0.mly"
                                               ( AST.LE_SetFields (l, f, []) )
# 9164 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_l_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9173 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = l;
                  MenhirLib.EngineTypes.startp = _startpos_l_;
                  MenhirLib.EngineTypes.endp = _endpos_l_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let l : (AST.lexpr) = Obj.magic l in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_l_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let f =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 9231 "asllib/Parser0.ml"
              
            in
            
# 684 "asllib/Parser0.mly"
                                               ( AST.LE_SetFields (l, f, []) )
# 9237 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_l_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9246 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.lexpr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 = 
# 673 "asllib/Parser0.mly"
                    ( AST.LE_Discard )
# 9288 "asllib/Parser0.ml"
             in
            let _1 =
              let _1 =
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 9296 "asllib/Parser0.ml"
                
              in
              ()
            in
            _2
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9309 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (unit list) = 
# 216 "<standard.mly>"
    ( [] )
# 9328 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let x : unit = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (unit list) = 
# 219 "<standard.mly>"
    ( x :: xs )
# 9360 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.case_alt list) = 
# 216 "<standard.mly>"
    ( [] )
# 9378 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 9452 "asllib/Parser0.ml"
                 _3_1
              in
              let where = 
# 729 "asllib/Parser0.mly"
    ( None )
# 9458 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9467 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9476 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9482 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9491 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9497 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 9597 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 9604 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9613 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 9619 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9628 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9636 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 9642 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9651 "asllib/Parser0.ml"
                
              in
              let where = 
# 729 "asllib/Parser0.mly"
    ( None )
# 9657 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9666 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9675 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9681 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9690 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9696 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9815 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 9821 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 9829 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9838 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 9844 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9853 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9861 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 9867 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9876 "asllib/Parser0.ml"
                
              in
              let where = 
# 729 "asllib/Parser0.mly"
    ( None )
# 9882 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9891 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9900 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9906 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9915 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9921 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9982 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 9988 "asllib/Parser0.ml"
                
              in
              let where = 
# 729 "asllib/Parser0.mly"
    ( None )
# 9994 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10003 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10012 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10018 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10027 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10033 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 10085 "asllib/Parser0.ml"
                
              in
              let where = 
# 729 "asllib/Parser0.mly"
    ( None )
# 10091 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10100 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10109 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10115 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10124 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10130 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 10212 "asllib/Parser0.ml"
                 _3_1
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 10218 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10227 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10236 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10242 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10251 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10257 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 10364 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 10371 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10380 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 10386 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10395 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10403 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 10409 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10418 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 10424 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10433 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10442 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10448 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10457 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10463 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10589 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 10595 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 10603 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10612 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 10618 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10627 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10635 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 10641 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10650 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 10656 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10665 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10674 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10680 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10689 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10695 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10763 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 10769 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 10775 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10784 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10793 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10799 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10808 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10814 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 10873 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 10879 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10888 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10897 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10903 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10912 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10918 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined2, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 11014 "asllib/Parser0.ml"
                 _3_1
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11024 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11034 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11043 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11049 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11058 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11064 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined4_, _startpos__1_inlined3_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 11185 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11192 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11201 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11207 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11216 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11224 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 11230 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11239 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11249 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11259 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11268 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11274 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11283 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11289 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined4_, _startpos__1_inlined3_, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11429 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 11435 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11443 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11452 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11458 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11467 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11475 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 11481 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11490 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11500 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11510 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11519 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11525 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11534 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11540 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined3 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11622 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 11628 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11638 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11648 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11657 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11663 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11672 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11678 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined3 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 11751 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11761 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11771 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11780 "asllib/Parser0.ml"
                
              in
              
# 721 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11786 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11795 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11801 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 11891 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11898 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11907 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11913 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11922 "asllib/Parser0.ml"
                
              in
              let where = 
# 729 "asllib/Parser0.mly"
    ( None )
# 11928 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11937 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11946 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11952 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11961 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11967 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12076 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 12082 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12090 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12099 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12105 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12114 "asllib/Parser0.ml"
                
              in
              let where = 
# 729 "asllib/Parser0.mly"
    ( None )
# 12120 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 12129 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12138 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 12144 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12153 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12159 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 12256 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12263 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12272 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12278 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12287 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 12293 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 12302 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12311 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 12317 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12326 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12332 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12448 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 12454 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12462 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12471 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12477 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12486 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 12492 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 12501 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12510 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 12516 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12525 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12531 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 12642 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12649 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12658 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12664 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12673 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 12683 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 12693 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12702 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 12708 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12717 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12723 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12853 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 12859 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12867 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12876 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12882 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12891 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 12901 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 736 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 12911 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12920 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 12926 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12935 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12941 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = desc;
                    MenhirLib.EngineTypes.startp = _startpos_desc_;
                    MenhirLib.EngineTypes.endp = _endpos_desc_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 13008 "asllib/Parser0.ml"
                 _3_1
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13017 "asllib/Parser0.ml"
                
              in
              
# 725 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 13023 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__4_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13032 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13038 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = desc;
                          MenhirLib.EngineTypes.startp = _startpos_desc_;
                          MenhirLib.EngineTypes.endp = _endpos_desc_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 13130 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 13137 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 13146 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 13152 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13161 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 13169 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 13175 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13184 "asllib/Parser0.ml"
                
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13193 "asllib/Parser0.ml"
                
              in
              
# 725 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 13199 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__6_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13208 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13214 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = desc;
                              MenhirLib.EngineTypes.startp = _startpos_desc_;
                              MenhirLib.EngineTypes.endp = _endpos_desc_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 13325 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 13331 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 13339 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 13348 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 13354 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13363 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 13371 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 13377 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13386 "asllib/Parser0.ml"
                
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13395 "asllib/Parser0.ml"
                
              in
              
# 725 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 13401 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__6_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13410 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13416 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = desc;
                MenhirLib.EngineTypes.startp = _startpos_desc_;
                MenhirLib.EngineTypes.endp = _endpos_desc_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 13469 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 13475 "asllib/Parser0.ml"
                
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13484 "asllib/Parser0.ml"
                
              in
              
# 725 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 13490 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__2_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13499 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13505 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = desc;
              MenhirLib.EngineTypes.startp = _startpos_desc_;
              MenhirLib.EngineTypes.endp = _endpos_desc_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1 : unit = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt = 
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 13548 "asllib/Parser0.ml"
               in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13556 "asllib/Parser0.ml"
                
              in
              
# 725 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 13562 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__1_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13571 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13577 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.decl option list) = 
# 216 "<standard.mly>"
    ( [] )
# 13596 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 13676 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 13682 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 13705 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 412 "asllib/Parser0.mly"
                ( AST.GDK_Constant  )
# 13711 "asllib/Parser0.ml"
                   in
                  
# 420 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13721 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13730 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 13736 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13742 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13748 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 13817 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1_inlined1 in
                  let gdk = 
# 412 "asllib/Parser0.mly"
                ( AST.GDK_Constant  )
# 13837 "asllib/Parser0.ml"
                   in
                  
# 420 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13847 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13856 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 13862 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13868 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13874 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 349 "asllib/Parser0.mly"
              ( "record" )
# 13960 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 412 "asllib/Parser0.mly"
                ( AST.GDK_Constant  )
# 13966 "asllib/Parser0.ml"
                   in
                  
# 420 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13976 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13985 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 13991 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13997 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14003 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 14084 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 14090 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 14113 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 413 "asllib/Parser0.mly"
                ( AST.GDK_Config    )
# 14119 "asllib/Parser0.ml"
                   in
                  
# 420 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 14129 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14138 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14144 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14150 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14156 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 14225 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1_inlined1 in
                  let gdk = 
# 413 "asllib/Parser0.mly"
                ( AST.GDK_Config    )
# 14245 "asllib/Parser0.ml"
                   in
                  
# 420 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 14255 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14264 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14270 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14276 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14282 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 349 "asllib/Parser0.mly"
              ( "record" )
# 14368 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 413 "asllib/Parser0.mly"
                ( AST.GDK_Config    )
# 14374 "asllib/Parser0.ml"
                   in
                  
# 420 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 14384 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14393 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14399 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14405 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14411 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 14486 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 14492 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 14513 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 414 "asllib/Parser0.mly"
                ( AST.GDK_Var       )
# 14519 "asllib/Parser0.ml"
                   in
                  
# 420 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 14529 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14538 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14544 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14550 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14556 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 14619 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1 in
                  let gdk = 
# 414 "asllib/Parser0.mly"
                ( AST.GDK_Var       )
# 14638 "asllib/Parser0.ml"
                   in
                  
# 420 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 14648 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14657 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14663 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14669 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14675 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : unit = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 14752 "asllib/Parser0.ml"
                   in
                  let gdk = 
# 414 "asllib/Parser0.mly"
                ( AST.GDK_Var       )
# 14757 "asllib/Parser0.ml"
                   in
                  
# 420 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 14767 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14776 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14782 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14788 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14794 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 14855 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 14861 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 14882 "asllib/Parser0.ml"
                    
                  in
                  
# 427 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 14893 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14902 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14908 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14914 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14920 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = ty;
                  MenhirLib.EngineTypes.startp = _startpos_ty_;
                  MenhirLib.EngineTypes.endp = _endpos_ty_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 14969 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1 in
                  
# 427 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 14993 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15002 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 15008 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15014 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15020 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = ty;
                  MenhirLib.EngineTypes.startp = _startpos_ty_;
                  MenhirLib.EngineTypes.endp = _endpos_ty_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 15083 "asllib/Parser0.ml"
                   in
                  
# 427 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 15093 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15102 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 15108 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15114 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15120 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 15208 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 15214 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 15237 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 15246 "asllib/Parser0.ml"
                    
                  in
                  
# 434 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 15258 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15267 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 15273 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15279 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15285 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 15387 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 15393 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let (_2_inlined1, _2) = (_2_inlined2, _2_inlined1) in
              let x =
                let desc =
                  let e =
                    let (_2, _1_inlined1) = (_2_inlined1, _1_inlined3) in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 15419 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 15428 "asllib/Parser0.ml"
                    
                  in
                  
# 434 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 15440 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15449 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 15455 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15461 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15467 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 15543 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 15565 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 434 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 15578 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15587 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 15593 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15599 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15605 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 15695 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 15721 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 434 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 15734 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15743 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 15749 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15755 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15761 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 15855 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 349 "asllib/Parser0.mly"
              ( "record" )
# 15863 "asllib/Parser0.ml"
                    
                  in
                  
# 434 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 15875 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15884 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 15890 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15896 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15902 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 16014 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 349 "asllib/Parser0.mly"
              ( "record" )
# 16022 "asllib/Parser0.ml"
                    
                  in
                  
# 434 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 16034 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16043 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 16049 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 16055 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16061 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 16150 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 16156 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16173 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 16180 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 16185 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 16193 "asllib/Parser0.ml"
                  
                in
                
# 446 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 16199 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16208 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 16214 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16220 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 16316 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 16322 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16339 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16348 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 16356 "asllib/Parser0.ml"
                  
                in
                
# 446 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 16362 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16371 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 16377 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16383 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 16460 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16477 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 16484 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 16489 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 446 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 16496 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16505 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 16511 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16517 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 16601 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16618 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16627 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 446 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 16634 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16643 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 16649 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16655 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16745 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 16752 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 16757 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 16763 "asllib/Parser0.ml"
                 in
                
# 446 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 16768 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16777 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 16783 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16789 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16886 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16895 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 16901 "asllib/Parser0.ml"
                 in
                
# 446 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 16906 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16915 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 16921 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16927 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 17022 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 17028 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined2, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 17046 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 17053 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 17058 "asllib/Parser0.ml"
                  
                in
                let name =
                  let (_1, _2) = (_1_inlined1, _2_inlined1) in
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17067 "asllib/Parser0.ml"
                  
                in
                
# 450 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 17073 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 17082 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 17088 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17094 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 17196 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 17202 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined2, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 17220 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 17229 "asllib/Parser0.ml"
                  
                in
                let name =
                  let (_1, _2) = (_1_inlined1, _2_inlined1) in
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17238 "asllib/Parser0.ml"
                  
                in
                
# 450 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 17244 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 17253 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 17259 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17265 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 17348 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 17366 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 17373 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 17378 "asllib/Parser0.ml"
                  
                in
                let name = _1_inlined1 in
                
# 450 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 17385 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 17394 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 17400 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17406 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 17496 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 17514 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 17523 "asllib/Parser0.ml"
                  
                in
                let name = _1_inlined1 in
                
# 450 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 17530 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 17539 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 17545 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17551 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 17648 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 17655 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 17660 "asllib/Parser0.ml"
                  
                in
                let name =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
              ( "record" )
# 17668 "asllib/Parser0.ml"
                  
                in
                
# 450 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 17674 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 17683 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 17689 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17695 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 17799 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 17808 "asllib/Parser0.ml"
                  
                in
                let name =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
              ( "record" )
# 17816 "asllib/Parser0.ml"
                  
                in
                
# 450 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 17822 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 17831 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 17837 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17843 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 17911 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 17917 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17929 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 17935 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17940 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17948 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 17954 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 17961 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17967 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = x;
                          MenhirLib.EngineTypes.startp = _startpos_x_;
                          MenhirLib.EngineTypes.endp = _endpos_x_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 18042 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 18048 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 18062 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 18069 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 18074 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 18082 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 18088 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 18095 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18101 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = x;
                          MenhirLib.EngineTypes.startp = _startpos_x_;
                          MenhirLib.EngineTypes.endp = _endpos_x_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 18176 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 18182 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 18194 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 18202 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 18210 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 18216 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 18223 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18229 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = x;
                            MenhirLib.EngineTypes.startp = _startpos_x_;
                            MenhirLib.EngineTypes.endp = _endpos_x_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 18311 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 18317 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 18331 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 18340 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 18348 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 18354 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 18361 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18367 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 18423 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 18435 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 18441 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 18446 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 18453 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 18460 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18466 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 18529 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 18543 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 18550 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 18555 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 18562 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 18569 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18575 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 18638 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 18650 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 18658 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 18665 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 18672 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18678 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 18748 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 18762 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 18771 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 18778 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 18785 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18791 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 18855 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 18861 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 18866 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 18872 "asllib/Parser0.ml"
               in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 18877 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 18884 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18890 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 18963 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 18970 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 18975 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 18981 "asllib/Parser0.ml"
               in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 18986 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 18993 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18999 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 19070 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19078 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 19084 "asllib/Parser0.ml"
               in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 19089 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 19096 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19102 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 19182 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19191 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 19197 "asllib/Parser0.ml"
               in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 19202 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 19209 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19215 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 19298 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 19304 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 19320 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 19327 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 19332 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19340 "asllib/Parser0.ml"
                  
                in
                
# 573 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            builtin = false;
          }
        )
# 19363 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 19372 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 19378 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19384 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 19474 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 19480 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 19496 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 19505 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19513 "asllib/Parser0.ml"
                  
                in
                
# 573 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            builtin = false;
          }
        )
# 19536 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 19545 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 19551 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19557 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 19628 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 19644 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 19651 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 19656 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 573 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            builtin = false;
          }
        )
# 19680 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 19689 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 19695 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19701 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 19779 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 19795 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 19804 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 573 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            builtin = false;
          }
        )
# 19828 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 19837 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 19843 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19849 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 19932 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 19939 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 19944 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 19950 "asllib/Parser0.ml"
                 in
                
# 573 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            builtin = false;
          }
        )
# 19972 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 19981 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 19987 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19993 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20083 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 20092 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 20098 "asllib/Parser0.ml"
                 in
                
# 573 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            builtin = false;
          }
        )
# 20120 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 20129 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 20135 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20141 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 20203 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 20209 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 20220 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 20226 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 20231 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20240 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 20248 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20254 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 20323 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 20329 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 20340 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 20346 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 20351 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20360 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 20368 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20374 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 20443 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 20449 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 20460 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20468 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20477 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 20485 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20491 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 20567 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 20573 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 20584 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20592 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20601 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 20609 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20615 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 20665 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 20676 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 20682 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 20687 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 20695 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20701 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 20758 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 20769 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 20775 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 20780 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 20788 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20794 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 20851 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 20862 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20870 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 20878 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20884 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 20948 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 20959 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20967 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 20975 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20981 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 21038 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 21044 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 21049 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 21055 "asllib/Parser0.ml"
               in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 21062 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21068 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 21132 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 21138 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 21143 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 21149 "asllib/Parser0.ml"
               in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 21156 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21162 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 21226 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 21234 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 21240 "asllib/Parser0.ml"
               in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 21247 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21253 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 21324 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 21332 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 21338 "asllib/Parser0.ml"
               in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 21345 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21351 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 21426 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 21432 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21449 "asllib/Parser0.ml"
                   _3_1
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 21457 "asllib/Parser0.ml"
                  
                in
                
# 459 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptyGetter
        and recurse_limit = None
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 21481 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21490 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 21496 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21502 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 21565 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21582 "asllib/Parser0.ml"
                   _3_1
                in
                let name = _1 in
                
# 459 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptyGetter
        and recurse_limit = None
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 21607 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21616 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 21622 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21628 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21704 "asllib/Parser0.ml"
                   _3_1
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 21710 "asllib/Parser0.ml"
                 in
                
# 459 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptyGetter
        and recurse_limit = None
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 21733 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21742 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 21748 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21754 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 21843 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 21849 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined2, _2_inlined1, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21866 "asllib/Parser0.ml"
                   _3_1
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 21874 "asllib/Parser0.ml"
                  
                in
                
# 479 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 21898 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21907 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 21913 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21919 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 21987 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 21993 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 22008 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22016 "asllib/Parser0.ml"
                  
                in
                
# 479 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 22040 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22049 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 22055 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22061 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 22138 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22155 "asllib/Parser0.ml"
                   _3_1
                in
                let name = _1 in
                
# 479 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 22180 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22189 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 22195 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22201 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = ty;
                    MenhirLib.EngineTypes.startp = _startpos_ty_;
                    MenhirLib.EngineTypes.endp = _endpos_ty_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 22257 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 22272 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 479 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 22297 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22306 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 22312 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22318 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22408 "asllib/Parser0.ml"
                   _3_1
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 22414 "asllib/Parser0.ml"
                 in
                
# 479 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 22437 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22446 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 22452 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22458 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = ty;
                    MenhirLib.EngineTypes.startp = _startpos_ty_;
                    MenhirLib.EngineTypes.endp = _endpos_ty_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 22525 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 22531 "asllib/Parser0.ml"
                 in
                
# 479 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 22554 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22563 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 22569 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22575 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 22664 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 22670 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22687 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 22694 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 22699 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22707 "asllib/Parser0.ml"
                  
                in
                
# 499 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 22730 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22739 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 22745 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22751 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 22847 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 22853 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22870 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 22879 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22887 "asllib/Parser0.ml"
                  
                in
                
# 499 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 22910 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22919 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 22925 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22931 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 23008 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23025 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 23032 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 23037 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 499 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 23061 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 23070 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 23076 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23082 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 23166 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23183 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 23192 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 499 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 23216 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 23225 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 23231 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23237 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23327 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 23334 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 23339 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 23345 "asllib/Parser0.ml"
                 in
                
# 499 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 23367 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 23376 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 23382 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23388 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23485 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 23494 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 23500 "asllib/Parser0.ml"
                 in
                
# 499 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 23522 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 23531 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 23537 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23543 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 23611 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 23617 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23629 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 23635 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 23640 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 23649 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 23657 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23663 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 23738 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 23744 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 23756 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 23762 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 23767 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 23776 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 23784 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23790 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 23865 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 23871 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23883 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23891 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 23900 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 23908 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23914 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 23996 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 24002 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 24014 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 24022 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 24031 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 24039 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24045 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24101 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 24113 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 24119 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 24124 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 24133 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24139 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24202 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 24214 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 24220 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 24225 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 24234 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24240 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24303 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 24315 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 24323 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 24332 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24338 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24408 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 24420 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 24428 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 24437 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24443 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 24507 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 24513 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 24518 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 349 "asllib/Parser0.mly"
              ( "record" )
# 24526 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 24534 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24540 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 24611 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 24617 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 24622 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 349 "asllib/Parser0.mly"
              ( "record" )
# 24630 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 24638 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24644 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 24715 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 24723 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 349 "asllib/Parser0.mly"
              ( "record" )
# 24731 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 24739 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24745 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 24823 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 24831 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 349 "asllib/Parser0.mly"
              ( "record" )
# 24839 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 24847 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24853 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24940 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24947 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 24953 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined2, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 24969 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined1 in
                let name =
                  let _2 = _2_inlined1 in
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 24979 "asllib/Parser0.ml"
                  
                in
                
# 526 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptySetter
        and recurse_limit = None
        and args = [ (ident, ty) ] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 25003 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25012 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 25018 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25024 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25099 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25106 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25122 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined1 in
                let name = _1 in
                
# 526 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptySetter
        and recurse_limit = None
        and args = [ (ident, ty) ] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 25148 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25157 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 25163 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25169 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25244 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25263 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined1 in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 25270 "asllib/Parser0.ml"
                 in
                
# 526 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptySetter
        and recurse_limit = None
        and args = [ (ident, ty) ] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 25293 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25302 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 25308 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25314 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = q;
                                  MenhirLib.EngineTypes.startp = _startpos_q_;
                                  MenhirLib.EngineTypes.endp = _endpos_q_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25413 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25422 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 25428 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25444 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 25452 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 25457 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25465 "asllib/Parser0.ml"
                  
                in
                
# 546 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 25489 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25498 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 25504 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25510 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = q;
                                    MenhirLib.EngineTypes.startp = _startpos_q_;
                                    MenhirLib.EngineTypes.endp = _endpos_q_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25615 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25625 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 25631 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25647 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined3 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 25657 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25665 "asllib/Parser0.ml"
                  
                in
                
# 546 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 25689 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25698 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 25704 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25710 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25797 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25806 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25822 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 25830 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 25835 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 546 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 25860 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25869 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 25875 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25881 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25974 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25984 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined5, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 26000 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined3 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 26010 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 546 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 26035 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 26044 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 26050 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26056 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26143 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 26164 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 26172 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 26177 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 26183 "asllib/Parser0.ml"
                 in
                
# 546 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 26206 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 26215 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 26221 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26227 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26320 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined5, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 26342 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined3 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 26352 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 26358 "asllib/Parser0.ml"
                 in
                
# 546 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 26381 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 26390 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 26396 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26402 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26468 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26475 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 26481 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 26492 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 26498 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 26506 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 26514 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26520 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26593 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26600 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 26606 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 26617 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 26623 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 26631 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 26639 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26645 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26723 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26732 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 26738 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 26749 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 26757 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 26762 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26768 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 26777 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 26785 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26791 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26876 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26885 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 26891 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 26902 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 26910 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 26915 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26921 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 26930 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 26938 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26944 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27028 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27038 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 27044 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 27055 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 27065 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27071 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 27080 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 27088 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27094 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = q;
                                MenhirLib.EngineTypes.startp = _startpos_q_;
                                MenhirLib.EngineTypes.endp = _endpos_q_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27185 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27195 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 27201 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 27212 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 27222 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27228 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 27237 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 27245 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27251 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27305 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27312 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 27323 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 27329 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 27336 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27342 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27403 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27410 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 27421 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 27427 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 27434 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27440 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27506 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27515 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 27526 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 27534 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 27539 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27545 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 27553 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27559 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27632 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27641 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 27652 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 27660 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 27665 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27671 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 27679 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27685 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27757 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27767 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 27778 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 27788 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27794 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 27802 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27808 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27887 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27897 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 27908 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 27918 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27924 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 27932 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27938 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27992 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 28006 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 28012 "asllib/Parser0.ml"
               in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 28017 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 28024 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28030 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28091 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 28105 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 28111 "asllib/Parser0.ml"
               in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 28116 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 28123 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28129 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28195 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 28211 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 28219 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 28224 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 28230 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 28236 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 28243 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28249 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28322 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 28338 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 28346 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 28351 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 28357 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 28363 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 28370 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28376 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28448 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 28465 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 28475 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 28481 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 28487 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 28494 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28500 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28579 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 28596 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 28606 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 28612 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 28618 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 28625 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28631 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = ty;
                MenhirLib.EngineTypes.startp = _startpos_ty_;
                MenhirLib.EngineTypes.endp = _endpos_ty_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28694 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let x = _1_inlined1 in
                  
# 273 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ty, None)) )
# 28713 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 28719 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28728 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 28734 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28740 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = ty;
                MenhirLib.EngineTypes.startp = _startpos_ty_;
                MenhirLib.EngineTypes.endp = _endpos_ty_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28815 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 28821 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 290 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 28843 "asllib/Parser0.ml"
                    
                  in
                  
# 273 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ty, None)) )
# 28849 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 28855 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28864 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 28870 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28876 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.field list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28946 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined4 in
                  _2
                in
                let x =
                  let fields =
                    let (_startpos__1_, _1_inlined1) = (_startpos__1_inlined2_, _1_inlined3) in
                    let desc =
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 28968 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28977 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 275 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from fields (T_Record fields.desc), None)) )
# 28984 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 28990 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28999 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 29005 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29011 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.field list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 29093 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 29099 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined4 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let fields =
                    let (_startpos__1_, _1_inlined1) = (_startpos__1_inlined2_, _1_inlined3) in
                    let desc =
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 29122 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29131 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 290 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 29140 "asllib/Parser0.ml"
                    
                  in
                  
# 275 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from fields (T_Record fields.desc), None)) )
# 29146 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 29152 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29161 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 29167 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29173 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x : (string list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 29243 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined3 in
                  _2
                in
                let x =
                  let li =
                    let _startpos__1_ = _startpos__1_inlined2_ in
                    let desc = 
# 205 "<standard.mly>"
    ( x )
# 29263 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29271 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 277 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Enum li.desc), None)) )
# 29278 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 29284 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29293 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 29299 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29305 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x : (string list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 29387 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 29393 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined3 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let li =
                    let _startpos__1_ = _startpos__1_inlined2_ in
                    let desc = 
# 205 "<standard.mly>"
    ( x )
# 29414 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29422 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 290 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 29431 "asllib/Parser0.ml"
                    
                  in
                  
# 277 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Enum li.desc), None)) )
# 29437 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 29443 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29452 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 29458 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29464 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 29513 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let ty =
                    let _endpos__0_ = _endpos__1_inlined1_ in
                    let desc =
                      let _1 = () in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 29535 "asllib/Parser0.ml"
                      
                    in
                    let _endpos_desc_ = _endpos__0_ in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _endpos in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29544 "asllib/Parser0.ml"
                    
                  in
                  let t = _1_inlined1 in
                  
# 280 "asllib/Parser0.mly"
          ( AST.D_TypeDecl (t, ty, None) )
# 29551 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 29557 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29566 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 29572 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29578 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 29639 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 29645 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let ty =
                    let _endpos__0_ = _endpos__1_inlined1_ in
                    let desc =
                      let _1 = () in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 29668 "asllib/Parser0.ml"
                      
                    in
                    let _endpos_desc_ = _endpos__0_ in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _endpos in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29677 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 290 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 29686 "asllib/Parser0.ml"
                    
                  in
                  
# 280 "asllib/Parser0.mly"
          ( AST.D_TypeDecl (t, ty, None) )
# 29692 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 29698 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29707 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 29713 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29719 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.field list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 29789 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let li =
                  let (_endpos__3_, _startpos__1_) = (_endpos__3_inlined1_, _startpos__1_inlined2_) in
                  let desc = 
# 205 "<standard.mly>"
    ( x )
# 29804 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29812 "asllib/Parser0.ml"
                  
                in
                let x = _1_inlined1 in
                
# 284 "asllib/Parser0.mly"
        ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Record li.desc), None)) )
# 29819 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29828 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 29834 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29840 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.field list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 29922 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 29928 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let li =
                  let (_endpos__3_, _startpos__1_) = (_endpos__3_inlined1_, _startpos__1_inlined2_) in
                  let desc = 
# 205 "<standard.mly>"
    ( x )
# 29943 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29951 "asllib/Parser0.ml"
                  
                in
                let x =
                  let _1 = _1_inlined1 in
                  let i = _1 in
                  
# 290 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 29960 "asllib/Parser0.ml"
                  
                in
                
# 284 "asllib/Parser0.mly"
        ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Record li.desc), None)) )
# 29966 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29975 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 29981 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29987 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.expr) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 30006 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = c;
                MenhirLib.EngineTypes.startp = _startpos_c_;
                MenhirLib.EngineTypes.endp = _endpos_c_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic xs in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = (c, e) in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30065 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30071 "asllib/Parser0.ml"
           : ((AST.expr * AST.expr) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.stmt) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 30090 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30171 "asllib/Parser0.ml"
                 _3_1
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30182 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30188 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 30295 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30302 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30311 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30317 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30326 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30334 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30340 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30349 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30360 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30366 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30492 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 30498 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30506 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30515 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30521 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30530 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30538 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30544 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30553 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30564 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30570 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30638 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 30644 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30655 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30661 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 30720 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30731 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30737 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.stmt) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 30756 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30815 "asllib/Parser0.ml"
                 _1_1
              in
              (expr, simple_stmt_list)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30826 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30832 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.stmt list) = 
# 216 "<standard.mly>"
    ( [] )
# 30851 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 30933 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30940 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30949 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30955 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30964 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30972 "asllib/Parser0.ml"
                 _1_1
              in
              
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30978 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30987 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30993 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31095 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 31101 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31109 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31118 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31124 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31133 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31141 "asllib/Parser0.ml"
                 _1_1
              in
              
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31147 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31156 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31162 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31206 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 31212 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31218 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31305 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31312 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 31322 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31328 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31337 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31343 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 31471 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31477 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31485 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 31495 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31501 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31510 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31516 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4;
                              MenhirLib.EngineTypes.startp = _startpos__4_;
                              MenhirLib.EngineTypes.endp = _endpos__4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31669 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31676 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31685 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31691 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31700 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31708 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31714 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31723 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31729 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31737 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 31747 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31753 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31762 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31768 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4;
                                  MenhirLib.EngineTypes.startp = _startpos__4_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31940 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 31946 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31954 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31963 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31969 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31978 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31986 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31992 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32001 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32007 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32015 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 32025 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32031 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32040 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32046 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32160 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 32166 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32172 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32180 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 32190 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32196 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32205 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32211 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 32316 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32322 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32330 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 32340 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32346 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32355 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32361 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32469 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32476 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32490 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32497 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32506 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32512 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32521 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32529 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32535 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32544 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32550 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32559 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32565 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 32714 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32720 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32728 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32742 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32749 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32758 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32764 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32773 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32781 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32787 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32796 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32802 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32811 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32817 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3;
                                            MenhirLib.EngineTypes.startp = _startpos__3_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32991 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32998 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33007 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33013 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33022 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33030 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33036 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33045 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33051 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33059 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 33073 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33080 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33089 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33095 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33104 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33112 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33118 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33127 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33133 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33142 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33148 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33341 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 33347 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33355 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33364 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33370 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33379 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33387 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33393 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33402 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33408 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33416 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 33430 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33437 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33446 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33452 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33461 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33469 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33475 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33484 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33490 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33499 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33505 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33640 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 33646 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33652 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33660 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 33674 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33681 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33690 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33696 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33705 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33713 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33719 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33728 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33734 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33743 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33749 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 33875 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33881 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33889 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 33903 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33910 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33919 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33925 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33934 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33942 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33948 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33957 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33963 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33972 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33978 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 34100 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34107 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34126 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 34132 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34140 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34149 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34155 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34164 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34172 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34178 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34187 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34193 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34202 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34208 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 34371 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 34377 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34385 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34404 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 34410 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34418 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34427 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34433 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34442 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34450 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34456 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34465 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34471 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34480 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34486 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined10;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined9;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined6;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined5;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 34674 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34681 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34690 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34696 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34705 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34713 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34719 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34728 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 34734 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34742 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34761 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 34767 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34775 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34784 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34790 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34799 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34807 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34813 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34822 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34828 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34837 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34843 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined14;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined13;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined12;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined11;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined10;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined9;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined8;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined7;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined6;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined5;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined4;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined3;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = _3;
                                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _;
                                                      MenhirLib.EngineTypes.semv = expr;
                                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                      MenhirLib.EngineTypes.next = {
                                                        MenhirLib.EngineTypes.state = _menhir_s;
                                                        MenhirLib.EngineTypes.semv = _1;
                                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                                      };
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35050 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 35056 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35064 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35073 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35079 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35088 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35096 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35102 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35111 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35117 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35125 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35144 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 35150 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35158 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35167 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35173 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35182 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35190 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35196 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35205 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35211 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35220 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35226 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35375 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 35381 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35387 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35395 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35414 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 35420 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35428 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35437 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35443 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35452 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35460 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35466 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35475 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35481 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35490 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35496 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 35636 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35642 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35650 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35669 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 35675 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35683 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35692 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35698 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35707 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35715 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35721 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35730 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35736 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35745 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35751 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 35824 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35831 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35841 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 35847 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35853 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35862 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35868 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 35982 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35988 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35996 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36006 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 36012 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36018 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36027 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36033 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 36172 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 36179 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36188 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 36194 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36203 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36211 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 36217 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36226 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36232 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36240 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36250 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 36256 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36262 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36271 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36277 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36435 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 36441 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 36449 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36458 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 36464 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36473 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36481 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 36487 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36496 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36502 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36510 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36520 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 36526 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36532 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36541 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36547 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36647 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 36653 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36659 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36667 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36677 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 36683 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36689 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36698 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36704 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36795 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36801 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36809 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36819 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 36825 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36831 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36840 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36846 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 36912 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36919 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36927 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36933 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36942 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36948 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37055 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 37061 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 37069 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 37077 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 37083 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37092 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37098 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 37230 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 37237 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37246 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 37252 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37261 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37269 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 37275 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37284 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 37290 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 37298 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 37306 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 37312 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37321 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37327 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37478 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 37484 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 37492 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37501 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 37507 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37516 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37524 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 37530 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37539 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 37545 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 37553 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 37561 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 37567 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37576 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37582 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37675 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 37681 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 37687 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 37695 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 37703 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 37709 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37718 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37724 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 37808 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 37814 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 37822 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 37830 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 37836 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37845 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37851 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37943 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 233 "asllib/Parser0.mly"
                      Some  
# 37949 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 697 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 37957 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37966 "asllib/Parser0.ml"
                 _1_1
              in
              
# 712 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 37972 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37981 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37987 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : (AST.case_alt list) = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _6_1 = _6 in
              
# 713 "asllib/Parser0.mly"
                                                            AST.S_Case  
# 38066 "asllib/Parser0.ml"
               (expr, _6_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38075 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38081 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 38172 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38188 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 38194 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 764 "asllib/Parser0.mly"
                       ( AST.Up )
# 38201 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 759 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 38208 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38217 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38223 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 38328 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38344 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 38353 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 764 "asllib/Parser0.mly"
                       ( AST.Up )
# 38361 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 759 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 38368 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38377 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38383 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 38474 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38490 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 38496 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 764 "asllib/Parser0.mly"
                                            ( AST.Down )
# 38503 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 759 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 38510 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38519 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38525 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 38630 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38646 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 38655 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 764 "asllib/Parser0.mly"
                                            ( AST.Down )
# 38663 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 759 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 38670 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38679 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38685 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _4 : unit = Obj.magic _4 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38767 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 38773 "asllib/Parser0.ml"
               in
              let _3_1 = _3 in
              
# 760 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 38779 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38788 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38794 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _4 : unit = Obj.magic _4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38890 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 =
                let _1 = _1_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 38899 "asllib/Parser0.ml"
                
              in
              let _3_1 = _3 in
              
# 760 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 38906 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38915 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38921 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 = 
# 123 "<standard.mly>"
    ( None )
# 39013 "asllib/Parser0.ml"
               in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39022 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 762 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 39029 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39038 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39044 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 =
                let (_2, _1) = (_2_inlined1, _1_inlined3) in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 39153 "asllib/Parser0.ml"
                
              in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39163 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 762 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 39170 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39179 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39185 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _5;
                  MenhirLib.EngineTypes.startp = _startpos__5_;
                  MenhirLib.EngineTypes.endp = _endpos__5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 39278 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 39297 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39308 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 39318 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39327 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39333 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _6;
                          MenhirLib.EngineTypes.startp = _startpos__6_;
                          MenhirLib.EngineTypes.endp = _endpos__6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _5;
                            MenhirLib.EngineTypes.startp = _startpos__5_;
                            MenhirLib.EngineTypes.endp = _endpos__5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 39461 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39487 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39496 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 39502 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39514 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 39524 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39533 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39539 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _5;
                                  MenhirLib.EngineTypes.startp = _startpos__5_;
                                  MenhirLib.EngineTypes.endp = _endpos__5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _4_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _2;
                                            MenhirLib.EngineTypes.startp = _startpos__2_;
                                            MenhirLib.EngineTypes.endp = _endpos__2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 39688 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 39718 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 39725 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 39734 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 39740 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39749 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 39757 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 39763 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39772 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39781 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 39787 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39799 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 39809 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39818 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39824 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _6;
                                    MenhirLib.EngineTypes.startp = _startpos__6_;
                                    MenhirLib.EngineTypes.endp = _endpos__6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _5;
                                      MenhirLib.EngineTypes.startp = _startpos__5_;
                                      MenhirLib.EngineTypes.endp = _endpos__5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _4_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _2;
                                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 39987 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 40022 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 40028 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 40036 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 40045 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 40051 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40060 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 40068 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 40074 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40083 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40092 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 40098 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 40110 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 40120 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40129 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 40135 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _5;
                        MenhirLib.EngineTypes.startp = _startpos__5_;
                        MenhirLib.EngineTypes.endp = _endpos__5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 40249 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 40275 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 40281 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40290 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 40296 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 40308 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 40318 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40327 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 40333 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 40440 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 40464 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40473 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 40479 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 40491 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 40501 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40510 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 40516 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.bitfield list) = 
# 145 "<standard.mly>"
    ( [] )
# 40535 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.bitfield list) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.bitfield list) = 
# 148 "<standard.mly>"
    ( x )
# 40560 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let _3 =
              let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
              let _3 = _1_inlined1 in
              let _3_1 = _3 in
              
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 40626 "asllib/Parser0.ml"
               _3_1
            in
            ()
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40634 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let x =
            let _3 =
              let _1 = _1_inlined1 in
              
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 40678 "asllib/Parser0.ml"
              
            in
            ()
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40686 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _3 =
              let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
              let _3 = _1_inlined1 in
              let _3_1 = _3 in
              
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 40760 "asllib/Parser0.ml"
               _3_1
            in
            ()
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 40768 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _3 =
              let _1 = _1_inlined1 in
              
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 40819 "asllib/Parser0.ml"
              
            in
            ()
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 40827 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 40862 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let x =
              let x = _1 in
              
# 293 "asllib/Parser0.mly"
                               ( (x, t) )
# 40875 "asllib/Parser0.ml"
              
            in
            
# 196 "<standard.mly>"
    ( x )
# 40881 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40887 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.field list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 40929 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let x = _1 in
              
# 293 "asllib/Parser0.mly"
                               ( (x, t) )
# 40942 "asllib/Parser0.ml"
              
            in
            
# 196 "<standard.mly>"
    ( x )
# 40948 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 40954 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = le;
                MenhirLib.EngineTypes.startp = _startpos_le_;
                MenhirLib.EngineTypes.endp = _endpos_le_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let le : (AST.lexpr) = Obj.magic le in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_le_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                
# 660 "asllib/Parser0.mly"
                                AST.S_Assign  
# 41006 "asllib/Parser0.ml"
                 (le, e)
              in
              
# 196 "<standard.mly>"
    ( x )
# 41012 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_le_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41021 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41027 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 41076 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 41091 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41099 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41105 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41111 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41120 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41126 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 41186 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 41193 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41201 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41207 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41213 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41222 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41228 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 41277 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 41292 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41300 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41306 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41312 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41321 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41327 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 41387 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 41394 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41402 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41408 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41414 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41423 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41429 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 41478 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 41493 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41501 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41507 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41513 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41522 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41528 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 41588 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 41595 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41603 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41609 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41615 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41624 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41630 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 41679 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 41684 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc =
                    let tident = _1 in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 41700 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41709 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41715 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41721 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41730 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41736 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 41786 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 41800 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc =
                    let tident = _1 in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 41809 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41818 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41824 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41830 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41839 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41845 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 41906 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 41911 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 41917 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined1 in
                let ty =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 41935 "asllib/Parser0.ml"
                      
                    in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 41941 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41950 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41956 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41962 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41971 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41977 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 42039 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 42045 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined1 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 42060 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 42070 "asllib/Parser0.ml"
                      
                    in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 42076 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42085 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42091 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42097 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42106 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42112 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 42161 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 42176 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42184 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42190 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42196 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42205 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42211 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 42271 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 42278 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42286 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42292 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42298 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42307 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42313 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 42380 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 42400 "asllib/Parser0.ml"
                     in
                    
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 42405 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42414 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42420 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42426 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42435 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42441 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 42522 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 42531 "asllib/Parser0.ml"
                     in
                    
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 42536 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42545 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42551 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42557 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42566 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42572 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 42657 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__3_inlined1_, x) = (_endpos__3_inlined2_, x_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 42683 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 42689 "asllib/Parser0.ml"
                     in
                    
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 42694 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42703 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42709 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42715 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42724 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42730 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined4 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 42832 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__3_inlined1_, x) = (_endpos__3_inlined2_, x_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 42844 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 42850 "asllib/Parser0.ml"
                     in
                    
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 42855 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42864 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42870 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42876 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42885 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42891 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 42958 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 42979 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42986 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42995 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 43001 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43007 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43016 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43022 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 43103 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 43113 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43120 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43129 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 43135 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43141 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43150 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43156 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 43235 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 43243 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined3 in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 43268 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43276 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43285 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 43291 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43297 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43306 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43312 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 43395 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined3 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 43411 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 43427 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43435 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43444 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 43450 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43456 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43465 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43471 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 43562 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 43570 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 43576 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined3 in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 43602 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 43610 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43618 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43627 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 43633 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43639 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43648 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43654 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 43749 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 43755 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined3 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 43772 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 43788 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 43796 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43804 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43813 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 43819 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43825 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43834 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43840 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 43931 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined3 in
                let ty =
                  let _3 = _3_inlined3 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 43963 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43971 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43980 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 43986 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43992 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44001 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44007 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined3 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 44117 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let _3 = _3_inlined3 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 44133 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 44141 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44150 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 44156 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44162 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44171 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44177 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44232 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 44249 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44257 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44263 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44269 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44278 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44284 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 44351 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 44359 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44367 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44373 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44379 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44388 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44394 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44449 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 44466 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44474 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44480 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44486 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44495 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44501 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 44568 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 44576 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44584 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44590 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44596 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44605 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44611 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44666 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 44683 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44691 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44697 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44703 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44712 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44718 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 44785 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 44793 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44801 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44807 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44813 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44822 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44828 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44883 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44888 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident = _1 in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 44906 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44915 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44921 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44927 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44936 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44942 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44998 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 45013 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident = _1 in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 45023 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45032 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45038 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45044 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45053 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45059 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 45126 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 45131 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 45137 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _1) = (_endpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 45157 "asllib/Parser0.ml"
                      
                    in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 45163 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45172 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45178 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45184 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45193 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45199 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 45267 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 45273 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 45289 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _1) = (_endpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 45300 "asllib/Parser0.ml"
                      
                    in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 45306 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45315 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45321 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45327 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45336 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45342 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 45397 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 45414 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45422 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45428 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45434 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45443 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45449 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 45516 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 45524 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45532 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45538 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45544 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45553 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45559 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 45632 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined3 in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 45653 "asllib/Parser0.ml"
                     in
                    
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 45658 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45667 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45673 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45679 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45688 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45694 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined3 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 45782 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 45791 "asllib/Parser0.ml"
                     in
                    
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 45796 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45805 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45811 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45817 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45826 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45832 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (
# 82 "asllib/Parser0.mly"
       (string)
# 45923 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined5 in
                let ty =
                  let (_startpos__1_, _1_inlined3, x, _1) = (_startpos__1_inlined1_, _1_inlined4, x_inlined1, _1_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 45950 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 45956 "asllib/Parser0.ml"
                     in
                    
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 45961 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45970 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45976 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45982 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45991 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45997 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined5 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 46106 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_startpos__1_, _1_inlined3, x, _1) = (_startpos__1_inlined1_, _1_inlined4, x_inlined1, _1_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 46118 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 46124 "asllib/Parser0.ml"
                     in
                    
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 46129 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46138 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 46144 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46150 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46159 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46165 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 46238 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined3 in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 46260 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46267 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46276 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 46282 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46288 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46297 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46303 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined3 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 46391 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 46401 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46408 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46417 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 46423 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46429 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46438 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46444 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 46529 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 46537 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 46563 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46571 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46580 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 46586 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46592 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46601 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46607 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 46696 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined4 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 46713 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 46729 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46737 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46746 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 46752 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46758 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46767 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46773 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 46870 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 46878 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 46884 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 46911 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 46919 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46927 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46936 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 46942 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46948 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46957 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46963 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 47064 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 47070 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined4 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 47088 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 47104 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 47112 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 47120 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47129 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 47135 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47141 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47150 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47156 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 47253 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 47286 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 47294 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47303 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 47309 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47315 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47324 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47330 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined4 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 47447 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 47463 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 47471 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47480 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 47486 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47492 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47501 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47507 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 47556 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                
# 666 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, None, Some expr)) )
# 47570 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47576 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47585 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47591 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 47667 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let names =
                  let (_1_inlined2, _1_inlined1) = (_1_inlined3, _1_inlined2) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let t = _1_inlined1 in
                    let h = _1 in
                    
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 47688 "asllib/Parser0.ml"
                    
                  in
                  
# 205 "<standard.mly>"
    ( x )
# 47694 "asllib/Parser0.ml"
                  
                in
                
# 668 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, LDI_Tuple names, None, Some e) )
# 47700 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47706 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47715 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47721 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let names =
                  let (_1_inlined2, _1_inlined1) = (_1_inlined3, _1_inlined2) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let t = _1_inlined1 in
                    let h = 
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 47813 "asllib/Parser0.ml"
                     in
                    
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 47818 "asllib/Parser0.ml"
                    
                  in
                  
# 205 "<standard.mly>"
    ( x )
# 47824 "asllib/Parser0.ml"
                  
                in
                
# 668 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, LDI_Tuple names, None, Some e) )
# 47830 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47836 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47845 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47851 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let names =
                  let (_1_inlined2, _1_inlined1) = (_1_inlined3, _1_inlined2) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let t = _1_inlined1 in
                    let h = 
# 655 "asllib/Parser0.mly"
                         ( ASTUtils.fresh_var "__ldi_discard" )
# 47943 "asllib/Parser0.ml"
                     in
                    
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 47948 "asllib/Parser0.ml"
                    
                  in
                  
# 205 "<standard.mly>"
    ( x )
# 47954 "asllib/Parser0.ml"
                  
                in
                
# 668 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, LDI_Tuple names, None, Some e) )
# 47960 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47966 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47975 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47981 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 48027 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48035 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48041 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48047 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48056 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48062 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 48108 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48116 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48122 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48128 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48137 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48143 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 48189 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48197 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48203 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48209 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48218 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48224 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 48260 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident = _1 in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 48276 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48285 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48291 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48297 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48306 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48312 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 48360 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 48366 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 48384 "asllib/Parser0.ml"
                      
                    in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 48390 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48399 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48405 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48411 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48420 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48426 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 48472 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48480 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48486 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48492 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48501 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48507 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 48575 "asllib/Parser0.ml"
                     in
                    
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 48580 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48589 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48595 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48601 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48610 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48616 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (string list) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined4 in
                let t =
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 48708 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 48714 "asllib/Parser0.ml"
                     in
                    
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 48719 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48728 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48734 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48740 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48749 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48755 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 48824 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 48831 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48840 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48846 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48852 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48861 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48867 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 48936 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 48960 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 48968 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48977 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48983 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48989 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48998 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49004 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 49085 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 49091 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 49116 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 49124 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 49132 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49141 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 49147 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 49153 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49162 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49168 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 49272 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 49280 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49289 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 49295 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 49301 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49310 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49316 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 49371 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 49377 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 49390 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 49396 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 49401 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 49409 "asllib/Parser0.ml"
                  
                in
                
# 633 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 49415 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49421 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49430 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49436 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 49498 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 49504 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 49517 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 49525 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 49533 "asllib/Parser0.ml"
                  
                in
                
# 633 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 49539 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49545 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49554 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49560 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 49603 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 49615 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 49621 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 49626 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 633 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 49633 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49639 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49648 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49654 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 49704 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 49716 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 49724 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 633 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 49731 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49737 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49746 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49752 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 49803 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 49809 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 49814 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 49820 "asllib/Parser0.ml"
                 in
                
# 633 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 49825 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49831 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49840 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49846 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 49904 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 49912 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 49918 "asllib/Parser0.ml"
                 in
                
# 633 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 49923 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49929 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49938 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49944 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 50020 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 50026 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 50040 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 50045 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50054 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 50062 "asllib/Parser0.ml"
                  
                in
                
# 635 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 50068 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50074 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50083 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50089 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 50172 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 50178 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let args =
                  let _1_inlined1 = _1_inlined4 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50194 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50203 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 50211 "asllib/Parser0.ml"
                  
                in
                
# 635 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 50217 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50223 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50232 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50238 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 50302 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 50315 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 50320 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50329 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 635 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 50336 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50342 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50351 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50357 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 50428 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let _1_inlined1 = _1_inlined4 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50443 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50452 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 635 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 50459 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50465 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50474 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50480 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 50553 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 50558 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50567 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 50573 "asllib/Parser0.ml"
                 in
                
# 635 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 50578 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50584 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50593 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50599 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let _1_inlined1 = _1_inlined4 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50681 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50690 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 50696 "asllib/Parser0.ml"
                 in
                
# 635 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 50701 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50707 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50716 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50722 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 50759 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 636 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 50765 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 50771 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50780 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50786 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 50830 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 636 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 50836 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 50842 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50851 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50857 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x = 
# 637 "asllib/Parser0.mly"
                                                    AST.S_Assert  
# 50900 "asllib/Parser0.ml"
               expr in
              
# 196 "<standard.mly>"
    ( x )
# 50905 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50914 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50920 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x = 
# 638 "asllib/Parser0.mly"
                                                  ( AST.S_Print { args = [ e ]; newline = true; debug = true } )
# 50963 "asllib/Parser0.ml"
               in
              
# 196 "<standard.mly>"
    ( x )
# 50968 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50977 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50983 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 51021 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51028 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51034 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51043 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51049 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 51104 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 51110 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51118 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51124 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51133 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51139 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = () in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51177 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51183 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51192 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51198 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 51246 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 51264 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51272 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51278 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51287 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51293 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 51331 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51338 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51344 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51353 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51359 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 51414 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 51420 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51428 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51434 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51443 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51449 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 51487 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51494 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51500 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51509 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51515 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 51550 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 51564 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51571 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51577 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51586 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51592 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 51651 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51658 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51664 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51673 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51679 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 51714 "asllib/Parser0.ml"
        ) = Obj.magic _2_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let _1 = () in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51729 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51735 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51744 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51750 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 51785 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51802 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51808 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51817 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51823 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 51858 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51875 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51881 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51890 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51896 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = le;
                  MenhirLib.EngineTypes.startp = _startpos_le_;
                  MenhirLib.EngineTypes.endp = _endpos_le_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let le : (AST.lexpr) = Obj.magic le in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_le_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                
# 660 "asllib/Parser0.mly"
                                AST.S_Assign  
# 51955 "asllib/Parser0.ml"
                 (le, e)
              in
              
# 196 "<standard.mly>"
    ( x )
# 51961 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_le_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51970 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51976 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 52032 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 52047 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52055 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52061 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52067 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52076 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52082 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 52149 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 52156 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52164 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52170 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52176 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52185 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52191 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 52247 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 52262 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52270 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52276 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52282 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52291 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52297 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 52364 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 52371 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52379 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52385 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52391 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52400 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52406 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 52462 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 52477 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52485 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52491 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52497 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52506 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52512 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 52579 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 52586 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52594 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52600 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52606 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52615 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52621 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 52677 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 52682 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc =
                    let tident = _1 in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 52698 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52707 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52713 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52719 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52728 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52734 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 52791 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 52805 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc =
                    let tident = _1 in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 52814 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52823 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52829 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52835 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52844 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52850 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 52918 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 52923 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 52929 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined1 in
                let ty =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 52947 "asllib/Parser0.ml"
                      
                    in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 52953 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52962 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52968 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52974 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52983 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52989 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 53058 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 53064 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined1 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 53079 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 53089 "asllib/Parser0.ml"
                      
                    in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 53095 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53104 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53110 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53116 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53125 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53131 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 53187 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 53202 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53210 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53216 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53222 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53231 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53237 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 53304 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 53311 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53319 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53325 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53331 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53340 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53346 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 53420 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 53440 "asllib/Parser0.ml"
                     in
                    
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 53445 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53454 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53460 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53466 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53475 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53481 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 53569 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 53578 "asllib/Parser0.ml"
                     in
                    
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 53583 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53592 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53598 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53604 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53613 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53619 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 53711 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__3_inlined1_, x) = (_endpos__3_inlined2_, x_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 53737 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 53743 "asllib/Parser0.ml"
                     in
                    
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 53748 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53757 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53763 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53769 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53778 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53784 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined4 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 53893 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__3_inlined1_, x) = (_endpos__3_inlined2_, x_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 53905 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 53911 "asllib/Parser0.ml"
                     in
                    
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 53916 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53925 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53931 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53937 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53946 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53952 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54026 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 54047 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 54054 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54063 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 54069 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54075 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54084 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54090 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 54178 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 54188 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 54195 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54204 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 54210 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54216 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54225 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54231 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54317 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54325 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined3 in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 54350 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 54358 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54367 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 54373 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54379 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54388 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54394 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54484 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined3 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 54500 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 54516 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 54524 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54533 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 54539 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54545 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54554 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54560 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54658 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54666 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 54672 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined3 in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 54698 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 54706 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 54714 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54723 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 54729 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54735 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54744 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54750 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54852 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 54858 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined3 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 54875 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 54891 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 54899 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 54907 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54916 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 54922 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54928 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54937 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54943 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 55041 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined3 in
                let ty =
                  let _3 = _3_inlined3 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 55073 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 55081 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55090 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 55096 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55102 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55111 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55117 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined3 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 55234 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let _3 = _3_inlined3 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 55250 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 55258 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55267 "asllib/Parser0.ml"
                  
                in
                
# 662 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 55273 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55279 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55288 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55294 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 55356 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 55373 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55381 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 55387 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55393 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55402 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55408 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 55482 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 55490 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55498 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 55504 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55510 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55519 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55525 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 55587 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 55604 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55612 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 55618 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55624 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55633 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55639 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 55713 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 55721 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55729 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 55735 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55741 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55750 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55756 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 55818 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 55835 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55843 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 55849 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55855 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55864 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55870 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 55944 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 55952 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55960 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 55966 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55972 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55981 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55987 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56049 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56054 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident = _1 in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 56072 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56081 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56087 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56093 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56102 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56108 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56171 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 56186 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident = _1 in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 56196 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56205 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56211 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56217 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56226 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56232 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56306 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56311 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 56317 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _1) = (_endpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 56337 "asllib/Parser0.ml"
                      
                    in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 56343 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56352 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56358 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56364 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56373 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56379 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56454 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 56460 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 56476 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _1) = (_endpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 56487 "asllib/Parser0.ml"
                      
                    in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 56493 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56502 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56508 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56514 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56523 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56529 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56591 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 56608 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56616 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56622 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56628 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56637 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56643 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 56717 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 56725 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56733 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56739 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56745 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56754 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56760 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56840 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined3 in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 56861 "asllib/Parser0.ml"
                     in
                    
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 56866 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56875 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56881 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56887 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56896 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56902 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined3 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 56997 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 57006 "asllib/Parser0.ml"
                     in
                    
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 57011 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57020 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 57026 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57032 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57041 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57047 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (
# 82 "asllib/Parser0.mly"
       (string)
# 57145 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined5 in
                let ty =
                  let (_startpos__1_, _1_inlined3, x, _1) = (_startpos__1_inlined1_, _1_inlined4, x_inlined1, _1_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 57172 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 57178 "asllib/Parser0.ml"
                     in
                    
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 57183 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57192 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 57198 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57204 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57213 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57219 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined5 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 57335 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_startpos__1_, _1_inlined3, x, _1) = (_startpos__1_inlined1_, _1_inlined4, x_inlined1, _1_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 57347 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 57353 "asllib/Parser0.ml"
                     in
                    
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 57358 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57367 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 57373 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57379 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57388 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57394 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 57474 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined3 in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 57496 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 57503 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57512 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 57518 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57524 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57533 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57539 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined3 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 57634 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 57644 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 57651 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57660 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 57666 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57672 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57681 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57687 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 57779 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 57787 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 57813 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 57821 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57830 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 57836 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57842 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57851 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57857 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 57953 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined4 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 57970 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 57986 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 57994 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58003 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 58009 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 58015 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58024 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58030 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 58134 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 58142 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 58148 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 58175 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58183 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58191 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58200 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 58206 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 58212 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58221 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58227 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 58335 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 58341 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined4 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 58359 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 58375 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58383 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58391 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58400 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 58406 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 58412 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58421 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58427 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 58531 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58564 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58572 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58581 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 58587 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 58593 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58602 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58608 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined4 in
                  
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 58732 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58748 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58756 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58765 "asllib/Parser0.ml"
                  
                in
                
# 664 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 58771 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 58777 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58786 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58792 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 58848 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                
# 666 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, None, Some expr)) )
# 58862 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 58868 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58877 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58883 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 58966 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let names =
                  let (_1_inlined2, _1_inlined1) = (_1_inlined3, _1_inlined2) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let t = _1_inlined1 in
                    let h = _1 in
                    
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 58987 "asllib/Parser0.ml"
                    
                  in
                  
# 205 "<standard.mly>"
    ( x )
# 58993 "asllib/Parser0.ml"
                  
                in
                
# 668 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, LDI_Tuple names, None, Some e) )
# 58999 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59005 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59014 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59020 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let names =
                  let (_1_inlined2, _1_inlined1) = (_1_inlined3, _1_inlined2) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let t = _1_inlined1 in
                    let h = 
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 59119 "asllib/Parser0.ml"
                     in
                    
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 59124 "asllib/Parser0.ml"
                    
                  in
                  
# 205 "<standard.mly>"
    ( x )
# 59130 "asllib/Parser0.ml"
                  
                in
                
# 668 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, LDI_Tuple names, None, Some e) )
# 59136 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59142 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59151 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59157 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let names =
                  let (_1_inlined2, _1_inlined1) = (_1_inlined3, _1_inlined2) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let t = _1_inlined1 in
                    let h = 
# 655 "asllib/Parser0.mly"
                         ( ASTUtils.fresh_var "__ldi_discard" )
# 59256 "asllib/Parser0.ml"
                     in
                    
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 59261 "asllib/Parser0.ml"
                    
                  in
                  
# 205 "<standard.mly>"
    ( x )
# 59267 "asllib/Parser0.ml"
                  
                in
                
# 668 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, LDI_Tuple names, None, Some e) )
# 59273 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59279 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59288 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59294 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 59347 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59355 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59361 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59367 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59376 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59382 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 59435 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59443 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59449 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59455 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59464 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59470 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 59523 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59531 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59537 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59543 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59552 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59558 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 59601 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident = _1 in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 59617 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59626 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59632 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59638 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59647 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59653 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 59708 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 59714 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 59732 "asllib/Parser0.ml"
                      
                    in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 59738 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59747 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59753 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59759 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59768 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59774 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 59827 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59835 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59841 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59847 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59856 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59862 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 59937 "asllib/Parser0.ml"
                     in
                    
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 59942 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59951 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59957 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59963 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59972 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59978 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (string list) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined4 in
                let t =
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 60077 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 60083 "asllib/Parser0.ml"
                     in
                    
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 60088 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60097 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 60103 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 60109 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60118 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60124 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 60200 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 60207 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60216 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 60222 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 60228 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60237 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60243 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 60319 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 60343 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 60351 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60360 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 60366 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 60372 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60381 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60387 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 60475 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 60481 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 60506 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 60514 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 60522 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60531 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 60537 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 60543 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60552 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60558 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 60669 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 60677 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60686 "asllib/Parser0.ml"
                  
                in
                
# 669 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 60692 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 60698 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60707 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60713 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 60775 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 60781 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 60794 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 60800 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 60805 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 60813 "asllib/Parser0.ml"
                  
                in
                
# 633 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 60819 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60825 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60834 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60840 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 60909 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 60915 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 60928 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 60936 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 60944 "asllib/Parser0.ml"
                  
                in
                
# 633 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 60950 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60956 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60965 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60971 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 61021 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 61033 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 61039 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 61044 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 633 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61051 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61057 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61066 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61072 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 61129 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 61141 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61149 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 633 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61156 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61162 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61171 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61177 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 61235 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 61241 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 61246 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 61252 "asllib/Parser0.ml"
                 in
                
# 633 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61257 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61263 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61272 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61278 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 61343 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61351 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 61357 "asllib/Parser0.ml"
                 in
                
# 633 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61362 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61368 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61377 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61383 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 61466 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 61472 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 61486 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 61491 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61500 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 61508 "asllib/Parser0.ml"
                  
                in
                
# 635 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61514 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61520 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61529 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61535 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 61625 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 61631 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let args =
                  let _1_inlined1 = _1_inlined4 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61647 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61656 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 61664 "asllib/Parser0.ml"
                  
                in
                
# 635 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61670 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61676 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61685 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61691 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 61762 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 61775 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 61780 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61789 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 635 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61796 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61802 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61811 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61817 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 61895 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let _1_inlined1 = _1_inlined4 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61910 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61919 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 635 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61926 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61932 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61941 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61947 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 62027 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 62032 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 62041 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 62047 "asllib/Parser0.ml"
                 in
                
# 635 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 62052 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62058 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62067 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62073 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let _1_inlined1 = _1_inlined4 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 62162 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 62171 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 62177 "asllib/Parser0.ml"
                 in
                
# 635 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 62182 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62188 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62197 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62203 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62247 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 636 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 62253 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 62259 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62268 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62274 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 62325 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 636 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 62331 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 62337 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62346 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62352 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x = 
# 637 "asllib/Parser0.mly"
                                                    AST.S_Assert  
# 62402 "asllib/Parser0.ml"
               expr in
              
# 196 "<standard.mly>"
    ( x )
# 62407 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62416 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62422 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x = 
# 638 "asllib/Parser0.mly"
                                                  ( AST.S_Print { args = [ e ]; newline = true; debug = true } )
# 62472 "asllib/Parser0.ml"
               in
              
# 196 "<standard.mly>"
    ( x )
# 62477 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62486 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62492 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62537 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 62544 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62550 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62559 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62565 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 62627 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 62633 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 62641 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62647 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62656 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62662 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = () in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 62707 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62713 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62722 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62728 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 62783 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 62801 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 62809 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62815 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62824 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62830 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62875 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 62882 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62888 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62897 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62903 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 62965 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 62971 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 62979 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62985 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62994 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63000 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63045 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63052 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63058 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63067 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63073 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 63115 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 63129 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63136 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63142 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63151 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63157 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 63223 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63230 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63236 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63245 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63251 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 63293 "asllib/Parser0.ml"
        ) = Obj.magic _2_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let _1 = () in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63308 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63314 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63323 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63329 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 63371 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63388 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63394 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63403 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63409 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 63451 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63468 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63474 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63483 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63489 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63565 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63572 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63581 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63587 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63596 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63604 "asllib/Parser0.ml"
                 _1_1
              in
              
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63610 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63619 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63625 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63720 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 63726 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63734 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63743 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63749 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63758 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63766 "asllib/Parser0.ml"
                 _1_1
              in
              
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63772 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63781 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63787 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63824 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 63830 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63836 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined3;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined3_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63916 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63923 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 63933 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63939 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63948 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63954 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4;
                      MenhirLib.EngineTypes.startp = _startpos__4_;
                      MenhirLib.EngineTypes.endp = _endpos__4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64075 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64081 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64089 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64099 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64105 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64114 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64120 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4;
                            MenhirLib.EngineTypes.startp = _startpos__4_;
                            MenhirLib.EngineTypes.endp = _endpos__4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 64266 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64273 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64282 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64288 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64297 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64305 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64311 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64320 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64326 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64334 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64344 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64350 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64359 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64365 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _4;
                                MenhirLib.EngineTypes.startp = _startpos__4_;
                                MenhirLib.EngineTypes.endp = _endpos__4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _2;
                                    MenhirLib.EngineTypes.startp = _startpos__2_;
                                    MenhirLib.EngineTypes.endp = _endpos__2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _menhir_s;
                                            MenhirLib.EngineTypes.semv = _1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_;
                                            MenhirLib.EngineTypes.next = _menhir_stack;
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64530 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 64536 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64544 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64553 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64559 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64568 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64576 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64582 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64591 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64597 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64605 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64615 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64621 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64630 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64636 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64743 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 64749 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64755 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64763 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64773 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64779 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64788 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64794 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined5;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined5_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 64892 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64898 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64906 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64916 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64922 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64931 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64937 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined5;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined5_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65038 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65045 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65059 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65066 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65075 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65081 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65090 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65098 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65104 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65113 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65119 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65128 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65134 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 65276 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65282 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65290 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65304 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65311 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65320 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65326 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65335 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65343 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65349 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65358 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65364 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65373 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65379 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _6;
                            MenhirLib.EngineTypes.startp = _startpos__6_;
                            MenhirLib.EngineTypes.endp = _endpos__6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65546 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65553 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65562 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65568 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65577 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65585 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65591 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65600 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65606 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65614 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65628 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65635 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65644 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65650 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65659 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65667 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65673 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65682 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65688 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65697 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65703 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined12;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined10;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined8;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined6;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined5;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _3;
                                              MenhirLib.EngineTypes.startp = _startpos__3_;
                                              MenhirLib.EngineTypes.endp = _endpos__3_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = expr;
                                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65889 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 65895 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65903 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65912 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65918 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65927 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65935 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65941 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65950 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65956 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65964 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65978 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65985 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65994 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66000 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66009 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66017 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66023 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66032 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66038 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66047 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66053 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66181 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 66187 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66193 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66201 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 66215 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66222 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66231 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66237 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66246 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66254 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66260 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66269 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66275 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66284 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66290 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined7;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined7_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 66409 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66415 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66423 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 66437 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66444 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66453 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66459 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66468 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66476 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66482 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66491 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66497 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66506 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66512 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined7;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined7_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 66627 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66634 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66653 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 66659 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66667 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66676 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66682 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66691 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66699 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66705 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66714 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66720 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66729 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66735 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _menhir_s;
                                            MenhirLib.EngineTypes.semv = _1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_;
                                            MenhirLib.EngineTypes.next = _menhir_stack;
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 66891 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66897 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66905 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66924 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 66930 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66938 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66947 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66953 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66962 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66970 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66976 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66985 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66991 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67000 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67006 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined12;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined10;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined9;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined8;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _6;
                            MenhirLib.EngineTypes.startp = _startpos__6_;
                            MenhirLib.EngineTypes.endp = _endpos__6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _3;
                                              MenhirLib.EngineTypes.startp = _startpos__3_;
                                              MenhirLib.EngineTypes.endp = _endpos__3_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = expr;
                                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 67187 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67194 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67203 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67209 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67218 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67226 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67232 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67241 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67247 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67255 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67274 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 67280 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67288 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67297 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67303 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67312 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67320 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67326 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67335 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67341 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67350 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67356 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined14;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined13;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined12;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined11;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined10;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined9;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined8;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined7;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined6;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined5;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined4;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _3;
                                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = expr;
                                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _menhir_s;
                                                      MenhirLib.EngineTypes.semv = _1;
                                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67556 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 67562 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67570 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67579 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67585 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67594 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67602 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67608 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67617 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67623 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67631 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67650 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 67656 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67664 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67673 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67679 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67688 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67696 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67702 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67711 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67717 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67726 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67732 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67874 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 67880 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67886 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67894 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67913 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 67919 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67927 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67936 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67942 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67951 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67959 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67965 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67974 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67980 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67989 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67995 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined9;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined9_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 68128 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 68134 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 68142 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68161 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 68167 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 68175 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68184 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 68190 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68199 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68207 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 68213 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68222 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68228 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68237 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68243 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined2;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 68309 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 68316 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68326 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 68332 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68338 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68347 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68353 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68460 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 68466 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 68474 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68484 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 68490 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68496 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68505 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68511 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 68643 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 68650 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68659 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 68665 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68674 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68682 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 68688 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68697 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 68703 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 68711 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68721 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 68727 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68733 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68742 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68748 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68899 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 68905 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 68913 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68922 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 68928 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68937 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68945 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 68951 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68960 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 68966 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 68974 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68984 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 68990 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68996 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69005 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69011 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69104 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 69110 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 69116 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69124 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69134 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 69140 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69146 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69155 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69161 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined4;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 69245 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 69251 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69259 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69269 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 69275 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69281 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69290 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69296 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined2;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 69355 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69362 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 69370 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69376 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69385 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69391 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69491 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 69497 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69505 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 69513 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69519 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69528 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69534 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 69659 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 69666 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69675 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 69681 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69690 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69698 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 69704 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69713 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 69719 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69727 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 69735 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69741 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69750 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69756 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69900 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 69906 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 69914 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69923 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 69929 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69938 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69946 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 69952 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69961 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 69967 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69975 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 69983 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69989 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69998 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70004 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70090 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 70096 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 70102 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 70110 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 70118 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70124 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70133 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70139 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined4;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 70216 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 70222 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 70230 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 70238 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70244 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70253 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70259 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70344 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 233 "asllib/Parser0.mly"
                      Some  
# 70350 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 697 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 70358 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70367 "asllib/Parser0.ml"
                 _1_1
              in
              
# 712 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70373 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70382 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70388 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _7;
          MenhirLib.EngineTypes.startp = _startpos__7_;
          MenhirLib.EngineTypes.endp = _endpos__7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _5;
              MenhirLib.EngineTypes.startp = _startpos__5_;
              MenhirLib.EngineTypes.endp = _endpos__5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _7 : unit = Obj.magic _7 in
        let _6 : (AST.case_alt list) = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__7_ in
        let _v =
          let x =
            let desc =
              let _6_1 = _6 in
              
# 713 "asllib/Parser0.mly"
                                                            AST.S_Case  
# 70460 "asllib/Parser0.ml"
               (expr, _6_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70469 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70475 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = end_e;
                  MenhirLib.EngineTypes.startp = _startpos_end_e_;
                  MenhirLib.EngineTypes.endp = _endpos_end_e_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = start_e;
                      MenhirLib.EngineTypes.startp = _startpos_start_e_;
                      MenhirLib.EngineTypes.endp = _endpos_start_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 70559 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70575 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 70581 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 764 "asllib/Parser0.mly"
                       ( AST.Up )
# 70588 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 759 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 70595 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70604 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70610 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = end_e;
                      MenhirLib.EngineTypes.startp = _startpos_end_e_;
                      MenhirLib.EngineTypes.endp = _endpos_end_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = start_e;
                          MenhirLib.EngineTypes.startp = _startpos_start_e_;
                          MenhirLib.EngineTypes.endp = _endpos_start_e_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 70708 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70724 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 70733 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 764 "asllib/Parser0.mly"
                       ( AST.Up )
# 70741 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 759 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 70748 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70757 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70763 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = end_e;
                  MenhirLib.EngineTypes.startp = _startpos_end_e_;
                  MenhirLib.EngineTypes.endp = _endpos_end_e_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = start_e;
                      MenhirLib.EngineTypes.startp = _startpos_start_e_;
                      MenhirLib.EngineTypes.endp = _endpos_start_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 70847 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70863 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 70869 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 764 "asllib/Parser0.mly"
                                            ( AST.Down )
# 70876 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 759 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 70883 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70892 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70898 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = end_e;
                      MenhirLib.EngineTypes.startp = _startpos_end_e_;
                      MenhirLib.EngineTypes.endp = _endpos_end_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = start_e;
                          MenhirLib.EngineTypes.startp = _startpos_start_e_;
                          MenhirLib.EngineTypes.endp = _endpos_start_e_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 70996 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71012 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 71021 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 764 "asllib/Parser0.mly"
                                            ( AST.Down )
# 71029 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 759 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 71036 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71045 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71051 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _4 : unit = Obj.magic _4 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_inlined1_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71126 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 71132 "asllib/Parser0.ml"
               in
              let _3_1 = _3 in
              
# 760 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 71138 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71147 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71153 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _4 : unit = Obj.magic _4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_inlined1_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71242 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 =
                let _1 = _1_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 71251 "asllib/Parser0.ml"
                
              in
              let _3_1 = _3 in
              
# 760 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 71258 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71267 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71273 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _7;
          MenhirLib.EngineTypes.startp = _startpos__7_;
          MenhirLib.EngineTypes.endp = _endpos__7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__7_ in
        let _v =
          let x =
            let desc =
              let _5 = 
# 123 "<standard.mly>"
    ( None )
# 71358 "asllib/Parser0.ml"
               in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71367 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 762 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 71374 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71383 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71389 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _7;
          MenhirLib.EngineTypes.startp = _startpos__7_;
          MenhirLib.EngineTypes.endp = _endpos__7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4;
                      MenhirLib.EngineTypes.startp = _startpos__4_;
                      MenhirLib.EngineTypes.endp = _endpos__4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__7_ in
        let _v =
          let x =
            let desc =
              let _5 =
                let (_2, _1) = (_2_inlined1, _1_inlined3) in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 71491 "asllib/Parser0.ml"
                
              in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71501 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 762 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 71508 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71517 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71523 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 71609 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 71628 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71639 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 71649 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71658 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71664 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _5;
                          MenhirLib.EngineTypes.startp = _startpos__5_;
                          MenhirLib.EngineTypes.endp = _endpos__5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _4_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _2;
                                    MenhirLib.EngineTypes.startp = _startpos__2_;
                                    MenhirLib.EngineTypes.endp = _endpos__2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 71785 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71811 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71820 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 71826 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71838 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 71848 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71857 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71863 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _5;
                                MenhirLib.EngineTypes.startp = _startpos__5_;
                                MenhirLib.EngineTypes.endp = _endpos__5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _4_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _2;
                                          MenhirLib.EngineTypes.startp = _startpos__2_;
                                          MenhirLib.EngineTypes.endp = _endpos__2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 72005 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 72035 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72042 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72051 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72057 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72066 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72074 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72080 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72089 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72098 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 72104 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 72116 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 72126 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72135 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 72141 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined10;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined6;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined5;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _5;
                                    MenhirLib.EngineTypes.startp = _startpos__5_;
                                    MenhirLib.EngineTypes.endp = _endpos__5_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _4_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _2;
                                              MenhirLib.EngineTypes.startp = _startpos__2_;
                                              MenhirLib.EngineTypes.endp = _endpos__2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 72297 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72332 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 72338 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72346 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72355 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72361 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72370 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72378 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72384 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72393 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72402 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 72408 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 72420 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 72430 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72439 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 72445 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 72552 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72578 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 72584 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72593 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 72599 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 72611 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 72621 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72630 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 72636 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _5;
                    MenhirLib.EngineTypes.startp = _startpos__5_;
                    MenhirLib.EngineTypes.endp = _endpos__5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _4_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 72736 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 72760 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72769 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 72775 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 72787 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 72797 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72806 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 72812 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 72895 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72902 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72911 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72917 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72926 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72934 "asllib/Parser0.ml"
                 _1_1
              in
              
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72940 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72949 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72955 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73057 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 73063 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73071 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73080 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73086 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73095 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73103 "asllib/Parser0.ml"
                 _1_1
              in
              
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73109 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73118 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73124 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73168 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 73174 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73180 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 73267 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73274 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73284 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73290 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73299 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73305 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73433 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73439 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73447 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73457 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73463 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73472 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73478 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4;
                              MenhirLib.EngineTypes.startp = _startpos__4_;
                              MenhirLib.EngineTypes.endp = _endpos__4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 73631 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73638 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73647 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73653 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73662 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73670 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73676 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73685 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73691 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73699 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73709 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73715 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73724 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73730 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4;
                                  MenhirLib.EngineTypes.startp = _startpos__4_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73902 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 73908 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73916 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73925 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73931 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73940 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73948 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73954 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73963 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73969 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73977 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73987 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73993 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74002 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74008 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74122 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 74128 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 74134 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74142 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 74152 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74158 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74167 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74173 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 74278 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 74284 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74292 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 74302 "asllib/Parser0.ml"
                 _3_1
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74308 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74317 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74323 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 74431 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74438 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 74452 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74459 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74468 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74474 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74483 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74491 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74497 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74506 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74512 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74521 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74527 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 74676 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 74682 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74690 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 74704 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74711 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74720 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74726 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74735 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74743 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74749 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74758 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74764 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74773 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74779 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3;
                                            MenhirLib.EngineTypes.startp = _startpos__3_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 74953 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74960 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74969 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74975 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74984 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74992 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74998 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75007 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75013 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75021 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75035 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75042 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75051 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75057 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75066 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75074 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75080 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75089 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75095 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75104 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75110 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75303 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 75309 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75317 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75326 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75332 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75341 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75349 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75355 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75364 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75370 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75378 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75392 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75399 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75408 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75414 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75423 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75431 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75437 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75446 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75452 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75461 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75467 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75602 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 75608 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75614 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75622 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75636 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75643 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75652 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75658 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75667 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75675 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75681 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75690 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75696 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75705 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75711 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 75837 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75843 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75851 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75865 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75872 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75881 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75887 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75896 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75904 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75910 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75919 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75925 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75934 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75940 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 76062 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76069 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76088 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 76094 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 76102 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76111 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 76117 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76126 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76134 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 76140 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76149 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76155 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76164 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76170 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 76333 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76339 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76347 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76366 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 76372 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 76380 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76389 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 76395 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76404 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76412 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 76418 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76427 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76433 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76442 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76448 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined10;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined9;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined6;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined5;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 76636 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 76643 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76652 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 76658 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76667 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76675 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 76681 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76690 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76696 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76704 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76723 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 76729 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 76737 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76746 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 76752 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76761 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76769 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 76775 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76784 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76790 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76799 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76805 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined14;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined13;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined12;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined11;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined10;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined9;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined8;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined7;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined6;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined5;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined4;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined3;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = _3;
                                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _;
                                                      MenhirLib.EngineTypes.semv = expr;
                                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                      MenhirLib.EngineTypes.next = {
                                                        MenhirLib.EngineTypes.state = _menhir_s;
                                                        MenhirLib.EngineTypes.semv = _1;
                                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                                      };
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77012 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 77018 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 77026 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77035 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 77041 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77050 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77058 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 77064 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77073 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 77079 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 77087 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77106 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 77112 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 77120 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77129 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 77135 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77144 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77152 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 77158 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77167 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77173 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77182 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77188 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77337 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 77343 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 77349 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 77357 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77376 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 77382 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 77390 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77399 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 77405 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77414 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77422 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 77428 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77437 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77443 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77452 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77458 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 77598 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 77604 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 77612 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77631 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 77637 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 77645 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77654 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 77660 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77669 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77677 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 77683 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77692 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77698 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77707 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77713 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 77786 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 77793 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77803 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 77809 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77815 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77824 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77830 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 77944 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 77950 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 77958 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77968 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 77974 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77980 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77989 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77995 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 78134 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 78141 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78150 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 78156 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78165 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78173 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 78179 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78188 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 78194 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 78202 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78212 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 78218 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 78224 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78233 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78239 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78397 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 78403 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 78411 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78420 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 78426 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78435 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78443 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 78449 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78458 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 78464 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 78472 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78482 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 78488 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 78494 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78503 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78509 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78609 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 78615 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 78621 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 78629 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78639 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 78645 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 78651 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78660 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78666 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 78757 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 78763 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 78771 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78781 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 78787 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 78793 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78802 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78808 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 78874 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 78881 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 78889 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 78895 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78904 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78910 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 79017 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 79023 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 79031 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79039 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 79045 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79054 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79060 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 79192 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 79199 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79208 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 79214 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79223 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79231 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 79237 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79246 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 79252 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 79260 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79268 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 79274 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79283 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79289 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79440 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 79446 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 79454 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79463 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 79469 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79478 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79486 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 79492 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79501 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 79507 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 79515 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79523 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 79529 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79538 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79544 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79637 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 79643 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 79649 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 79657 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79665 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 79671 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79680 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79686 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79770 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 79776 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 716 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 79784 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79792 "asllib/Parser0.ml"
                
              in
              
# 711 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 79798 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79807 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79813 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79905 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 233 "asllib/Parser0.mly"
                      Some  
# 79911 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 697 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 79919 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79928 "asllib/Parser0.ml"
                 _1_1
              in
              
# 712 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 79934 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79943 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79949 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : (AST.case_alt list) = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _6_1 = _6 in
              
# 713 "asllib/Parser0.mly"
                                                            AST.S_Case  
# 80028 "asllib/Parser0.ml"
               (expr, _6_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80037 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80043 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 80134 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 80150 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 80156 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 764 "asllib/Parser0.mly"
                       ( AST.Up )
# 80163 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 759 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 80170 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80179 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80185 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 80290 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 80306 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 80315 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 764 "asllib/Parser0.mly"
                       ( AST.Up )
# 80323 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 759 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 80330 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80339 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80345 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 80436 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 80452 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 80458 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 764 "asllib/Parser0.mly"
                                            ( AST.Down )
# 80465 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 759 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 80472 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80481 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80487 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 80592 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 80608 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 80617 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 764 "asllib/Parser0.mly"
                                            ( AST.Down )
# 80625 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 759 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 80632 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80641 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80647 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _4 : unit = Obj.magic _4 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 80729 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 80735 "asllib/Parser0.ml"
               in
              let _3_1 = _3 in
              
# 760 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 80741 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80750 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80756 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _4 : unit = Obj.magic _4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 80852 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 =
                let _1 = _1_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 80861 "asllib/Parser0.ml"
                
              in
              let _3_1 = _3 in
              
# 760 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 80868 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80877 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80883 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 = 
# 123 "<standard.mly>"
    ( None )
# 80975 "asllib/Parser0.ml"
               in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 80984 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 762 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 80991 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81000 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 81006 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 =
                let (_2, _1) = (_2_inlined1, _1_inlined3) in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 81115 "asllib/Parser0.ml"
                
              in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 81125 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 762 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 81132 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81141 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 81147 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _5;
                  MenhirLib.EngineTypes.startp = _startpos__5_;
                  MenhirLib.EngineTypes.endp = _endpos__5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 81240 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 81259 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 81270 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 81280 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81289 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 81295 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _6;
                          MenhirLib.EngineTypes.startp = _startpos__6_;
                          MenhirLib.EngineTypes.endp = _endpos__6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _5;
                            MenhirLib.EngineTypes.startp = _startpos__5_;
                            MenhirLib.EngineTypes.endp = _endpos__5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 81423 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 81449 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81458 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 81464 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 81476 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 81486 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81495 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 81501 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _5;
                                  MenhirLib.EngineTypes.startp = _startpos__5_;
                                  MenhirLib.EngineTypes.endp = _endpos__5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _4_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _2;
                                            MenhirLib.EngineTypes.startp = _startpos__2_;
                                            MenhirLib.EngineTypes.endp = _endpos__2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 81650 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 81680 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 81687 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 81696 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 81702 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81711 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 81719 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 81725 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81734 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81743 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 81749 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 81761 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 81771 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81780 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 81786 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _6;
                                    MenhirLib.EngineTypes.startp = _startpos__6_;
                                    MenhirLib.EngineTypes.endp = _endpos__6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _5;
                                      MenhirLib.EngineTypes.startp = _startpos__5_;
                                      MenhirLib.EngineTypes.endp = _endpos__5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _4_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _2;
                                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 81949 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 81984 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 81990 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 696 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 81998 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 82007 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 693 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 82013 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82022 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 82030 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 623 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 82036 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82045 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82054 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 82060 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 82072 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 82082 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82091 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 82097 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _5;
                        MenhirLib.EngineTypes.startp = _startpos__5_;
                        MenhirLib.EngineTypes.endp = _endpos__5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82211 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 627 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 82237 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 82243 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82252 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 82258 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 82270 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 82280 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82289 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 82295 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82402 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 599 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 82426 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82435 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 82441 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 606 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 82453 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 614 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 82463 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82472 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 82478 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82506 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 82516 "asllib/Parser0.ml"
           in
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 316 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 82524 "asllib/Parser0.ml"
            
          in
          (
# 305 "asllib/Parser0.mly"
                                ( [ x ]  )
# 82530 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82565 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 82575 "asllib/Parser0.ml"
           in
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 316 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 82583 "asllib/Parser0.ml"
            
          in
          (
# 305 "asllib/Parser0.mly"
                                ( [ x ]  )
# 82589 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let t : (AST.bitfield list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82631 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 316 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 82644 "asllib/Parser0.ml"
            
          in
          (
# 306 "asllib/Parser0.mly"
                                ( x :: t )
# 82650 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82678 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 82688 "asllib/Parser0.ml"
           in
          let x =
            let x = _1 in
            
# 293 "asllib/Parser0.mly"
                               ( (x, t) )
# 82695 "asllib/Parser0.ml"
            
          in
          (
# 305 "asllib/Parser0.mly"
                                ( [ x ]  )
# 82701 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82736 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 82746 "asllib/Parser0.ml"
           in
          let x =
            let x = _1 in
            
# 293 "asllib/Parser0.mly"
                               ( (x, t) )
# 82753 "asllib/Parser0.ml"
            
          in
          (
# 305 "asllib/Parser0.mly"
                                ( [ x ]  )
# 82759 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t_inlined1;
                MenhirLib.EngineTypes.startp = _startpos_t_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos_t_inlined1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let t : (AST.field list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82801 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t_inlined1 : (AST.ty) = Obj.magic t_inlined1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_inlined1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x =
            let t = t_inlined1 in
            let x = _1 in
            
# 293 "asllib/Parser0.mly"
                               ( (x, t) )
# 82814 "asllib/Parser0.ml"
            
          in
          (
# 306 "asllib/Parser0.mly"
                                ( x :: t )
# 82820 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82842 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 82851 "asllib/Parser0.ml"
           in
          let x = _1 in
          (
# 305 "asllib/Parser0.mly"
                                ( [ x ]  )
# 82857 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82886 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 82895 "asllib/Parser0.ml"
           in
          let x = _1 in
          (
# 305 "asllib/Parser0.mly"
                                ( [ x ]  )
# 82901 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let t : (string list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82937 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x = _1 in
          (
# 306 "asllib/Parser0.mly"
                                ( x :: t )
# 82947 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = body;
            MenhirLib.EngineTypes.startp = _startpos_body_;
            MenhirLib.EngineTypes.endp = _endpos_body_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let body : (AST.stmt list) = Obj.magic body in
        let _1 : (unit list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.t) = 
# 238 "asllib/Parser0.mly"
    (
      let body = ASTUtils.stmt_from_list body in
      AST.[
        D_Func {
          name = "main";
          args = [];
          parameters = [];
          body = SB_ASL body;
          return_type = None;
          subprogram_type = ST_Procedure;
          recurse_limit = None;
          builtin = false;
        } |> ASTUtils.add_pos_from body
      ]
    )
# 83001 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_expr_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let x =
            let desc = 
# 750 "asllib/Parser0.mly"
                AST.Pattern_Single  
# 83028 "asllib/Parser0.ml"
             expr in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos_expr_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83036 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83042 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x =
            let desc = 
# 751 "asllib/Parser0.mly"
                                   AST.Pattern_Range  
# 83084 "asllib/Parser0.ml"
             (e1, e2) in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83092 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83098 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc = 
# 735 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 83126 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83134 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83140 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 83162 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 734 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 83174 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83183 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83189 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_expr_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 750 "asllib/Parser0.mly"
                AST.Pattern_Single  
# 83231 "asllib/Parser0.ml"
             expr in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos_expr_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83239 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83245 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            let desc = 
# 751 "asllib/Parser0.mly"
                                   AST.Pattern_Range  
# 83302 "asllib/Parser0.ml"
             (e1, e2) in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83310 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83316 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 735 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 83358 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83366 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83372 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 83408 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 734 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 83420 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83429 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83435 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.expr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.expr list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 83461 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.expr list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.expr list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 83500 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 83527 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            
# 597 "asllib/Parser0.mly"
                             ( (x, t) )
# 83539 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83545 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 83587 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            
# 597 "asllib/Parser0.mly"
                             ( (x, t) )
# 83599 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83605 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 83627 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = _1 in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83637 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (string list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 83673 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = _1 in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83683 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 83705 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = _1 in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83715 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = 
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 83742 "asllib/Parser0.ml"
           in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83747 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = 
# 655 "asllib/Parser0.mly"
                         ( ASTUtils.fresh_var "__ldi_discard" )
# 83774 "asllib/Parser0.ml"
           in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83779 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (string list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 83815 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = _1 in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83825 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (string list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = 
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 83866 "asllib/Parser0.ml"
           in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83871 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (string list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = 
# 655 "asllib/Parser0.mly"
                         ( ASTUtils.fresh_var "__ldi_discard" )
# 83912 "asllib/Parser0.ml"
           in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83917 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.lexpr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.lexpr list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 83943 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.lexpr list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.lexpr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.lexpr list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 83982 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 747 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 84027 "asllib/Parser0.ml"
                 _1_1
              in
              
# 205 "<standard.mly>"
    ( x )
# 84033 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84042 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84048 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 84070 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 734 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 84082 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84091 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84097 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc = 
# 735 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 84125 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84133 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84139 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 87 "asllib/Parser0.mly"
       (bool)
# 84161 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 401 "asllib/Parser0.mly"
                       AST.L_Bool        
# 84176 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 743 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 84182 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84191 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84198 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84207 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84213 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Z.t)
# 84235 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 402 "asllib/Parser0.mly"
                       AST.L_Int         
# 84250 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 743 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 84256 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84265 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84272 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84281 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84287 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 86 "asllib/Parser0.mly"
       (Q.t)
# 84309 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 403 "asllib/Parser0.mly"
                       AST.L_Real        
# 84324 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 743 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 84330 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84339 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84346 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84355 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84361 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (Bitvector.t)
# 84383 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 404 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 84398 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 743 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 84404 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84413 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84420 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84429 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84435 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 84457 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 405 "asllib/Parser0.mly"
                       AST.L_String      
# 84472 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 743 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 84478 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84487 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84494 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84503 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84509 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 84543 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 84549 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident =
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 84564 "asllib/Parser0.ml"
                    
                  in
                  
# 744 "asllib/Parser0.mly"
                         AST.E_Var  
# 84570 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84579 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84586 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84595 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84601 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 84623 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = _1 in
                  
# 744 "asllib/Parser0.mly"
                         AST.E_Var  
# 84637 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84646 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84653 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84662 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84668 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 84699 "asllib/Parser0.ml"
                   in
                  
# 744 "asllib/Parser0.mly"
                         AST.E_Var  
# 84704 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84713 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84720 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84729 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84735 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 747 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 84795 "asllib/Parser0.ml"
                 _1_1
              in
              
# 205 "<standard.mly>"
    ( x )
# 84801 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84810 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 84816 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 84852 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 734 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 84864 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84873 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 84879 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 735 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 84921 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84929 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 84935 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 87 "asllib/Parser0.mly"
       (bool)
# 84971 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 401 "asllib/Parser0.mly"
                       AST.L_Bool        
# 84986 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 743 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 84992 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85001 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85008 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85017 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85023 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Z.t)
# 85059 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 402 "asllib/Parser0.mly"
                       AST.L_Int         
# 85074 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 743 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 85080 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85089 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85096 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85105 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85111 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 86 "asllib/Parser0.mly"
       (Q.t)
# 85147 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 403 "asllib/Parser0.mly"
                       AST.L_Real        
# 85162 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 743 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 85168 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85177 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85184 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85193 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85199 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (Bitvector.t)
# 85235 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 404 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 85250 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 743 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 85256 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85265 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85272 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85281 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85287 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 85323 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 405 "asllib/Parser0.mly"
                       AST.L_String      
# 85338 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 743 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 85344 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85353 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85360 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85369 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85375 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 85423 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 85429 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            let desc =
              let _1 =
                let desc =
                  let qualident =
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 85445 "asllib/Parser0.ml"
                    
                  in
                  
# 744 "asllib/Parser0.mly"
                         AST.E_Var  
# 85451 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85460 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85467 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85476 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85482 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 85518 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = _1 in
                  
# 744 "asllib/Parser0.mly"
                         AST.E_Var  
# 85532 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85541 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85548 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85557 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85563 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 85608 "asllib/Parser0.ml"
                   in
                  
# 744 "asllib/Parser0.mly"
                         AST.E_Var  
# 85613 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85622 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 745 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85629 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85638 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85644 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 85672 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 85684 "asllib/Parser0.ml"
             in
            
# 596 "asllib/Parser0.mly"
                                            ( (x, t) )
# 85689 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 85695 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x_inlined1;
            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 85729 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            let _2 =
              let x = x_inlined1 in
              
# 126 "<standard.mly>"
    ( Some x )
# 85744 "asllib/Parser0.ml"
              
            in
            
# 596 "asllib/Parser0.mly"
                                            ( (x, t) )
# 85750 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 85756 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 85798 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 85810 "asllib/Parser0.ml"
             in
            
# 596 "asllib/Parser0.mly"
                                            ( (x, t) )
# 85815 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85821 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x_inlined1;
                MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = t;
                  MenhirLib.EngineTypes.startp = _startpos_t_;
                  MenhirLib.EngineTypes.endp = _endpos_t_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 85869 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            let _2 =
              let x = x_inlined1 in
              
# 126 "<standard.mly>"
    ( Some x )
# 85884 "asllib/Parser0.ml"
              
            in
            
# 596 "asllib/Parser0.mly"
                                            ( (x, t) )
# 85890 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85896 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = sexpr;
          MenhirLib.EngineTypes.startp = _startpos_sexpr_;
          MenhirLib.EngineTypes.endp = _endpos_sexpr_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let sexpr : (AST.expr) = Obj.magic sexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_sexpr_ in
        let _endpos = _endpos_sexpr_ in
        let _v =
          let x = 
# 396 "asllib/Parser0.mly"
                                      AST.Slice_Single  
# 85923 "asllib/Parser0.ml"
           sexpr in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 85928 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x = 
# 397 "asllib/Parser0.mly"
                                      AST.Slice_Range   
# 85969 "asllib/Parser0.ml"
           (e1, e2) in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 85974 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x = 
# 398 "asllib/Parser0.mly"
                                      AST.Slice_Length  
# 86015 "asllib/Parser0.ml"
           (e1, e2) in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 86020 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = sexpr;
              MenhirLib.EngineTypes.startp = _startpos_sexpr_;
              MenhirLib.EngineTypes.endp = _endpos_sexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let sexpr : (AST.expr) = Obj.magic sexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_sexpr_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = 
# 396 "asllib/Parser0.mly"
                                      AST.Slice_Single  
# 86061 "asllib/Parser0.ml"
           sexpr in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 86066 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            
# 397 "asllib/Parser0.mly"
                                      AST.Slice_Range   
# 86123 "asllib/Parser0.ml"
             (e1, e2)
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 86129 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            
# 398 "asllib/Parser0.mly"
                                      AST.Slice_Length  
# 86186 "asllib/Parser0.ml"
             (e1, e2)
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 86192 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.ty list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 86218 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.ty list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.ty list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 86257 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.expr) = 
# 205 "<standard.mly>"
    ( x )
# 86296 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 87 "asllib/Parser0.mly"
       (bool)
# 86317 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 401 "asllib/Parser0.mly"
                       AST.L_Bool        
# 86329 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 86335 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86344 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Z.t)
# 86366 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 402 "asllib/Parser0.mly"
                       AST.L_Int         
# 86378 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 86384 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86393 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 86 "asllib/Parser0.mly"
       (Q.t)
# 86415 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 403 "asllib/Parser0.mly"
                       AST.L_Real        
# 86427 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 86433 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86442 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (Bitvector.t)
# 86464 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 404 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 86476 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 86482 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86491 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 86513 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 405 "asllib/Parser0.mly"
                       AST.L_String      
# 86525 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 86531 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86540 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 86574 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 86580 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 86592 "asllib/Parser0.ml"
              
            in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 86598 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86607 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 86629 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 86640 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86649 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 86677 "asllib/Parser0.ml"
             in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 86682 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86691 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 86739 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 86745 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 86755 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 86761 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 86766 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 86774 "asllib/Parser0.ml"
              
            in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 86780 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86789 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 86844 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 86850 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 86860 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 86868 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 86876 "asllib/Parser0.ml"
              
            in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 86882 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86891 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 86927 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 86937 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 86943 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 86948 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 86955 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86964 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 87007 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 87017 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87025 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87032 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87041 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 87083 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 87089 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87094 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 87100 "asllib/Parser0.ml"
             in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87105 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87114 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 87163 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87171 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 87177 "asllib/Parser0.ml"
             in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87182 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87191 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 87253 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 87259 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 87270 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87275 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 87282 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87287 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 87295 "asllib/Parser0.ml"
              
            in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87301 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87310 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.expr list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 87379 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 87385 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87398 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 87405 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87410 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 87418 "asllib/Parser0.ml"
              
            in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87424 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87433 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 87502 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 87508 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 87519 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87524 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87533 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 87541 "asllib/Parser0.ml"
              
            in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87547 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87556 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 87632 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 87638 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined4 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87651 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87660 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 87668 "asllib/Parser0.ml"
              
            in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87674 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87683 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 87733 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 87744 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87749 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 87756 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87761 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87768 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87777 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.expr list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 87834 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87847 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 87854 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87859 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87866 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87875 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 87932 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 87943 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87948 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87957 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87964 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87973 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 88037 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined4 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88050 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88059 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 88066 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88075 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 88132 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 88137 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 88144 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 88149 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 88155 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 88160 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88169 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.expr list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88235 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 88242 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 88247 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 88253 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 88258 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88267 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 88331 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 88336 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88345 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 88351 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 88356 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88365 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined4 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88438 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88447 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 88453 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 88458 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88467 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 772 "asllib/Parser0.mly"
            ( AST.BNOT )
# 88502 "asllib/Parser0.ml"
             in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 88507 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88516 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 773 "asllib/Parser0.mly"
            ( AST.NEG )
# 88551 "asllib/Parser0.ml"
             in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 88556 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88565 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 774 "asllib/Parser0.mly"
            ( AST.NOT )
# 88600 "asllib/Parser0.ml"
             in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 88605 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88614 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 779 "asllib/Parser0.mly"
                 ( AST.AND    )
# 88656 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 88661 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88670 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 780 "asllib/Parser0.mly"
                 ( AST.BAND   )
# 88712 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 88717 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88726 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 781 "asllib/Parser0.mly"
                 ( AST.BOR    )
# 88768 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 88773 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88782 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 782 "asllib/Parser0.mly"
                 ( AST.DIV    )
# 88824 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 88829 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88838 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 783 "asllib/Parser0.mly"
                 ( AST.EOR    )
# 88880 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 88885 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88894 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 784 "asllib/Parser0.mly"
                 ( AST.EQ_OP  )
# 88936 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 88941 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88950 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 785 "asllib/Parser0.mly"
                 ( AST.NEQ    )
# 88992 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 88997 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89006 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 786 "asllib/Parser0.mly"
                 ( AST.GEQ    )
# 89048 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89053 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89062 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 787 "asllib/Parser0.mly"
                 ( AST.IMPL   )
# 89104 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89109 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89118 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 788 "asllib/Parser0.mly"
                 ( AST.LEQ    )
# 89160 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89165 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89174 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 789 "asllib/Parser0.mly"
                 ( AST.PLUS   )
# 89216 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89221 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89230 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 790 "asllib/Parser0.mly"
                 ( AST.MINUS  )
# 89272 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89277 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89286 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 791 "asllib/Parser0.mly"
                 ( AST.MOD    )
# 89328 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89333 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89342 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 792 "asllib/Parser0.mly"
                 ( AST.MUL    )
# 89384 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89389 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89398 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 793 "asllib/Parser0.mly"
                 ( AST.OR     )
# 89440 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89445 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89454 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 794 "asllib/Parser0.mly"
                 ( AST.RDIV   )
# 89496 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89501 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89510 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 795 "asllib/Parser0.mly"
                 ( AST.SHL    )
# 89552 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89557 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89566 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 796 "asllib/Parser0.mly"
                 ( AST.SHR    )
# 89608 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89613 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89622 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 776 "asllib/Parser0.mly"
                                  ( AST.PLUS )
# 89664 "asllib/Parser0.ml"
             in
            
# 372 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89669 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89678 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.expr) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 89738 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 89744 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 373 "asllib/Parser0.mly"
                                                        AST.E_Tuple      
# 89751 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89760 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = c;
                    MenhirLib.EngineTypes.startp = _startpos_c_;
                    MenhirLib.EngineTypes.endp = _endpos_c_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let desc =
            let e_else =
              let _1 = _1_inlined1 in
              let _1_1 = _1 in
              
# 393 "asllib/Parser0.mly"
                                                build_expr_conds  
# 89833 "asllib/Parser0.ml"
               (_1_1, expr)
            in
            
# 374 "asllib/Parser0.mly"
                                                        AST.E_Cond       
# 89839 "asllib/Parser0.ml"
             (c, e, e_else)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89848 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 89882 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 375 "asllib/Parser0.mly"
                                                        AST.E_GetField   
# 89895 "asllib/Parser0.ml"
             (e, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89904 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 89954 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 89959 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 376 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 89966 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89975 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 90033 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 376 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 90040 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90049 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 90092 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 90097 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 377 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 90104 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90113 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 90164 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 377 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 90171 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90180 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 90216 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 90221 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 378 "asllib/Parser0.mly"
                                                        make_concat      
# 90228 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90237 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 90281 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 378 "asllib/Parser0.mly"
                                                        make_concat      
# 90288 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90297 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let bpattern =
              let desc =
                let x =
                  let _1 = _1_inlined1 in
                  let _1_1 = _1 in
                  
# 747 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 90358 "asllib/Parser0.ml"
                   _1_1
                in
                
# 205 "<standard.mly>"
    ( x )
# 90364 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90373 "asllib/Parser0.ml"
              
            in
            
# 379 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 90379 "asllib/Parser0.ml"
             (e, bpattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90388 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 90422 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern_mask =
              let desc =
                let _1_1 = _1 in
                
# 734 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 90437 "asllib/Parser0.ml"
                 _1_1
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90446 "asllib/Parser0.ml"
              
            in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 90452 "asllib/Parser0.ml"
             (e, pattern_mask)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90461 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1_inlined1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 90495 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let desc =
            let _2 =
              let desc =
                let pm =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let _1_1 = _1 in
                    
# 734 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 90513 "asllib/Parser0.ml"
                     _1_1
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90522 "asllib/Parser0.ml"
                  
                in
                
# 381 "asllib/Parser0.mly"
                                                     AST.Pattern_Not  
# 90528 "asllib/Parser0.ml"
                 pm
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90537 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 381 "asllib/Parser0.mly"
                                                                           AST.E_Pattern  
# 90544 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90553 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 90589 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90597 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 90604 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90613 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 90649 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90657 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 90664 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90673 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 90709 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90717 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 90724 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90733 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 90762 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let tident = _1 in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 90775 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90784 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 90791 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90800 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 90841 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 90847 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let tident =
                  let i = _1 in
                  
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 90862 "asllib/Parser0.ml"
                  
                in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 90868 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90877 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 90884 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90893 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 90929 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90937 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 90944 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90953 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 91011 "asllib/Parser0.ml"
                 in
                
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 91016 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91025 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91032 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91041 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 91123 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 91129 "asllib/Parser0.ml"
                 in
                
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 91134 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91143 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91150 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91159 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 91218 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 91225 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91234 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91241 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91250 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 91312 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 91333 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 91341 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91350 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91357 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91366 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 91440 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 91446 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 91468 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 91476 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 91484 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91493 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91500 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91509 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 91603 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 91611 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91620 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91627 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91636 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 91672 "asllib/Parser0.ml"
               in
              let _1 = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 91677 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 91684 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91693 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 91727 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 91740 "asllib/Parser0.ml"
               in
              let _1 = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 91745 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 91752 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91761 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 91797 "asllib/Parser0.ml"
               in
              let _1 = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 91802 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 91809 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91818 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 91852 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 91865 "asllib/Parser0.ml"
               in
              let _1 = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 91870 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 91877 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91886 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 91922 "asllib/Parser0.ml"
               in
              let _1 = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 91927 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 91934 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91943 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 91977 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 91990 "asllib/Parser0.ml"
               in
              let _1 = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 91995 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92002 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92011 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 92040 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 92051 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 92058 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92066 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92075 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 92109 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 92115 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 92126 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 92133 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92141 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92150 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 92191 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 92197 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 92208 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 92217 "asllib/Parser0.ml"
                  
                in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 92223 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92231 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92240 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 92286 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 92292 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 92298 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 92309 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 92318 "asllib/Parser0.ml"
                  
                in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 92324 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92332 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92341 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 92377 "asllib/Parser0.ml"
               in
              let _1 = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 92382 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92389 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92398 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 92432 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 92445 "asllib/Parser0.ml"
               in
              let _1 = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 92450 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92457 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92466 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 92523 "asllib/Parser0.ml"
               in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 92529 "asllib/Parser0.ml"
                 in
                
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 92534 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92542 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92551 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 92603 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 92621 "asllib/Parser0.ml"
                
              in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 92628 "asllib/Parser0.ml"
                 in
                
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 92633 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92641 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92650 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 92728 "asllib/Parser0.ml"
               in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 92737 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 92743 "asllib/Parser0.ml"
                 in
                
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 92748 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92756 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92765 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 92835 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 92856 "asllib/Parser0.ml"
                
              in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 92866 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 92872 "asllib/Parser0.ml"
                 in
                
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 92877 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92885 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92894 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 92951 "asllib/Parser0.ml"
               in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 92958 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 92965 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92973 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92982 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 93034 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 93052 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 93060 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93067 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93075 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93084 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 93146 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 93159 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 93173 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93181 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93189 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93198 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 93262 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 93271 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 93284 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 93298 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93306 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93314 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93323 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 93397 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 93403 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 93416 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 93430 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 93438 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93446 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93454 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93463 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 93539 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 93548 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 93554 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 93567 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 93581 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 93589 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93597 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93605 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93614 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 93699 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 93713 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93721 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93729 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93738 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 93814 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 93834 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 93848 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93856 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93864 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93873 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.decl option list) = Obj.magic x in
        let _1 : (unit list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x = 
# 232 "asllib/Parser0.mly"
                      ( List.filter_map Fun.id x )
# 93914 "asllib/Parser0.ml"
           in
          (
# 196 "<standard.mly>"
    ( x )
# 93919 "asllib/Parser0.ml"
           : (AST.t))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 93946 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93954 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 93981 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93989 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 94016 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94024 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 94046 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let tident = _1 in
            
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 94057 "asllib/Parser0.ml"
             tident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94066 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 94100 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 94106 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let tident =
              let i = _1 in
              
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 94118 "asllib/Parser0.ml"
              
            in
            
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 94124 "asllib/Parser0.ml"
             tident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94133 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 94160 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94168 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let e = 
# 205 "<standard.mly>"
    ( x )
# 94217 "asllib/Parser0.ml"
             in
            
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 94222 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94231 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let b =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 94304 "asllib/Parser0.ml"
              
            in
            let e = 
# 205 "<standard.mly>"
    ( x )
# 94310 "asllib/Parser0.ml"
             in
            
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 94315 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94324 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let _2 = 
# 205 "<standard.mly>"
    ( x )
# 94374 "asllib/Parser0.ml"
               in
              ()
            in
            
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 94381 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94390 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 94445 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let _1 = _1_inlined1 in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 94464 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 94472 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94481 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 94548 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 94554 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let _1 = _1_inlined1 in
                  let _1 =
                    let i = _1 in
                    
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 94573 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 94581 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 94589 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94598 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let (_3, _1) = (_3_inlined1, _1_inlined1) in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 94682 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 94690 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94699 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.ty list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.ty) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 94759 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 94765 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 312 "asllib/Parser0.mly"
                              AST.T_Tuple  
# 94772 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94781 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
    |]
  
  and trace =
    None
  
end

module MenhirInterpreter = struct
  
  module ET = MenhirLib.TableInterpreter.MakeEngineTable (Tables)
  
  module TI = MenhirLib.Engine.Make (ET)
  
  include TI
  
end

let spec =
  fun lexer lexbuf : (AST.t) ->
    Obj.magic (MenhirInterpreter.entry `Legacy 1760 lexer lexbuf)

and opn =
  fun lexer lexbuf : (AST.t) ->
    Obj.magic (MenhirInterpreter.entry `Legacy 0 lexer lexbuf)

module Incremental = struct
  
  let spec =
    fun initial_position : (AST.t) MenhirInterpreter.checkpoint ->
      Obj.magic (MenhirInterpreter.start 1760 initial_position)
  
  and opn =
    fun initial_position : (AST.t) MenhirInterpreter.checkpoint ->
      Obj.magic (MenhirInterpreter.start 0 initial_position)
  
end
